<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

require_once("include/init.php");
require_once("include/init_ingame.php");
require_once("include/random_names.php");

if ($GAME["empire"]->data["admin"]==0) $GAME["system"]->redirect("manage.php");


//////////////////////////////////////////////////////////////////////////////
// Handle requests
//////////////////////////////////////////////////////////////////////////////
if (isset($_POST["bulletin"]))
{
	$query = "UPDATE tb_bulletin SET content='".addslashes($_POST["bulletin"])."'";
	$DB->Execute($query);

	$GAME["system"]->redirect("admin.php");
}

/* Delete a player */
if (isset($_GET["delete"])) {
	$empire = new Empire($DB,$TPL,$GAME["gameplay_costs"]);
	if (!$empire->load($_GET["delete"])) $GAME["system"]->redirect("admin.php",array("WARNING"=>LANG_INVALID_EMPIRE_ID));
	$empire->delete();
	$GAME["system"]->redirect("admin.php",array("NOTICE"=>LANG_EMPIRE_SUCCESSFULLY_DELETED));
}

/* Add a AI player */
if (isset($_POST["ai_difficulty"])) {
	
	
	
	srand(time(NULL));
	if (rand(0,1) == 1) $emperor_gender = "M"; else $emperor_gender = "F";

	$prefixes = array();
	for ($i=0;$i<count($CONF_RANDOM_NAME_PREFIX);$i++) {
		if ($CONF_RANDOM_NAME_PREFIX[$i][0] == $emperor_gender)	$prefixes[] = $CONF_RANDOM_NAME_PREFIX[$i][1];
	}

	$emperors = array();
	for ($i=0;$i<count($CONF_RANDOM_NAME_EMPEROR);$i++) {
		if ($CONF_RANDOM_NAME_EMPEROR[$i][0] == $emperor_gender)	$emperors[] = $CONF_RANDOM_NAME_EMPEROR[$i][1];
	}

	$empire_first = array();
	for ($i=0;$i<count($CONF_RANDOM_NAME_EMPIRE_FIRST);$i++) {
		$empire_first[] = $CONF_RANDOM_NAME_EMPIRE_FIRST[$i];
	}

	$empire_second = array();
	for ($i=0;$i<count($CONF_RANDOM_NAME_EMPIRE_SECOND);$i++) {
		$empire_second[] = $CONF_RANDOM_NAME_EMPIRE_SECOND[$i];
	}
		
	do {
		$x = -950+rand(0,1900);
		$y = -950+rand(0,1900);
		$rs = $DB->Execute("SELECT * FROM tb_empire WHERE (x>=".($x-50)." AND x<=".($x+50).") AND (y>=".($y-50)." AND y<=".($y+50).")");
	
	} while(!$rs->EOF);

		
	$emperor_name = $prefixes[rand(0,count($prefixes)-1)] . " ". $emperors[rand(0,count($emperors)-1)];	
	$empire_name = $empire_first[rand(0,count($empire_first)-1)] . " ". $empire_second[rand(0,count($empire_second)-1)];	
	$empire_email = md5(rand(0,999999999).time(NULL).rand(0,999999999));
	$empire_password = md5(rand(0,999999999).time(NULL).rand(0,999999999));
	$activation_hash = md5(rand(0,999999999).time(NULL).rand(0,999999999));
	$query = "INSERT INTO tb_empire (
	email,
	emperor,
	name,
	gender,
	logo,
	password,
	biography,
	active,
	admin,
    ai_level,			
	activation_hash,
	date,
	last_turn_date,
	turns_left,
	protection_turns_left,
	credits,
	last_credits,
	population,
	food,x,y) 
	VALUES(
	'".addslashes($empire_email)."',
	'".addslashes($emperor_name)."',
	'".addslashes($empire_name)."',
	'".addslashes($emperor_gender)."',
	'3333455555543333333450000005433333450099220054333450099922200543345099992222054334509999222205433450919922120543345093392332054334509999222205433450099922200543334509111120543333450999222054333345009922005433333450092005433333334500005433333333345555433333',
	'".md5($empire_password)."',
	'".addslashes(LANG_AI_EMPIRE_BIOGRAPHY)."',1,0,".addslashes($_POST["ai_difficulty"]).",
	'".$activation_hash."',
	".time(NULL).",
	".time(NULL).",
	".CONF_TURNS_PER_DAY.",
	".CONF_PROTECTION_TURNS.",
	".CONF_START_CREDITS.",
	".CONF_START_CREDITS.",
	".CONF_START_POPULATION.",
	".CONF_START_FOOD.",$x,$y
	);";
	
	$DB->Execute($query);
	
	
	$query = "SELECT id FROM tb_empire WHERE email = '".addslashes($empire_email)."'";
	$rs = $DB->Execute($query);
	
	$id = $rs->fields["id"];

	$query = "INSERT INTO tb_production (empire) values($id)";
	$DB->Execute($query);

	$query = "INSERT INTO tb_supply (empire, rate_soldier) values($id,100);";
	$DB->Execute($query);

	$query = "INSERT INTO tb_planets (
	empire,
	food_planets,
	ore_planets,
	tourism_planets,
	supply_planets,
	gov_planets,
	edu_planets,
	research_planets,
	urban_planets,
	petro_planets,
	antipollu_planets) 
	VALUES(
	$id,
	".CONF_START_FOOD_PLANETS.",
	".CONF_START_ORE_PLANETS.",
	".CONF_START_TOURISM_PLANETS.",
	".CONF_START_SUPPLY_PLANETS.",
	".CONF_START_GOV_PLANETS.",
	".CONF_START_EDU_PLANETS.",
	".CONF_START_RESEARCH_PLANETS.",
	".CONF_START_URBAN_PLANETS.",
	".CONF_START_PETRO_PLANETS.",
	".CONF_START_ANTIPOLLU_PLANETS."
	);";

	$DB->Execute($query);

	$query = "INSERT INTO tb_army (empire,soldiers,fighters,stations) 
	VALUES($id,".CONF_START_SOLDIERS.",".CONF_START_FIGHTERS.",".CONF_START_STATIONS.");";
	$DB->Execute($query);
	

	$evt = new EventCreator($DB);
	$evt->type = CONF_EVENT_NEWEMPIRE;
	$evt->from = $id;
	$evt->params = array("empire_emperor"=>$emperor_name,"empire_name"=>$empire_name,"gender"=>$emperor_gender);
	$evt->broadcast();
	
	$GAME["system"]->redirect("admin.php",array("NOTICE"=>LANG_NEW_AI_EMPIRE_CREATED));	
}

/* Reset game */
if (isset($_GET["resetgame"]))
{
	
	$GAME["system"]->Reset();
	$GAME["system"]->redirect("admin.php",array("WARNING"=>LANG_GAME_SUCCESSFULLY_RESETTED));
}

//////////////////////////////////////////////////////////////////////////////
// Display page
//////////////////////////////////////////////////////////////////////////////

$GAME["template"]->setPage("admin.html");


$rs = $DB->Execute("SELECT * FROM tb_empire WHERE email <> '' ORDER BY networth DESC");
$loop = array();
$count = 0;
while (!$rs->EOF)
{
	if ($rs->fields["active"] == 2) $rs->fields["name"] = " <b>*collapsed*</b> ".$rs->fields["name"];

	$planets = $DB->Execute("SELECT * FROM tb_planets WHERE empire=".$rs->fields["id"]);
	$planets = $planets->fields;
	$rs->fields["planets_count"] = $planets["food_planets"];
	$rs->fields["planets_count"] += $planets["ore_planets"];
	$rs->fields["planets_count"] += $planets["tourism_planets"];
	$rs->fields["planets_count"] += $planets["supply_planets"];
	$rs->fields["planets_count"] += $planets["gov_planets"];
	$rs->fields["planets_count"] += $planets["edu_planets"];
	$rs->fields["planets_count"] += $planets["research_planets"];
	$rs->fields["planets_count"] += $planets["urban_planets"];
	$rs->fields["planets_count"] += $planets["petro_planets"];
	$rs->fields["planets_count"] += $planets["antipollu_planets"];

	$rs->fields["bgcolor"] =  ($count++ % 2 == 0?"#667777":"#778888");

	$rs->fields["name"] = stripslashes($rs->fields["name"]);
	$rs->fields["emperor"] = stripslashes($rs->fields["emperor"]);

	$rs->fields["planets_count"] = $GAME["template"]->formatNumber($rs->fields["planets_count"]);
	$rs->fields["networth"] = $GAME["template"]->formatNumber($rs->fields["networth"]);
	$rs->fields["rank"] = $count;
	$rs->fields["actions"] = "<a onclick=\"if (!confirm('".LANG_ARE_YOU_SURE."')) return false;\" href=\"?delete=".$rs->fields["id"]."\">Delete</a>";
		
	$loop[] = $rs->fields;
	$rs->MoveNext();
}

$GAME["template"]->setLoop("toplist",$loop);

$rs = $DB->Execute("SELECT COUNT(*) FROM tb_empire WHERE active < 2");
$GAME["template"]->setVar("playerscount",$rs->fields[0]);
$GAME["template"]->setVar("maxplayers",CONF_MAXPLAYERS);
$GAME["template"]->setVar("max_planets_per_turn","Limited by credits");
$GAME["template"]->setVar("food_available",$GAME["template"]->formatFood($GAME["template"]->coord["food"]));

$planets = 0;
$planets += $GAME["template"]->coord["food_planets"];
$planets += $GAME["template"]->coord["ore_planets"];
$planets += $GAME["template"]->coord["tourism_planets"];
$planets += $GAME["template"]->coord["supply_planets"];
$planets += $GAME["template"]->coord["gov_planets"];
$planets += $GAME["template"]->coord["edu_planets"];
$planets += $GAME["template"]->coord["urban_planets"];
$planets += $GAME["template"]->coord["research_planets"];
$planets += $GAME["template"]->coord["petro_planets"];
$planets += $GAME["template"]->coord["antipollu_planets"];
$GAME["template"]->setVar("planets_available",$GAME["template"]->formatNumber($planets));

$rs = $DB->Execute("SELECT * FROM tb_bulletin");

$GAME["template"]->setVar("bulletin_noformat",stripslashes($rs->fields["content"]));
print $GAME["template"]->render();

?>
