<?php


//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//
require_once ("include/init.php");
require_once ("include/init_ingame.php");

if (isset ($_GET["retreat"])) {

	$id = addslashes($_GET["retreat"]);
	$rs = $DB->Execute("SELECT * FROM tb_armyconvoy WHERE empire_from=" . $GAME["empire"]->data["id"] . " AND (convoy_type=" . CONF_CONVOY_INVASION . " OR convoy_type=" . CONF_CONVOY_DEFENSE . ") AND id=" . $id);
	if (!$rs->EOF) {

		$time_left = ($rs->fields["time_total"] - $rs->fields["time_left"]) + 5;
		$convoy_type = CONF_CONVOY_INVASION_RETREAT;
		if ($rs->fields["convoy_type"] == CONF_CONVOY_DEFENSE)
			$convoy_type = CONF_CONVOY_DEFENSE_RETREAT;

		$query = "UPDATE tb_armyconvoy SET convoy_type=$convoy_type,time_left=$time_left WHERE id=" . $id;
		$DB->Execute($query);

		$p = (($rs->fields["time_left"] / $rs->fields["time_total"]) * 100);

		if ($p < 90) {
			$GAME["empire"]->army->data["effectiveness"] -= 5;
			if ($GAME["empire"]->army->data["effectiveness"] < 5)
				$GAME["empire"]->army->data["effectiveness"] = 5;
		}

		$GAME["empire"]->save();

		$evt = new EventCreator($DB);
		$evt->from = -1;
		$evt->to = $rs->fields["empire_to"];
		$evt->type = CONF_EVENT_CONVOY_RETREAT;
		$evt->params = $rs->fields["empire_from"];
		$evt->send();
	}

	$GAME["system"]->redirect("battle.php");
	die();
}

////////////////////////////////////////////////////////////////////////////////////
// Display page
////////////////////////////////////////////////////////////////////////////////////
$GAME["template"]->setPage("battle.html");

/* Invasion soldiers */
$invasion_soldiers = $GAME["empire"]->army->data["soldiers"];
$carriers_needed = ceil($GAME["empire"]->army->data["soldiers"] * CONF_CARRIER_SOLDIER);
if (($carriers_needed) > $GAME["empire"]->army->data["carriers"]) {
	$percent = ($GAME["empire"]->army->data["carriers"] / $carriers_needed) * 100;
	$invasion_soldiers = floor(($invasion_soldiers / 100) * $percent);
}

if ($invasion_soldiers > ($GAME["empire"]->army->data["generals"] * 50)) {
	$invasion_soldiers = floor($GAME["empire"]->army->data["generals"] * 50);
}
$GAME["template"]->setVar("invasion_soldiers", $GAME["template"]->formatNumber($invasion_soldiers));
$GAME["template"]->setVar("invasion_soldiers_noformat", $invasion_soldiers);

/* Invasion fighters */
$invasion_fighters = $GAME["empire"]->army->data["fighters"];
$carriers_needed = ceil($GAME["empire"]->army->data["fighters"] * CONF_CARRIER_FIGHTER);

if (($carriers_needed) > $GAME["empire"]->army->data["carriers"]) {
	$percent = ($GAME["empire"]->army->data["carriers"] / $carriers_needed) * 100;
	$invasion_fighters = floor(($invasion_fighters / 100) * $percent);
}

$GAME["template"]->setVar("invasion_fighters", $GAME["template"]->formatNumber($invasion_fighters));
$GAME["template"]->setVar("invasion_fighters_noformat", $invasion_fighters);

/*Invasion  lightcruisers */
$invasion_lightcruisers = $GAME["empire"]->army->data["lightcruisers"];
$GAME["template"]->setVar("invasion_lightcruisers", $GAME["template"]->formatNumber($invasion_lightcruisers));
$GAME["template"]->setVar("invasion_lightcruisers_noformat", $invasion_lightcruisers);

/* Invasion heavycruisers */
$invasion_heavycruisers = $GAME["empire"]->army->data["heavycruisers"];
$GAME["template"]->setVar("invasion_heavycruisers", $GAME["template"]->formatNumber($invasion_heavycruisers));
$GAME["template"]->setVar("invasion_heavycruisers_noformat", $invasion_heavycruisers);

/* Guerilla Soldiers */
$guerilla_soldiers = $GAME["empire"]->army->data["soldiers"];
$GAME["template"]->setVar("guerilla_soldiers", $GAME["template"]->formatNumber($guerilla_soldiers));
$GAME["template"]->setVar("guerilla_soldiers_noformat", $guerilla_soldiers);

////////////////////////////////////////////////////////////////
// Populate empires
////////////////////////////////////////////////////////////////
$empires = array ();
$rs = $DB->Execute("SELECT * FROM tb_empire WHERE  admin=0 AND active=1 AND protection_turns_left = 0 ORDER BY emperor ASC");
while (!$rs->EOF) {
	if ($rs->fields["id"] != $GAME["empire"]->data["id"]) {

		if ($GAME["empire"]->coalition->isMember()) {

			if ($GAME["empire"]->coalition->isMemberFromId($rs->fields["id"])) {
				$rs->MoveNext();
				continue;
			}

		}

		if ($GAME["empire"]->diplomacy->treatyFrom($rs->fields["id"]) == null) {
			$empire = array ();
			$empire["id"] = $rs->fields["id"];
			$empire["name"] = $GAME["template"]->displayEmpire($rs->fields["emperor"], $rs->fields["name"], $GAME["empire"]->data["networth"]);

			$rs2 = $DB->Execute("SELECT tb_coalition.name FROM tb_member,tb_coalition WHERE tb_member.empire=" . $rs->fields["id"] . " AND tb_member.coalition = tb_coalition.id");
			if (!$rs2->EOF)
				$empire["name"] .= " [" . $rs2->fields["name"] . "]";

			$empires[] = $empire;
		}

	}

	$rs->MoveNext();
}

$GAME["template"]->setLoop("empires", $empires);

/* Populate pirates */
$pirates = array ();
$rs = $DB->Execute("SELECT * FROM tb_pirate ORDER BY name ASC");
while (!$rs->EOF) {
	$pirate = array ();
	$pirate["id"] = $rs->fields["id"];
	$pirate["name"] = $rs->fields["name"] . " (Nwt: " . $GAME["template"]->formatNumber($rs->fields["networth"]) . ")";
	$pirates[] = $pirate;

	$rs->MoveNext();
}

$GAME["template"]->setLoop("pirates", $pirates);

if ($GAME["empire"]->data["have_nukes"] == 1)
	$GAME["template"]->TPL->set_var("block_nuclear_warfare", $GAME["template"]->TPL->process("", "nuclear_warfare", 2));
else
	$GAME["template"]->TPL->set_var("block_nuclear_warfare", "");

// Display army convoys
$rs = $DB->Execute("SELECT * FROM tb_armyconvoy WHERE empire_from=" . $GAME["empire"]->data["id"] . " OR empire_to=" . $GAME["empire"]->data["id"] . " ORDER BY id ASC");
$convoys = array ();

while (!$rs->EOF) {
	$convoy = array ();

	$empire_from = $DB->Execute("SELECT emperor,name FROM tb_empire WHERE id=" . $rs->fields["empire_from"]);
	$empire_to = $DB->Execute("SELECT emperor,name FROM tb_empire WHERE id=" . $rs->fields["empire_to"]);

	$convoy["id"] = $rs->fields["id"];

	$convoy["convoy_type"] = LANG_INVASION_CONVOY;
	if (($rs->fields["convoy_type"] == CONF_CONVOY_DEFENSE) || ($rs->fields["convoy_type"] == CONF_CONVOY_DEFENSE_RETREAT))
		$convoy["convoy_type"] = LANG_DEFENSE_CONVOY;

	$convoy["from_empire"] = $empire_from->fields["emperor"] . "@" . $empire_from->fields["name"];
	$convoy["target_empire"] = $empire_to->fields["emperor"] . "@" . $empire_to->fields["name"];
	if (($rs->fields["convoy_type"] == CONF_CONVOY_INVASION_RETREAT) || ($rs->fields["convoy_type"] == CONF_CONVOY_DEFENSE_RETREAT)) {
		$convoy["retreat"] = "";
		$convoy["convoy_type"] .= " *" . LANG_RETREAT . "*";
	} else {

		if ($rs->fields["empire_from"] == $GAME["empire"]->data["id"])
			$convoy["retreat"] = LANG_RETREAT;
		else
			$convoy["retreat"] = "";


	}

	if ($rs->fields["convoy_type"] == CONF_CONVOY_INVASION)	$convoy["background"] = "convoy_invasion.jpg";
	if ($rs->fields["convoy_type"] == CONF_CONVOY_DEFENSE)	$convoy["background"] = "convoy_defense.jpg";
	if ($rs->fields["convoy_type"] == CONF_CONVOY_INVASION_RETREAT)	$convoy["background"] = "convoy_retreat.jpg";
	if ($rs->fields["convoy_type"] == CONF_CONVOY_DEFENSE_RETREAT)	$convoy["background"] = "convoy_retreat.jpg";

	$convoy["soldiers"] = $GAME["template"]->formatNumber($rs->fields["convoy_soldiers"]);
	$convoy["fighters"] = $GAME["template"]->formatNumber($rs->fields["convoy_fighters"]);
	$convoy["lightcruisers"] = $GAME["template"]->formatNumber($rs->fields["convoy_lightcruisers"]);
	$convoy["heavycruisers"] = $GAME["template"]->formatNumber($rs->fields["convoy_heavycruisers"]);
	$convoy["carriers"] = $GAME["template"]->formatNumber($rs->fields["carriers"]);
	$convoy["time_left"] = $GAME["template"]->formatTime($rs->fields["time_left"]);

	$convoys[] = $convoy;
	$rs->MoveNext();
}

$GAME["template"]->setLoop("convoys", $convoys);

print $GAME["template"]->render();
?>
