<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

require_once ("include/init.php");
require_once ("include/init_ingame.php");

if ($GAME["empire"]->data["protection_turns_left"] != 0) {
	$GAME["system"]->redirect("battle.php",array("" .
			"WARNING"=>LANG_NO_ATTACK_UNTIL_OUT_OF_PROTECTION
	));
}

if ($GAME["empire"]->data["already_attacked"] != 0) {
	$GAME["system"]->redirect("battle.php", array (
		"WARNING" => LANG_SORRY_ONLY_ONE_ATTACK_PER_TURN
	));
}


////////////////////////////////////////////////////////////////
// GUERILLA ATTACK
////////////////////////////////////////////////////////////////
if (isset($_POST["guerilla_empire"]))
{

	

	$empire = $_POST["guerilla_empire"];
	$soldiers = floor($_POST["guerilla_soldiers"]);

	$rs = $DB->Execute("SELECT * FROM tb_empire WHERE  admin=0 AND protection_turns_left=0 AND id=".addslashes($empire));
	if ($rs->EOF) {
		$GAME["system"]->redirect("battle.php",array("WARNING"=>LANG_INVALID_EMPIRE_ID));
	}
	
	$rs2 = $DB->Execute("SELECT * FROM tb_army WHERE empire=".addslashes($empire));
	$rs3 = $DB->Execute("SELECT * FROM tb_production WHERE empire=".addslashes($empire));
	
	if ($soldiers > $GAME["empire"]->army->data["soldiers"]) {
		$GAME["system"]->redirect("battle.php",array("WARNING"=>LANG_INVALID_SOLDIERS_QUANTITY));
	}
		
	if ($GAME["empire"]->diplomacy->treatyFrom($rs->fields["id"]) != null) {
		$GAME["system"]->redirect("battle.php",array("WARNING"=>LANG_CANT_ATTACK_EMPIRE_WITH_DIPLOMATIC_TIES));
	} 

	if ($GAME["empire"]->coalition->isMemberFromId($rs->fields["id"])) {		
		$GAME["system"]->redirect("battle.php",array("WARNING"=>LANG_YOU_CANT_ATTACK_COALITION_MEMBER));
	}
	
	$enemy_soldiers = $rs2->fields["soldiers"];
	$result = "";
	$lost = 0;
	$total_lost = 0;
	$my_lost = 0;

	for ($i=0;$i<CONF_GUERILLA_ATTACK_ROUNDS;$i++)
	{
		$result .= "<b style=\"color:yellow\">Round #".($i+1)."</b><br/>\r\n";
		$result .= LANG_ATTACKING_WITH.$GAME["template"]->formatNumber($soldiers)." ".LANG_SOLDIERS." ... ";
		
		$attack_strength = $soldiers * $GAME["empire"]->army->data["effectiveness"];
		$defense_strength = $enemy_soldiers * CONF_GUERILLA_SOLDIER_DEFENSE * $rs2->fields["effectiveness"];
		if ($attack_strength == 0) $attack_strength = 1;
		if ($defense_strength == 0) $defense_strength = 1;
		$attack_strength *= $units_info["soldiers_".$GAME["empire"]->army->data["soldiers_level"]]["guerilla"];
		$defense_strength *= $units_info["soldiers_".$rs2->fields["soldiers_level"]]["guerilla"];

		$attack = "";
		$p_attack = floor(($attack_strength / $defense_strength)*100);
		
		$p_attack = floor($p_attack/20);
		if ($p_attack > 40) $p_attack = 40;
		if ($p_attack <= 0) $p_attack = 1;

		for ($j=0;$j<$p_attack;$j++) $attack .= "<img style=\"border:1px solid darkred\" width=\"16\" height=\"16\" src=\"images/icons/army/soldiers_".$GAME["empire"]->army->data["soldiers_level"].".gif\" border=\"0\"> ";

		$defense = "";
		$p_defense = floor(($defense_strength / $attack_strength)*100);
		
		$p_defense = floor($p_defense/20);
		if ($p_defense <= 0) $p_defense = 1;
		if ($p_defense > 40) $p_defense = 40;

		for ($j=0;$j<$p_defense;$j++) $defense .= "<img style=\"border:1px solid darkblue\"  width=\"16\" height=\"16\" src=\"images/icons/army/soldiers_".$rs2->fields["soldiers_level"].".gif\" border=\"0\"> ";

		$graphic = "<table bgcolor=\"white\" cellpadding=\"5\" align=\"center\" width=\"700\">\r\n";
		$graphic .= "<tr><td bgcolor=\"#330000\" width=\"50%\">$attack</td><td bgcolor=\"#000033\" width=\"50%\">$defense</td></tr>\r\n";
		$graphic .= "</table><br/>\r\n";
		$p = $defense_strength -$attack_strength;
		if ($p > 0)
		{
			$result .= "<b style=\"color:#FF9999\">".LANG_BATTLE_LOST." ";	
			$lost++;
			
			$lost_soldiers = round(($soldiers / 100)*CONF_GUERILLA_SOLDIER_LOST);
			$soldiers -= $lost_soldiers;
			$enemy_soldiers -= (($lost_soldiers / CONF_GUERILLA_SOLDIER_DEFENSE));
			
			$result .= " (".LANG_YOUR_CASUALTIES.": ".$GAME["template"]->formatNumber($lost_soldiers).", ".LANG_ENEMY_CASUALTIES.": ".$GAME["template"]->formatNumber(($lost_soldiers / CONF_GUERILLA_SOLDIER_DEFENSE)).")</b>";
			
			$total_lost += ($lost_soldiers / CONF_GUERILLA_SOLDIER_DEFENSE);
			$my_lost += $lost_soldiers;

		} else {
			$result .= "<b style=\"color:#99FF99\">".LANG_BATTLE_WON." ";	

			$lost_soldiers = round(($enemy_soldiers / 100)*CONF_GUERILLA_SOLDIER_LOST);
			$soldiers -= ($lost_soldiers/2);
			$enemy_soldiers -= ($lost_soldiers);
			
			$result .= " (".LANG_YOUR_CASUALTIES.": ".$GAME["template"]->formatNumber($lost_soldiers/2).", ".LANG_ENEMY_CASUALTIES.": ".$GAME["template"]->formatNumber($lost_soldiers).")</b>";
			
			$total_lost += $lost_soldiers;	
			$my_lost += ($lost_soldiers/2);

		}
		
		$result .= "$graphic\r\n";

		if ($soldiers == 0) break;
		if ($enemy_soldiers == 0) break;
	}

	if ($lost >= 1)
	{
		$result .= YOU_HAVE_WEAKENED_THE_ENEMY_BUT_YOU_HAVE_REVEALED_YOUR_IDENTITY."<br/>";

		$evt = new EventCreator($DB);
		$evt->type = CONF_EVENT_GUERILLA_REVEALED;
		$evt->from = $GAME["empire"]->data["id"];
		$evt->to = $rs->fields["id"];
		$evt->params = array("empire_id"=>$GAME["empire"]->data["id"],"empire_name"=>$GAME["empire"]->data["name"],"empire_emperor"=>$GAME["empire"]->data["emperor"],"gender"=>$GAME["empire"]->data["gender"],"lost_soldiers"=>$lost_soldiers);
		$evt->send();
				
		
		$empire_from = $GAME["template"]->displayEmpireHTML($GAME["empire"]->data["id"],$GAME["empire"]->data["emperor"],$GAME["empire"]->data["name"],$GAME["empire"]->data["networth"]);
		$empire_to = $GAME["template"]->displayEmpireHTML($rs->fields["id"],$rs->fields["emperor"],$rs->fields["name"],$rs->fields["networth"]);
		$won = false;
		$type = "guerilla";
		
		$evt->type = CONF_EVENT_EMPIREATTACKED;
		$evt->from = $GAME["empire"]->data["id"];
		$evt->to = $rs->fields["id"];
		$evt->params = array("empire_from"=>$empire_from,"empire_to"=>$empire_to,"type"=>$type,"won"=>$won);
		$evt->broadcast();
		
		
	} else {
		$result .= YOU_HAVE_WEAKENED_THE_ENEMY_WITHOUT_REVEALING_YOUR_IDENTITY."<br/>";
		
		$evt = new EventCreator($DB);
		$evt->type = CONF_EVENT_GUERILLA_STEALTH;
		$evt->from = $GAME["empire"]->data["id"];
		$evt->to = $rs->fields["id"];
		$evt->params = array("empire_id"=>$GAME["empire"]->data["id"],"empire_name"=>$GAME["empire"]->data["name"],"empire_emperor"=>$GAME["empire"]->data["emperor"],"gender"=>$GAME["empire"]->data["gender"],"lost_soldiers"=>$lost_soldiers);
		$evt->send();
				

		$r = rand(0,2);
		if ($r == 0)
		{
			$result .= "<b style=\"color:yellow\">".LANG_RIOTS_BREAKOUT."</b><br/>";

			$civil_status = $rs->fields["civil_status"];
			$civil_status++;
			if ($civil_status > (count($CONF_CIVIL_STATUS)-1))
				$civil_status = count($CONF_CIVIL_STATUS)-1;

			$population = $rs->fields["population"];
			$population -= floor(($population/100)*rand(0,20));
			$rs2->fields["effectiveness"] -= 5;
			if ($rs2->fields["effectiveness"] < 0) $rs2->fields["effectiveness"] = 0;
			
			$DB->Execute("UPDATE tb_empire SET civil_status=$civil_status,population=$population WHERE id=".$rs->fields["id"]);

		}
		
	}

	$tourism = $rs3->fields["tourism_short"] - 5;
	if ($tourism < 0) $tourism = 1;
	
	$DB->Execute("UPDATE tb_production SET tourism_short=".$tourism." WHERE empire=".$rs->fields["id"]);
	

	$GAME["empire"]->army->data["soldiers"] -= $my_lost; 
	$DB->Execute("UPDATE tb_army SET effectiveness=".$rs2->fields["effectiveness"].",soldiers=".floor($rs2->fields["soldiers"]-$total_lost)." WHERE empire=".$rs->fields["id"]);
	

	$GAME["empire"]->data["already_attacked"] = 1;
	$GAME["empire"]->save();
	

	
	$evt = new EventCreator($DB);
	$evt->type = CONF_EVENT_NOTICE;
	$evt->from = -1;
	$evt->height = 500;
	$evt->to = $GAME["empire"]->data["id"];
	$evt->params = array("notice_data"=>$result);
	$evt->send();
}





////////////////////////////////////////////////////////////////
// MAIN
////////////////////////////////////////////////////////////////

$GAME["system"]->redirect("manage.php");

?>
