<?php


//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

require_once ("include/init.php");
require_once ("include/init_ingame.php");

if ($GAME["empire"]->data["protection_turns_left"] != 0) {
	$GAME["system"]->redirect("battle.php",array("" .
			"WARNING"=>LANG_NO_ATTACK_UNTIL_OUT_OF_PROTECTION
	));
}

if ($GAME["empire"]->data["already_attacked"] != 0) {
	$GAME["system"]->redirect("battle.php", array (
		"WARNING" => LANG_SORRY_ONLY_ONE_ATTACK_PER_TURN
	));
}

if (isset($_POST["invasion_empire"])) {


	$DB->StartTrans();
	
	// we send invasion convoy
	$empire = $_POST["invasion_empire"];

	$soldiers = floor($_POST["invasion_soldiers"]);
	if ($soldiers > $GAME["empire"]->army->data["soldiers"]) $GAME["system"]->redirect("battle.php",array("WARNING"=>LANG_INVALID_QTY));

	$fighters = floor($_POST["invasion_fighters"]);
	if ($fighters > $GAME["empire"]->army->data["fighters"]) $GAME["system"]->redirect("battle.php",array("WARNING"=>LANG_INVALID_QTY));

	$lightcruisers = floor($_POST["invasion_lightcruisers"]);
	if ($lightcruisers > $GAME["empire"]->army->data["lightcruisers"]) $GAME["system"]->redirect("battle.php",array("WARNING"=>LANG_INVALID_QTY));

	$heavycruisers = floor($_POST["invasion_heavycruisers"]);
	if ($heavycruisers > $GAME["empire"]->army->data["heavycruisers"]) $GAME["system"]->redirect("battle.php",array("WARNING"=>LANG_INVALID_QTY));
	
	$generals_needed = ceil($soldiers / 50);
	if ($generals_needed > $GAME["empire"]->army->data["generals"]) {
		$generals = $GAME["empire"]->army->data["generals"];
		$soldiers = $generals * 50;
	} else $generals = $generals_needed;

	$total = $soldiers + $fighters + $lightcruisers + $heavycruisers;
	if ($total == 0) {
		$GAME["system"]->redirect("battle.php",array("WARNING"=>LANG_INVALID_QTY));
	}


	// verify if target is correct
	$rs = $DB->Execute("SELECT * FROM tb_empire WHERE admin=0 AND protection_turns_left=0 AND id=".addslashes($empire));
	if ($rs->EOF) {
		$GAME["system"]->redirect("battle.php",array("WARNING"=>LANG_INVALID_EMPIRE_ID));
	}

	if ($GAME["empire"]->diplomacy->treatyFrom(addslashes($empire)) != null) {
		$GAME["system"]->redirect("battle.php",array("WARNING"=>LANG_CANT_ATTACK_EMPIRE_WITH_DIPLOMATIC_TIES));
	} 

	if ($GAME["empire"]->coalition->isMemberFromId(addslashes($empire))) {		
		$GAME["system"]->redirect("battle.php",array("WARNING"=>LANG_YOU_CANT_ATTACK_COALITION_MEMBER));
	}
	

	// checking needed carriers
	$carriers_needed = 0;
	$carriers_needed += (CONF_CARRIER_SOLDIER * $units_info["carriers_" .$GAME["empire"]->army->data["carriers_level"]]["cargo_hold"] * $soldiers);
	$carriers_needed += (CONF_CARRIER_GENERAL * $units_info["carriers_" .$GAME["empire"]->army->data["carriers_level"]]["cargo_hold"] * $generals);
	$carriers_needed += (CONF_CARRIER_FIGHTER * $units_info["carriers_" .$GAME["empire"]->army->data["carriers_level"]]["cargo_hold"] * $fighters);
	$carriers_needed += (CONF_CARRIER_LIGHTCRUISER * $units_info["carriers_" .$GAME["empire"]->army->data["carriers_level"]]["cargo_hold"] * $lightcruisers);
	$carriers_needed += (CONF_CARRIER_HEAVYCRUISER * $units_info["carriers_" .$GAME["empire"]->army->data["carriers_level"]]["cargo_hold"] * $heavycruisers);
	$carriers_needed = ceil($carriers_needed);

	if ($carriers_needed > $GAME["empire"]->army->data["carriers"]) {
		$GAME["system"]->redirect("battle.php",array("WARNING"=>LANG_NOT_ENOUGH_CARRIERS));
	}

	// wildraw from resources
	$GAME["empire"]->army->data["soldiers"] -= $soldiers;
	$GAME["empire"]->army->data["generals"] -= $generals;
	$GAME["empire"]->army->data["fighters"] -= $fighters;
	$GAME["empire"]->army->data["lightcruisers"] -= $lightcruisers;
	$GAME["empire"]->army->data["heavycruisers"] -= $heavycruisers;
	$GAME["empire"]->army->data["carriers"] -= $carriers_needed;
	$GAME["empire"]->save();
	

	$x = abs($GAME["empire"]->data["x"] - $rs->fields["x"]);
	$y = abs($GAME["empire"]->data["y"] - $rs->fields["y"]);

	// calculating time needed
	$time_required = floor(sqrt(($x * $x) + ($y * $y)));
	$time_required = floor($time_required / $units_info["carriers_" . $GAME["empire"]->army->data["carriers_level"]]["speed"]);
	$time_required *= 10;
	$time_required -= ($time_required % 60);

	// creating convoy
	$query = "
	INSERT INTO tb_armyconvoy
	(
	convoy_type,
	convoy_target,
	empire_from,
	empire_to,
	convoy_generals,
	convoy_soldiers,
	convoy_soldiers_level,
	convoy_fighters,
	convoy_fighters_level,
	convoy_lightcruisers,
	convoy_lightcruisers_level,
	convoy_heavycruisers,
	convoy_heavycruisers_level,
	carriers,
	carriers_level,
	time_left,
	time_total)
	VALUES(
	".CONF_CONVOY_INVASION.",
	-1,
	".$GAME["empire"]->data["id"].",
	".addslashes($empire).",
	$generals,
	$soldiers,
	".$GAME["empire"]->army->data["soldiers_level"].",
	$fighters,
	".$GAME["empire"]->army->data["fighters_level"].",
	$lightcruisers,
	".$GAME["empire"]->army->data["lightcruisers_level"].",
	$heavycruisers,
	".$GAME["empire"]->army->data["heavycruisers_level"].",
	$carriers_needed,
	".$GAME["empire"]->army->data["carriers_level"].",
	$time_required,
	$time_required
	)";
	$DB->Execute($query);
	$convoy_id = $DB->Execute("SELECT id FROM tb_armyconvoy ORDER BY id DESC LIMIT 1");
	$convoy_id = $convoy_id->fields["id"];

	// send a event to target
	$evt = new EventCreator($DB);
	$evt->from = $GAME["empire"]->data["id"];
	$evt->type = CONF_EVENT_INCOMING_INVASION;
	$evt->to = addslashes($empire);
	$evt->params = array("soldiers"=>$soldiers,"fighters"=>$fighters,"generals"=>$generals,"lightcruisers"=>$lightcruisers,"heavycruisers"=>$heavycruisers);
	$evt->send();
	
	////////////////////////////////////////////////////////////////////////
	// Time to check if the target have friends :)
	////////////////////////////////////////////////////////////////////////
	$target_empire = new Empire($DB,$GAME["template"],$GAME["gameplay_costs"]);
	$target_empire->Load(addslashes($empire));

  // compare networths
  $networth1 = $GAME["empire"]->data["networth"];
  $networth2 = $target_empire->data["networth"];
  $percent = (($networth1 / $networth2) * 100);
	if ($percent <= 33) {
		$GAME["empire"]->data["civil_status"]++;
		if ($GAME["empire"]->data["civil_status"]> 7) $GAME["empire"]->data["civil_status"] = 7;
		$GAME["empire"]->save();
	
	}
		
	for ($i=0;$i<count($target_empire->diplomacy->data);$i++) {
 	
 		if ($target_empire->diplomacy->data[$i]["status"] != 1) continue;
		
		$percent = 0;
		if ($target_empire->diplomacy->data[$i]["type"] == 1) $percent = 10; 
		if ($target_empire->diplomacy->data[$i]["type"] == 2) $percent = 30; 

		// we first check if the distance is shorter
		$empire = $target_empire->diplomacy->data[$i]["empire_from"];
		if ($empire == $target_empire->data["id"]) $empire = $target_empire->diplomacy->data[$i]["empire_to"];
		if ($empire == $target_empire->data["id"]) continue;
		
		$ally_empire = new Empire($DB,$GAME["template"],$GAME["gameplay_costs"]);
		$ally_empire->Load($empire);
		
		$x = abs($target_empire->data["x"] - $ally_empire->data["x"]);
		$y = abs($target_empire->data["y"] - $ally_empire->data["y"]);

		// calculating time needed
		$time_required2 = floor(sqrt(($x * $x) + ($y * $y)));
		$time_required2 = floor($time_required2 / $units_info["carriers_" .$ally_empire->army->data["carriers_level"]]["speed"]);
		$time_required2 *= 10;
		$time_required2 -= ($time_required2 % 60);
		
		if ($time_required2 > $time_required) continue; // to bad
		
		// now we need to scale the numbers
		$defense_soldiers = floor(($ally_empire->army->data["soldiers"]/100)*$percent);
		$defense_generals = ceil($defense_soldiers / 50);
		if ($defense_generals > $ally_empire->army->data["generals"]) {
			$defense_soldiers = $defense_generals * 50;
		}

		$defense_fighters = floor(($ally_empire->army->data["fighters"]/100)*$percent);
		$defense_lightcruisers = floor(($ally_empire->army->data["lightcruisers"]/100)*$percent);
		$defense_heavycruisers = floor(($ally_empire->army->data["heavycruisers"]/100)*$percent);

		if ($defense_soldiers > $soldiers) $defense_soldiers = $soldiers;
		if ($defense_fighters > $fighters) $defense_fighters = $fighters;
		if ($defense_lightcruisers > $lightcruisers) $defense_lightcruisers = $lightcruisers;
		if ($defense_heavycruisers > $heavycruisers) $defense_heavycruisers = $heavycruisers;

		// checking needed carriers
		$carriers_needed = 0;
		$carriers_needed += (CONF_CARRIER_SOLDIER * $units_info["carriers_" .$ally_empire->army->data["carriers_level"]]["cargo_hold"] *  $defense_soldiers);
		$carriers_needed += (CONF_CARRIER_GENERAL * $units_info["carriers_" .$ally_empire->army->data["carriers_level"]]["cargo_hold"] * $defense_generals);
		$carriers_needed += (CONF_CARRIER_FIGHTER * $units_info["carriers_" .$ally_empire->army->data["carriers_level"]]["cargo_hold"] * $defense_fighters);
		$carriers_needed += (CONF_CARRIER_LIGHTCRUISER * $units_info["carriers_" .$ally_empire->army->data["carriers_level"]]["cargo_hold"] * $defense_lightcruisers);
		$carriers_needed += (CONF_CARRIER_HEAVYCRUISER * $units_info["carriers_" .$ally_empire->army->data["carriers_level"]]["cargo_hold"] * $defense_heavycruisers);
		$carriers_needed = ceil($carriers_needed);

		$ally_empire->army->data["soldiers"] -= $defense_soldiers;
		$ally_empire->army->data["fighters"] -= $defense_fighters;
		$ally_empire->army->data["lightcruisers"] -= $defense_lightcruisers;
		$ally_empire->army->data["heavycruisers"] -= $defense_heavycruisers;
		$ally_empire->Save();

		// no enough carriers
		if ($carriers_needed > $ally_empire->army->data["carriers"]) continue;

		// creating convoy
		$query = "
		INSERT INTO tb_armyconvoy
		(
		convoy_type,
		convoy_target,
		empire_from,
		empire_to,
		convoy_generals,
		convoy_soldiers,
		convoy_soldiers_level,
		convoy_fighters,
		convoy_fighters_level,
		convoy_lightcruisers,
		convoy_lightcruisers_level,
		convoy_heavycruisers,
		convoy_heavycruisers_level,
		carriers,
		time_left,
		time_total)
		VALUES(
		".CONF_CONVOY_DEFENSE.",
		".$convoy_id.",
		".$ally_empire->data["id"].",
		".$target_empire->data["id"].",
		$defense_generals,
		$defense_soldiers,
		".$ally_empire->army->data["soldiers_level"].",
		$defense_fighters,
		".$ally_empire->army->data["fighters_level"].",
		$defense_lightcruisers,
		".$ally_empire->army->data["lightcruisers_level"].",
		$defense_heavycruisers,
		".$ally_empire->army->data["heavycruisers_level"].",
		$carriers_needed,
		$time_required2,
		$time_required2
		)";
		
		$DB->Execute($query);
		// send a event to target
		$evt = new EventCreator($DB);
		$evt->from = $ally_empire->data["id"];
		$evt->type = CONF_EVENT_INCOMING_DEFENSE;
		$evt->to = $target_empire->data["id"];
		$evt->params = array("soldiers"=>$soldiers,"fighters"=>$fighters,"generals"=>$generals,"lightcruisers"=>$lightcruisers,"heavycruisers"=>$heavycruisers);
		$evt->send();
	
		// send a event to ally
		$evt = new EventCreator($DB);
		$evt->from = $target_empire->data["id"];
		$evt->type = CONF_EVENT_SENDING_DEFENSE;
		$evt->to = $ally_empire->data["id"];
		$evt->params = array("soldiers"=>$soldiers,"fighters"=>$fighters,"generals"=>$generals,"lightcruisers"=>$lightcruisers,"heavycruisers"=>$heavycruisers);
		$evt->send();

	}

	$DB->CompleteTrans();
	$GAME["system"]->redirect("battle.php",array("NOTICE"=>LANG_INVASION_CONVOY_SENT));
}



////////////////////////////////////////////////////////////////
// MAIN
////////////////////////////////////////////////////////////////

$GAME["system"]->redirect("manager.php");


?>