<?php


//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.e
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

require_once ("include/init.php");
require_once ("include/init_ingame.php");

if ($GAME["empire"]->data["already_attacked"] != 0) {
	$GAME["system"]->redirect("battle.php", array (
		"WARNING" => LANG_SORRY_ONLY_ONE_ATTACK_PER_TURN
	));
}

////////////////////////////////////////////////////////////////
// GUERILLA ATTACK
////////////////////////////////////////////////////////////////
if (isset ($_POST["battle_pirate"])) {

	$pirate = $DB->Execute("SELECT * FROM tb_pirate WHERE id=" . addslashes($_POST["battle_pirate"]));
	if ($pirate->EOF)
		$GAME["system"]->redirect("battle.php", array (
			"WARNING" => LANG_INVALID_PIRATE_ID
		));

	
	$pirate = $pirate->fields;

	$soldiers = $_POST["pirate_soldiers"];
	$fighters = $_POST["pirate_fighters"];
	$lightcruisers = $_POST["pirate_lightcruisers"];
	$heavycruisers = $_POST["pirate_heavycruisers"];
	$generals = ceil($soldiers / 50);
	if ($generals > $GAME["empire"]->army->data["generals"]) {
		$soldiers = $GAME["empire"]->army->data["generals"] * 50;
		$generals = $GAME["empire"]->army->data["generals"];
	}

	if ($soldiers > $GAME["empire"]->army->data["soldiers"])
		$GAME["system"]->redirect("battle.php", array (
			"WARNING" => LANG_INVALID_SOLDIERS_QUANTITY
		));

	if ($fighters > $GAME["empire"]->army->data["fighters"])
		$GAME["system"]->redirect("battle.php", array (
			"WARNING" => LANG_INVALID_FIGHTERS_QUANTITY
		));

	if ($lightcruisers > $GAME["empire"]->army->data["lightcruisers"])
		$GAME["system"]->redirect("battle.php", array (
			"WARNING" => LANG_INVALID_LIGHTCRUISERS_QUANTITY
		));

	if ($heavycruisers > $GAME["empire"]->army->data["heavycruisers"])
		$GAME["system"]->redirect("battle.php", array (
			"WARNING" => LANG_INVALID_HEAVYCRUISERS_QUANTITY
		));



	$result = "";
	$lost_generals = 0;

	$r = rand(0, 6);

	if ($r == 1) {
		$result .= "<br/><b style=\"color:yellow\">*** " . LANG_PIRATE_GANG_FLED . " ***</b><br</br>\r\n";
		$evt = new EventCreator($DB);
		$evt->type = CONF_EVENT_PIRATEBUST;
		$evt->from = -1;
		$evt->to = $GAME["empire"]->data["id"];
		$evt->params = array (
			"result" => $result,
			"pirate_name" => $pirate["name"]
		);
		$evt->send();
		$GAME["empire"]->data["already_attacked"] = 1;
		$GAME["empire"]->save();

	} else {

		$result .= "<b>".LANG_ATTACKING_WITH."</b><b style=\"color:#99FFFF\">" . 
		$GAME["template"]->formatNumber($soldiers) . "</b><b> ".LANG_SOLDIERS.", </b><b style=\"color:#99FFFF\">" . 
		$GAME["template"]->formatNumber($generals) . "</b><b> ".LANG_GENERALS.", </b><b style=\"color:#99FFFF\">" . 
		$GAME["template"]->formatNumber($fighters) . "</b><b> ".LANG_FIGHTERS.
		", </b><b style=\"color:#99FFFF\">" . $GAME["template"]->formatNumber($lightcruisers) .
		 "</b><b> ".LANG_LIGHTCRUISERS.", </b><b style=\"color:#99FFFF\">" . 
		 $GAME["template"]->formatNumber($heavycruisers) . "</b><b> ".LANG_HEAVYCRUISERS."</b><br/><br/>\r\n";

		$attack_strength = floor(((
		($soldiers*$units_info["soldiers_".$GAME["empire"]->army->data["soldiers_level"]]["pirate_bust"]) + 
		$fighters + 
		$lightcruisers + 
		$heavycruisers
		) / 100) * $GAME["empire"]->army->data["effectiveness"]);
		$defense_strength = ($pirate["soldiers"] + $pirate["fighters"] + $pirate["lightcruisers"] + $pirate["heavycruisers"]) * CONF_PIRATE_DEFENSE;

		$damage = $attack_strength - $defense_strength;

		$lost_soldiers = 0;
		$lost_fighters = 0;
		$lost_lightcruisers = 0;
		$lost_heavycruisers = 0;
		$lost_generals = 0;
		$lost_pirate_soldiers = 0;
		$lost_pirate_fighters = 0;
		$lost_pirate_lightcruisers = 0;
		$lost_pirate_sheavycruisers = 0;

		if ($damage < 0) {

			$lost_pirate_soldiers = $GAME["system"]->alterNumber(floor(($soldiers+($fighters/10)+($lightcruisers/20)+($heavycruisers/40)) / 10), 10);
			if ($lost_pirate_soldiers > $pirate["soldiers"]) $lost_pirate_soldiers = $pirate["soldiers"];
			$lost_pirate_generals = $GAME["system"]->alterNumber(floor($lost_pirate_soldiers / 50), 10);
			if ($lost_pirate_generals > $pirate["generals"]) $lost_pirate_generals = $pirate["generals"];
			$lost_pirate_fighters = $GAME["system"]->alterNumber(floor(($fighters+($soldiers/50)+($lightcruisers/10)+($heavycruisers/20)) / 10), 10);
			if ($lost_pirate_fighters > $pirate["fighters"]) $lost_pirate_fighters = $pirate["fighters"];
			$lost_pirate_lightcruisers = $GAME["system"]->alterNumber(floor(($lightcruisers+($fighters/20)+($heavycruisers/10)) / 10), 10);
			if ($lost_pirate_lightcruisers > $pirate["lightcruisers"]) $lost_pirate_lightcruisers = $pirate["lightcruisers"];
			$lost_pirate_heavycruisers = $GAME["system"]->alterNumber(floor(($heavycruisers+($lightcruisers/10)+($fighters/50)) / 10), 10);
			if ($lost_pirate_heavycruisers > $pirate["heavycruisers"]) $lost_pirate_heavycruisers = $pirate["heavycruisers"];


			$lost_soldiers = $GAME["system"]->alterNumber(floor(($pirate["soldiers"] + ($pirate["fighters"]/10) + ($pirate["lightcruisers"]/20)+($pirate["heavycruisers"]/40))/ 40), 10);
			if ($lost_soldiers > $soldiers) $lost_soldiers = $soldiers;
			$lost_generals = $GAME["system"]->alterNumber(floor($lost_soldiers / 200), 10);
			if ($lost_soldiers > $soldiers) $lost_soldiers = $soldiers;
			$lost_fighters = $GAME["system"]->alterNumber(floor(($pirate["fighters"]+($pirate["soldiers"]/50)+($pirate["lightcruisers"]/10)+($pirate["heavycruisers"]/20)) / 40), 10);
			if ($lost_fighters > $fighters) $lost_fighters = $fighters;
			$lost_lightcruisers = $GAME["system"]->alterNumber(floor(($pirate["lightcruisers"]+($pirate["fighters"]/20) + ($pirate["heavycruisers"]/10)) / 40), 10);
			if ($lost_lightcruisers > $lightcruisers) $lost_lightcruisers = $lightcruisers;
			$lost_heavycruisers = $GAME["system"]->alterNumber(floor(($pirate["heavycruisers"]+($pirate["lightcruisers"]/10)+($pirate["fighters"]/50)) / 40), 10);
			if ($lost_heavycruisers > $heavycruisers) $lost_heavycruisers = $heavycruisers;
			


			$GAME["empire"]->army->data["effectiveness"] -= rand(1, CONF_PIRATE_EFFECTIVENESS_LOST);
			if ($GAME["empire"]->army->data["effectiveness"] < 0)
				$GAME["empire"]->army->data["effectiveness"] = 0;
			$result .= "<b style=\"color:white\">".LANG_YOUR_CASUALTIES.": </b><b style=\"color:#9999FF\">" . $GAME["template"]->formatNumber(floor($lost_soldiers)) . "</b><b style=\"color:white\"> ".LANG_SOLDIERS.",
						  			 </b><b style=\"color:#9999FF\">" . $GAME["template"]->formatNumber(floor($lost_generals)) . "</b><b style=\"color:white\"> ".LANG_GENERALS.",
						  			 </b><b style=\"color:#9999FF\">" . $GAME["template"]->formatNumber(floor($lost_fighters)) . "</b><b style=\"color:white\"> ".LANG_FIGHTERS.",
						  			  </b><b style=\"color:#999FFF\">" . $GAME["template"]->formatNumber(floor($lost_lightcruisers)) . "</b><b style=\"color:white\"> ".LANG_LIGHTCRUISERS.",
						  			   </b><b style=\"color:#9999FF\">" . $GAME["template"]->formatNumber(floor($lost_heavycruisers)) . "</b><b style=\"color:white\"> ".LANG_HEAVYCRUISERS."</b><br/><br/>\r\n";

			$result .= "<b style=\"color:#FF9999\">".LANG_PIRATE_CASUALTIES.": </b><b style=\"color:yellow\">" . $GAME["template"]->formatNumber(floor($lost_pirate_soldiers)) . "</b><b style=\"color:#FF9999\"> ".LANG_SOLDIERS.",
						  			 </b><b style=\"color:yellow\">" . $GAME["template"]->formatNumber(floor($lost_pirate_generals)) . "</b><b style=\"color:#FF9999\"> ".LANG_GENERALS.",
						  			 </b><b style=\"color:yellow\">" . $GAME["template"]->formatNumber(floor($lost_pirate_fighters)) . "</b><b style=\"color:#FF9999\"> ".LANG_FIGHTERS.",
						  			  </b><b style=\"color:yellow\">" . $GAME["template"]->formatNumber(floor($lost_pirate_lightcruisers)) . "</b><b style=\"color:#FF9999\"> ".LANG_LIGHTCRUISERS.",
						  			   </b><b style=\"color:yellow\">" . $GAME["template"]->formatNumber(floor($lost_pirate_heavycruisers)) . "</b><b style=\"color:#FF9999\"> ".LANG_HEAVYCRUISERS."</b><br/><br/>\r\n";

			
			$GAME["empire"]->army->data["soldiers"] -= $lost_soldiers;
			$GAME["empire"]->army->data["fighters"] -= $lost_fighters;
			$GAME["empire"]->army->data["lightcruisers"] -= $lost_lightcruisers;
			$GAME["empire"]->army->data["heavycruisers"] -= $lost_heavycruisers;

			$networth = 0;
			$networth += ($pirate["credits"] * CONF_NETWORTH_CREDITS);
	
			$planets = 0;
			$planets += $pirate["food_planets"];
			$planets += $pirate["ore_planets"];
			$planets += $pirate["tourism_planets"];
			$planets += $pirate["supply_planets"];
			$planets += $pirate["gov_planets"];
			$planets += $pirate["edu_planets"];
			$planets += $pirate["research_planets"];
			$planets += $pirate["urban_planets"];
			$planets += $pirate["petro_planets"];
			$planets += $pirate["antipollu_planets"];
			$networth += ($planets * CONF_NETWORTH_PLANETS);
					
			$army = 0;
			$army += ($pirate["soldiers"]-$lost_pirate_soldiers) * CONF_NETWORTH_MILITARY_SOLDIER;
			$army += ($pirate["fighters"]-$lost_pirate_fighters)* CONF_NETWORTH_MILITARY_FIGHTER;
			$army += ($pirate["stations"])* CONF_NETWORTH_MILITARY_STATION;
			$army += ($pirate["lightcruisers"]-$lost_pirate_lightcruisers)* CONF_NETWORTH_MILITARY_LIGHTCRUISER;
			$army += ($pirate["heavycruisers"]-$lost_pirate_heavycruisers)* CONF_NETWORTH_MILITARY_HEAVYCRUISER;
			$army += ($pirate["carriers"])* CONF_NETWORTH_MILITARY_CARRIER;
			$army += ($pirate["generals"]-$lost_pirate_generals)* CONF_NETWORTH_MILITARY_GENERAL;
			$army += ($pirate["covertagents"])* CONF_NETWORTH_MILITARY_COVERT;
			$networth += $army;
			
			$pirate["networth"] = $networth;
		
			
			$DB->Execute("UPDATE tb_pirate SET soldiers=" . ($pirate["soldiers"] - $lost_pirate_soldiers) . ",
									fighters=" . ($pirate["fighters"] - $lost_pirate_fighters) . ",
									lightcruisers=" . ($pirate["lightcruisers"] - $lost_pirate_lightcruisers) . ",
									heavycruisers=" . ($pirate["heavycruisers"] - $lost_pirate_heavycruisers) . ",".
									"networth=".addslashes($pirate["networth"])."
								 	WHERE id=" . $pirate["id"]);

			$result .= "<b style=\"color:yellow\">*** ".LANG_PIRATE_PREVAILED.": " . $GAME["empire"]->army->data["effectiveness"] . "%<br/></b>\r\n";
		} else {


			$lost_pirate_soldiers = $GAME["system"]->alterNumber(floor(($soldiers+($fighters/10)+($lightcruisers/20)+($heavycruisers/40)) / 40), 10);
			if ($lost_pirate_soldiers > $pirate["soldiers"]) $lost_pirate_soldiers = $pirate["soldiers"];
			$lost_pirate_generals = $GAME["system"]->alterNumber(floor($lost_pirate_soldiers / 200), 10);
			if ($lost_pirate_generals > $pirate["generals"]) $lost_pirate_generals = $pirate["generals"];
			$lost_pirate_fighters = $GAME["system"]->alterNumber(floor(($fighters+($soldiers/50)+($lightcruisers/10)+($heavycruisers/20)) / 40), 10);
			if ($lost_pirate_fighters > $pirate["fighters"]) $lost_pirate_fighters = $pirate["fighters"];
			$lost_pirate_lightcruisers = $GAME["system"]->alterNumber(floor(($lightcruisers+($fighters/20)+($heavycruisers/10)) / 40), 10);
			if ($lost_pirate_lightcruisers > $pirate["lightcruisers"]) $lost_pirate_lightcruisers = $pirate["lightcruisers"];
			$lost_pirate_heavycruisers = $GAME["system"]->alterNumber(floor(($heavycruisers+($lightcruisers/10)+($fighters/50)) / 40), 10);
			if ($lost_pirate_heavycruisers > $pirate["heavycruisers"]) $lost_pirate_heavycruisers = $pirate["heavycruisers"];


			$lost_soldiers = $GAME["system"]->alterNumber(floor(($pirate["soldiers"] + ($pirate["fighters"]/10) + ($pirate["lightcruisers"]/20)+($pirate["heavycruisers"]/40))/ 10), 10);
			if ($lost_soldiers > $soldiers) $lost_soldiers = $soldiers;
			$lost_generals = $GAME["system"]->alterNumber(floor($lost_soldiers / 50), 10);
			if ($lost_generals > $generals) $lost_generals = $generals;
			$lost_fighters = $GAME["system"]->alterNumber(floor(($pirate["fighters"]+($pirate["soldiers"]/50)+($pirate["lightcruisers"]/10)+($pirate["heavycruisers"]/20)) / 10), 10);
			if ($lost_fighters > $fighters) $lost_fighters = $fighters;
			$lost_lightcruisers = $GAME["system"]->alterNumber(floor(($pirate["lightcruisers"]+($pirate["fighters"]/20) + ($pirate["heavycruisers"]/10)) / 10), 10);
			if ($lost_lightcruisers > $lightcruisers) $lost_lightcruisers = $lightcruisers;
			$lost_heavycruisers = $GAME["system"]->alterNumber(floor(($pirate["heavycruisers"]+($pirate["lightcruisers"]/10)+($pirate["fighters"]/50)) / 10), 10);
			if ($lost_heavycruisers > $heavycruisers) $lost_heavycruisers = $heavycruisers;


			$result .= "<b style=\"color:white\">".LANG_YOUR_CASUALTIES.": </b><b style=\"color:#9999FF\">" . $GAME["template"]->formatNumber(floor($lost_soldiers)) . "</b><b style=\"color:white\"> ".LANG_SOLDIERS.",
						  			 </b><b style=\"color:#9999FF\">" . $GAME["template"]->formatNumber(floor($lost_generals)) . "</b><b style=\"color:white\"> ".LANG_GENERALS.",
						  			 </b><b style=\"color:#9999FF\">" . $GAME["template"]->formatNumber(floor($lost_fighters)) . "</b><b style=\"color:white\"> ".LANG_FIGHTERS.",
						  			  </b><b style=\"color:#999FFF\">" . $GAME["template"]->formatNumber(floor($lost_lightcruisers)) . "</b><b style=\"color:white\"> ".LANG_LIGHTCRUISERS.",
						  			   </b><b style=\"color:#9999FF\">" . $GAME["template"]->formatNumber(floor($lost_heavycruisers)) . "</b><b style=\"color:white\"> ".LANG_HEAVYCRUISERS."</b><br/><br/>\r\n";

			$result .= "<b style=\"color:#FF9999\">".LANG_PIRATE_CASUALTIES.": </b><b style=\"color:yellow\">" . $GAME["template"]->formatNumber(floor($lost_pirate_soldiers)) . "</b><b style=\"color:#FF9999\"> ".LANG_SOLDIERS.",
						  			 </b><b style=\"color:yellow\">" . $GAME["template"]->formatNumber(floor($lost_pirate_generals)) . "</b><b style=\"color:#FF9999\"> ".LANG_GENERALS.",
						  			 </b><b style=\"color:yellow\">" . $GAME["template"]->formatNumber(floor($lost_pirate_fighters)) . "</b><b style=\"color:#FF9999\"> ".LANG_FIGHTERS.",
						  			  </b><b style=\"color:yellow\">" . $GAME["template"]->formatNumber(floor($lost_pirate_lightcruisers)) . "</b><b style=\"color:#FF9999\"> ".LANG_LIGHTCRUISERS.",
						  			   </b><b style=\"color:yellow\">" . $GAME["template"]->formatNumber(floor($lost_pirate_heavycruisers)) . "</b><b style=\"color:#FF9999\"> ".LANG_HEAVYCRUISERS."</b><br/><br/>\r\n";

			$result .= "<b style=\"color:lightgreen\">*** ".LANG_PIRATE_GANG_LOST."<br/></b>\r\n";
			$GAME["empire"]->army->data["effectiveness"] += rand(1, CONF_PIRATE_EFFECTIVENESS_WON);
			if ($GAME["empire"]->army->data["effectiveness"] > 100)
				$GAME["empire"]->army->data["effectiveness"] = 100;

			$GAME["empire"]->army->data["soldiers"] -= $lost_soldiers;
			$GAME["empire"]->army->data["fighters"] -= $lost_fighters;
			$GAME["empire"]->army->data["lightcruisers"] -= $lost_lightcruisers;
			$GAME["empire"]->army->data["heavycruisers"] -= $lost_heavycruisers;


			$pirate = $DB->Execute("SELECT * FROM tb_pirate WHERE id=" . $pirate["id"]);
			$pirate = $pirate->fields;

			$reclaimed_credits = (($pirate["credits"] / 100) * rand(0, 20));
			$reclaimed_food = (($pirate["food"] / 100) * rand(0, 20));
			$reclaimed_covertagents = ((($pirate["covertagents"]) / 100) * rand(0, 20));
			$reclaimed_generals = ((($pirate["generals"]-$lost_pirate_generals) / 100) * rand(0, 20));
			$reclaimed_stations = ((($pirate["stations"]) / 100) * rand(0, 20));
			$reclaimed_soldiers = ((($pirate["soldiers"]-$lost_pirate_soldiers) / 100) * rand(0, 20));
			$reclaimed_fighters = ((($pirate["fighters"]-$lost_pirate_fighters) / 100) * rand(0, 20));
			$reclaimed_lightcruisers = ((($pirate["lightcruisers"]-$lost_pirate_lightcruisers) / 100) * rand(0, 20));
			$reclaimed_heavycruisers = ((($pirate["heavycruisers"]-$lost_pirate_heavycruisers) / 100) * rand(0, 20));
			$reclaimed_carriers = ((($pirate["carriers"]) / 100) * rand(0, 20));
			$reclaimed_food_planets = (($pirate["food_planets"] / 100) * rand(0, 20));
			$reclaimed_ore_planets = (($pirate["ore_planets"] / 100) * rand(0, 20));
			$reclaimed_tourism_planets = (($pirate["tourism_planets"] / 100) * rand(0, 20));
			$reclaimed_supply_planets = (($pirate["supply_planets"] / 100) * rand(0, 20));
			$reclaimed_gov_planets = (($pirate["gov_planets"] / 100) * rand(0, 20));
			$reclaimed_edu_planets = (($pirate["edu_planets"] / 100) * rand(0, 20));
			$reclaimed_research_planets = (($pirate["research_planets"] / 100) * rand(0, 20));
			$reclaimed_urban_planets = (($pirate["urban_planets"] / 100) * rand(0, 20));
			$reclaimed_petro_planets = (($pirate["petro_planets"] / 100) * rand(0, 20));
			$reclaimed_antipollu_planets = (($pirate["antipollu_planets"] / 100) * rand(0, 20));

			$networth = 0;
			$networth += (($pirate["credits"]-$reclaimed_credits) * CONF_NETWORTH_CREDITS);
	
			$planets = 0;
			$planets += ($pirate["food_planets"]- $reclaimed_food_planets);
			$planets += ($pirate["ore_planets"]- $reclaimed_ore_planets);
			$planets += ($pirate["tourism_planets"]- $reclaimed_tourism_planets);
			$planets += ($pirate["supply_planets"]- $reclaimed_supply_planets);
			$planets += ($pirate["gov_planets"]- $reclaimed_gov_planets);
			$planets += ($pirate["edu_planets"]- $reclaimed_edu_planets);
			$planets += ($pirate["research_planets"]- $reclaimed_research_planets);
			$planets += ($pirate["urban_planets"]- $reclaimed_urban_planets);
			$planets += ($pirate["petro_planets"]- $reclaimed_petro_planets);
			$planets += ($pirate["antipollu_planets"]- $reclaimed_antipollu_planets);
			$networth += ($planets * CONF_NETWORTH_PLANETS);
					
			$army = 0;
			$army += ($pirate["soldiers"]-$lost_pirate_soldiers-$reclaimed_soldiers) * CONF_NETWORTH_MILITARY_SOLDIER;
			$army += ($pirate["fighters"]-$lost_pirate_fighters-$reclaimed_fighters)* CONF_NETWORTH_MILITARY_FIGHTER;
			$army += ($pirate["stations"]-$reclaimed_stations)* CONF_NETWORTH_MILITARY_STATION;
			$army += ($pirate["lightcruisers"]-$lost_pirate_lightcruisers-$reclaimed_lightcruisers)* CONF_NETWORTH_MILITARY_LIGHTCRUISER;
			$army += ($pirate["heavycruisers"]-$lost_pirate_heavycruisers-$reclaimed_heavycruisers)* CONF_NETWORTH_MILITARY_HEAVYCRUISER;
			$army += ($pirate["carriers"]-$reclaimed_carriers)* CONF_NETWORTH_MILITARY_CARRIER;
			$army += ($pirate["generals"]-$lost_pirate_generals-$reclaimed_generals)* CONF_NETWORTH_MILITARY_GENERAL;
			$army += ($pirate["covertagents"])* CONF_NETWORTH_MILITARY_COVERT;
			$networth += $army;
			
			$pirate["networth"] = $networth;
		
			
			$DB->Execute("UPDATE tb_pirate SET soldiers=" . ($pirate["soldiers"] - $lost_pirate_soldiers) . ",
									fighters=" . ($pirate["fighters"] - $lost_pirate_fighters) . ",
									lightcruisers=" . ($pirate["lightcruisers"] - $lost_pirate_lightcruisers) . ",
									heavycruisers=" . ($pirate["heavycruisers"] - $lost_pirate_heavycruisers) . ",".
									"networth=".addslashes($pirate["networth"])."
								 	WHERE id=" . $pirate["id"]);


			$result .= "<br/><div style=\"color:#66AAAA;font-size:12px;font-family:verdana\">";
			$result .= LANG_RECLAIMED." ".LANG_CREDITS.": " . $GAME["template"]->formatCredits($reclaimed_credits) . "<br/>\r\n";
			$result .= LANG_RECLAIMED." ".LANG_FOOD.": " . $GAME["template"]->formatFood($reclaimed_food) . "<br/>\r\n";
			$result .= LANG_RECLAIMED." ".LANG_COVERTAGENTS.": <b style=\"color:white\">" . $GAME["template"]->formatNumber($reclaimed_covertagents) . "</b><br/>\r\n";
			$result .= LANG_RECLAIMED." ".LANG_GENERALS.": <b style=\"color:white\">" . $GAME["template"]->formatNumber($reclaimed_generals) . "</b><br/>\r\n";
			$result .= LANG_RECLAIMED." ".LANG_STATIONS.": <b style=\"color:white\">" . $GAME["template"]->formatNumber($reclaimed_stations) . "</b><br/>\r\n";
			$result .= LANG_RECLAIMED." ".LANG_SOLDIERS.": <b style=\"color:white\">" . $GAME["template"]->formatNumber($reclaimed_soldiers) . "</b><br/>\r\n";
			$result .= LANG_RECLAIMED." ".LANG_FIGHTERS.": <b style=\"color:white\">" . $GAME["template"]->formatNumber($reclaimed_fighters) . "</b><br/>\r\n";
			$result .= LANG_RECLAIMED." ".LANG_LIGHTCRUISERS.": <b style=\"color:white\">" . $GAME["template"]->formatNumber($reclaimed_lightcruisers) . "</b><br/>\r\n";
			$result .= LANG_RECLAIMED." ".LANG_HEAVYCRUISERS.": <b style=\"color:white\">" . $GAME["template"]->formatNumber($reclaimed_heavycruisers) . "</b><br/>\r\n";
			$result .= LANG_RECLAIMED." ".LANG_CARRIERS.": <b style=\"color:white\">" . $GAME["template"]->formatNumber($reclaimed_carriers) . "</b><br/>\r\n";
			$result .= LANG_RECLAIMED." ".LANG_FOOD_PLANETS.": <b style=\"color:white\">" . $GAME["template"]->formatNumber($reclaimed_food_planets) . "</b><br/>\r\n";
			$result .= LANG_RECLAIMED." ".LANG_ORE_PLANETS.": <b style=\"color:white\">" . $GAME["template"]->formatNumber($reclaimed_ore_planets) . "</b><br/>\r\n";
			$result .= LANG_RECLAIMED." ".LANG_TOURISM_PLANETS.": <b style=\"color:white\">" . $GAME["template"]->formatNumber($reclaimed_tourism_planets) . "</b><br/>\r\n";
			$result .= LANG_RECLAIMED." ".LANG_SUPPLY_PLANETS.": <b style=\"color:white\">" . $GAME["template"]->formatNumber($reclaimed_supply_planets) . "</b><br/>\r\n";
			$result .= LANG_RECLAIMED." ".LANG_GOV_PLANETS.": <b style=\"color:white\">" . $GAME["template"]->formatNumber($reclaimed_gov_planets) . "</b><br/>\r\n";
			$result .= LANG_RECLAIMED." ".LANG_EDU_PLANETS.": <b style=\"color:white\">" . $GAME["template"]->formatNumber($reclaimed_edu_planets) . "</b><br/>\r\n";
			$result .= LANG_RECLAIMED." ".LANG_URBAN_PLANETS.": <b style=\"color:white\">" . $GAME["template"]->formatNumber($reclaimed_urban_planets) . "</b><br/>\r\n";
			$result .= LANG_RECLAIMED." ".LANG_RESEARCH_PLANETS.": <b style=\"color:white\">" . $GAME["template"]->formatNumber($reclaimed_research_planets) . "</b><br/>\r\n";
			$result .= LANG_RECLAIMED." ".LANG_PETROLEUM_PLANETS.": <b style=\"color:white\">" . $GAME["template"]->formatNumber($reclaimed_petro_planets) . "</b><br/>\r\n";
			$result .= LANG_RECLAIMED." ".LANG_ANTIPOLLU_PLANETS.": <b style=\"color:white\">" . $GAME["template"]->formatNumber($reclaimed_antipollu_planets) . "</b><br/>\r\n";
			$result .= "</div><br/>";

			$query = "UPDATE tb_pirate SET credits=" . floor($pirate["credits"] - $reclaimed_credits) . ",
						  		food=" . floor($pirate["food"] - $reclaimed_food) . ",
						  		covertagents=" . floor($pirate["covertagents"] - $reclaimed_covertagents) . ",
						  		general=" . floor($pirate["generals"] - $reclaimed_generals) . ",
						  		stations=" . floor($pirate["stations"] - $reclaimed_stations) . ",
						  		soldiers=" . floor($pirate["soldiers"] - $reclaimed_soldiers) . ",
						  		fighters=" . floor($pirate["fighters"] - $reclaimed_fighters) . ",
						  		lightcruisers=" . floor($pirate["lightcruisers"] - $reclaimed_lightcruisers) . ",
						  		heavycruisers=" . floor($pirate["heavycruisers"] - $reclaimed_heavycruisers) . ",
						  		carriers=" . floor($pirate["carriers"] - $reclaimed_carriers) . ",
						  		food_planets=" . floor($pirate["food_planets"] - $reclaimed_food_planets) . ",
						  		ore_planets=" . floor($pirate["ore_planets"] - $reclaimed_ore_planets) . ",
						  		tourism_planets=" . floor($pirate["tourism_planets"] - $reclaimed_tourism_planets) . ",
						  		supply_planets=" . floor($pirate["supply_planets"] - $reclaimed_supply_planets) . ",
						  		gov_planets=" . floor($pirate["gov_planets"] - $reclaimed_gov_planets) . ",
						  		edu_planets=" . floor($pirate["edu_planets"] - $reclaimed_edu_planets) . ",
						  		urban_planets=" . floor($pirate["urban_planets"] - $reclaimed_urban_planets) . ",
						  		research_planets=" . floor($pirate["research_planets"] - $reclaimed_research_planets) . ",
						  		petro_planets=" . floor($pirate["petro_planets"] - $reclaimed_petro_planets) . ",
						  		antipollu_planets=" . floor($pirate["antipollu_planets"] - $reclaimed_antipollu_planets) . "
						  		WHERE id=" . $pirate["id"];

			$DB->Execute($query);

			$GAME["empire"]->data["credits"] += $reclaimed_credits;
			$GAME["empire"]->data["food"] += $reclaimed_food;

			$GAME["empire"]->army->data["soldiers"] += $reclaimed_soldiers;
			$GAME["empire"]->army->data["fighters"] += $reclaimed_fighters;
			$GAME["empire"]->army->data["stations"] += $reclaimed_stations;
			$GAME["empire"]->army->data["lightcruisers"] += $reclaimed_lightcruisers;
			$GAME["empire"]->army->data["heavycruisers"] += $reclaimed_heavycruisers;
			$GAME["empire"]->army->data["carriers"] += $reclaimed_carriers;
			$GAME["empire"]->army->data["covertagents"] += $reclaimed_covertagents;
			$GAME["empire"]->army->data["generals"] += $reclaimed_generals;

			$GAME["empire"]->planets->data["food_planets"] += $reclaimed_food_planets;
			$GAME["empire"]->planets->data["ore_planets"] += $reclaimed_ore_planets;
			$GAME["empire"]->planets->data["tourism_planets"] += $reclaimed_tourism_planets;
			$GAME["empire"]->planets->data["supply_planets"] += $reclaimed_supply_planets;
			$GAME["empire"]->planets->data["gov_planets"] += $reclaimed_gov_planets;
			$GAME["empire"]->planets->data["edu_planets"] += $reclaimed_edu_planets;
			$GAME["empire"]->planets->data["urban_planets"] += $reclaimed_urban_planets;
			$GAME["empire"]->planets->data["research_planets"] += $reclaimed_research_planets;
			$GAME["empire"]->planets->data["petro_planets"] += $reclaimed_petro_planets;
			$GAME["empire"]->planets->data["antipollu_planets"] += $reclaimed_antipollu_planets;
			$GAME["empire"]->data["already_attacked"] = 1;
			$GAME["empire"]->save();
			

		}


			$evt = new EventCreator($DB);
			$evt->type = CONF_EVENT_PIRATEBUST;
			$evt->from = -1;
			$evt->to = $GAME["empire"]->data["id"];
			$evt->params = array (
				"result" => $result,
				"pirate_name" => $pirate["name"]
			);
			$evt->send();
			

	}

}

////////////////////////////////////////////////////////////////
// MAIN
////////////////////////////////////////////////////////////////

$GAME["system"]->redirect("manage.php");
?>
