<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//
require_once ("include/init.php");
require_once ("include/init_ingame.php");

$max_lightcruisers = floor($GAME["empire"]->data["credits"] / CONF_BLACKMARKET_PRICE_LIGHTCRUISERS);

if ($GAME["empire"]->data["blackmarket"]==0) $GAME["system"]->redirect("manage.php");

//////////////////////////////////////////////////////////////////////////////////////////////////////
// buy light cruisers
//////////////////////////////////////////////////////////////////////////////////////////////////////
if (isset($_GET["buy_lightcruisers"])) {
	$qty = str_replace(",","",$_GET["buy_lightcruisers"]);
	if ($qty > $max_lightcruisers) {
		$GAME["system"]->redirect("blackmarket.php",array("WARNING"=>LANG_INVALID_LIGHCRUISERS_QTY));
	}
	
	if (($qty * CONF_BLACKMARKET_PRICE_LIGHTCRUISERS) > $GAME["empire"]->data["credits"]) {
		$GAME["system"]->redirect("blackmarket.php",array("WARNING"=>LANG_NO_ENOUGH_CREDITS));
	}
 

	$GAME["empire"]->data["credits"] -= ($qty * CONF_BLACKMARKET_PRICE_LIGHTCRUISERS);
	$GAME["empire"]->army->data["lightcruisers"] += $qty;
	$GAME["empire"]->data["blackmarket"] = 0;
	$GAME["empire"]->save();
	
	$GAME["system"]->redirect("manage.php",array("NOTICE"=>LANG_LIGHTCRUISERS_BOUGHT));
}


//////////////////////////////////////////////////////////////////////////////////////////////////////
// buy protection
//////////////////////////////////////////////////////////////////////////////////////////////////////
if (isset($_GET["buy_extraprotection"])) {

	if ($GAME["empire"]->data["protection_turns_left"] > 0) 
		$GAME["system"]->redirect("blackmarket.php",array("WARNING"=>LANG_YOU_ARE_ALREADY_UNDER_PROTECTION));
	
	if ($GAME["empire"]->data["credits"] < CONF_BLACKMARKET_PRICE_EXTRAPROTECTION) 
		$GAME["system"]->redirect("blackmarket.php",array("WARNING"=>LANG_NO_ENOUGH_CREDITS));

	$GAME["empire"]->data["credits"] -= CONF_BLACKMARKET_PRICE_EXTRAPROTECTION;
	$GAME["empire"]->data["protection_turns_left"] += 10;
	$GAME["empire"]->data["blackmarket"] = 0;
	$GAME["empire"]->save();

	$GAME["system"]->redirect("manage.php",array("NOTICE"=>LANG_EXTRAPROTECTION_BOUGHT));



}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// buy nuke
//////////////////////////////////////////////////////////////////////////////////////////////////////
if (isset($_GET["buy_nuke"])) {
	
	if ($GAME["empire"]->data["credits"] < CONF_BLACKMARKET_PRICE_NUKES) 
		$GAME["system"]->redirect("blackmarket.php",array("WARNING"=>LANG_NO_ENOUGH_CREDITS));

	if ($GAME["empire"]->data["have_nukes"]==1) {
		$GAME["system"]->redirect("blackmarket.php",array("WARNING"=>LANG_YOU_ALREADY_HAVE_NUKES));
	}

	$GAME["empire"]->data["have_nukes"] = 1;
	$GAME["empire"]->data["blackmarket"] = 0;
	$GAME["empire"]->save();


	$evt = new EventCreator($DB);
	$evt->type = CONF_EVENT_EMPIRE_BUY_NUKES;
	$evt->from = $GAME["empire"]->data["id"];
	$evt->broadcast();


	$GAME["system"]->redirect("manage.php",array("NOTICE"=>LANG_NUKES_BOUGHT));

}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// buy teleport
//////////////////////////////////////////////////////////////////////////////////////////////////////
if (isset($_GET["buy_teleport"])) {

	if ($GAME["empire"]->data["credits"] < CONF_BLACKMARKET_PRICE_EXTRAPROTECTION) 
		$GAME["system"]->redirect("blackmarket.php",array("WARNING"=>LANG_NO_ENOUGH_CREDITS));


	$GAME["empire"]->data["population"] = floor($GAME["empire"]->data["population"]/2);
	
	
	srand(time(NULL));
	do {
		$x = -950+rand(0,1900);
		$y = -950+rand(0,1900);
		$rs = $DB->Execute("SELECT * FROM tb_empire WHERE (x>=".($x-50)." AND x<=".($x+50).") AND (y>=".($y-50)." AND y<=".($y+50).")");
	
	} while(!$rs->EOF);

	$GAME["empire"]->data["x"] = $x;
	$GAME["empire"]->data["y"] = $y;
	$GAME["empire"]->data["blackmarket"] = 0;
	$GAME["empire"]->save();

	$evt = new EventCreator($DB);
	$evt->type = CONF_EVENT_EMPIRE_TELEPORTED;
	$evt->from = $GAME["empire"]->data["id"];
	$evt->params = array("empire_id"=>$GAME["empire"]->data["id"],"empire_name"=>$GAME["empire"]->data["name"],"empire_emperor"=>$GAME["empire"]->data["emperor"],"gender"=>$GAME["empire"]->data["gender"]);
	$evt->broadcast();

	$GAME["system"]->redirect("manage.php",array("NOTICE"=>LANG_TELEPORTATION_SUCCESSFULLY_DONE));
	
	// do not modify convoys 
}


// render

$GAME["template"]->setPage("blackmarket.html");

$GAME["template"]->setVar("price_lightcruisers",$GAME["template"]->formatCredits(CONF_BLACKMARKET_PRICE_LIGHTCRUISERS));
$GAME["template"]->setVar("max_lightcruisers",$GAME["template"]->formatNumber($max_lightcruisers));


$GAME["template"]->setVar("price_nukes",$GAME["template"]->formatCredits(CONF_BLACKMARKET_PRICE_NUKES));
$GAME["template"]->setVar("price_teleport",$GAME["template"]->formatCredits(CONF_BLACKMARKET_PRICE_TELEPORT));
$GAME["template"]->setVar("price_extraprotection",$GAME["template"]->formatCredits(CONF_BLACKMARKET_PRICE_EXTRAPROTECTION));

print $GAME["template"]->render();

?>