<?php
//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:	http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.e
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

require_once ("include/init.php");
require_once ("include/init_ingame.php");

if ($GAME["empire"]->data["protection_turns_left"] != 0)
	$GAME["system"]->redirect("manage.php", array (
		"WARNING" => LANG_NO_COVERT_OPERATIONS_UNTIL_OUT_OF_PROTECTION
	));

if ($GAME["empire"]->army->data["covertagents"] == 0)
	$GAME["system"]->redirect("manage.php", array (
		"WARNING" => LANG_NEED_COVERTAGENTS_TO_CONDUCT_OPERATIONS
	));

////////////////////////////////////////////////////////////////////////////////
// Handle requests
////////////////////////////////////////////////////////////////////////////////

if (isset ($_POST["empire"])) {

	$empire = $_POST["empire"];
	$operation = $_POST["operation"];

	if (($operation < 0) || ($operation > (count($CONF_COVERT_OPERATIONS) - 1)))
		$GAME["system"]->redirect("covert.php", array (
			"WARNING" => LANG_INVALID_COVERT_OPERATION
		));

	if ($CONF_COVERT_OPERATIONS[$operation]["cost_points"] > $GAME["empire"]->army->data["covert_points"])
		$GAME["system"]->redirect("covert.php", array (
			"WARNING" => LANG_NO_ENOUGH_COVERT_POINTS
		));

	if ($CONF_COVERT_OPERATIONS[$operation]["cost_credits"] > $GAME["empire"]->data["credits"])
		$GAME["system"]->redirect("covert.php", array (
			"WARNING" => LANG_NO_ENOUGH_CREDITS
		));

	$rs = $DB->Execute("SELECT * FROM tb_empire WHERE  admin=0  AND id=" . addslashes($empire));
	if ($rs->EOF)
		$GAME["system"]->redirect("covert.php", array (
			"WARNING" => LANG_INVALID_EMPIRE_ID
		));

	if ($rs->fields["protection_turns_left"] != 0)
		$GAME["system"]->redirect("covert.php", array (
			"WARNING" => LANG_EMPIRE_UNDER_PROTECTION
		));

	$enemy_empire = new Empire($DB, $TPL, $GAME["gameplay_costs"]);
	$enemy_empire->load($empire);

	$covert1 = $GAME["empire"]->army->data["covertagents"] / $GAME["empire"]->planets->getCount();
	$covert2 = $enemy_empire->army->data["covertagents"] / $enemy_empire->planets->getCount();

	if ($covert1 == 0)
		$covert1 = 1;
	if ($covert2 == 0)
		$covert2 = 1;

	$c = $GAME["empire"]->army->data["covertagents"] / ($enemy_empire->army->data["covertagents"] == 0 ? 1 : $enemy_empire->army->data["covertagents"]);

	$success_rate = (($covert1 / $covert2) * 100);
	$success_rate /= $CONF_COVERT_OPERATIONS[$operation]["ratio"];

	$difficulty = LANG_IMPOSSIBLE;
	if ($success_rate > 0)
		$difficulty = LANG_NEARLY_IMPOSSIBLE;
	if ($success_rate > 20)
		$difficulty = LANG_UNLIKELY;
	if ($success_rate > 40)
		$difficulty = LANG_FAIR;
	if ($success_rate > 60)
		$difficulty = LANG_MOSTLY_SAFE;
	if ($success_rate > 80)
		$difficulty = LANG_SAFE;

	$result = LANG_SUCCESS_RATE . ": " . $difficulty . "<br/>\r\n";
	srand(time(NULL));
	$percent = rand(1, 100);
	if ($success_rate > $percent)
		switch ($operation) {

				/***************************************************************************/
			case CONF_COVERTOP_TAKEHOSTAGES :
				/***************************************************************************/

				$p = rand(10+($GAME["empire"]->army->data["covertagents_level"]*10), 90);
				$credits_lost = floor(($enemy_empire->data["credits"] / 100) * $p);
				$credits_lost *= $c;
				if ($credits_lost > $enemy_empire->data["credits"])
					$credits_lost = $enemy_empire->data["credits"];

				$enemy_empire->data["credits"] -= $credits_lost;
				$enemy_empire->save();
				
				$GAME["template"]->TPL->set_file("covertop", "covertop/takehostages.html");
				$GAME["template"]->TPL->set_var("credits_lost",$GAME["template"]->formatNumber($credits_lost));
				$result .= $GAME["template"]->TPL->process("", "covertop", 2);
				
				$GAME["empire"]->data["credits"] += $credits_lost;
			  $GAME["empire"]->save();
				
				$evt = new EventCreator($DB);
				$evt->type = CONF_EVENT_HOSTAGES;
				$evt->from = $GAME["empire"]->data["id"];
				$evt->to = $enemy_empire->data["id"];
				$evt->params = array("credits_lost"=>$credits_lost);
				$evt->send();

				break;

				/***************************************************************************/
			case CONF_COVERTOP_RELATIONSSPYING :
				/***************************************************************************/

				$GAME["template"]->TPL->set_file("covertop", "covertop/relationsspying.html");
	
				$treaties = array();
				for ($i=0;$i<count($enemy_empire->diplomacy->data);$i++) {
	
					$treaty = $enemy_empire->diplomacy->data[$i];
					
					switch($treaty["status"])
					{
						case 1:
							$treaty["status"] = LANG_ACTIVE;	
						break;
						
						case 2:
							$treaty["status"] = LANG_BREAK_PENDING;	
						break;
						
						default:
							$treaty["status"] = LANG_ACCEPT_PENDING;	
					}
					
					$treaty["type"] = $CONF_DIPLOMACY_TREATIES[$treaty["type"]];

					$r1 = $DB->Execute("SELECT emperor,name FROM tb_empire WHERE id=".addslashes($treaty["empire_from"]));
					$r2 = $DB->Execute("SELECT emperor,name FROM tb_empire WHERE id=".addslashes($treaty["empire_to"]));
					$treaty["from"] = $r1->fields["emperor"]."@".$r1->fields["name"];
					$treaty["to"] = $r2->fields["emperor"]."@".$r2->fields["name"];
					
					
					$r =rand(0, 4);
					if ($r > $GAME["empire"]->army->data["covertagents_level"]) $treaty["from"] = "???";

					$r =rand(0, 4);
					if ($r > $GAME["empire"]->army->data["covertagents_level"]) $treaty["to"] = "???";

					$r =rand(0, 4);
					if ($r > $GAME["empire"]->army->data["covertagents_level"]) $treaty["type"] = "???";

					$r =rand(0, 4);
					if ($r > $GAME["empire"]->army->data["covertagents_level"]) $treaty["status"] = "???";

						
					$treaties[] = $treaty;
					
				}
				$GAME["template"]->TPL->set_loop("relations",$treaties);
				$result .= $GAME["template"]->TPL->process("", "covertop", 2);

				break;

				/***************************************************************************/
			case CONF_COVERTOP_BOMBINGOPERATIONS :
				/***************************************************************************/

				$e = rand(10+(10*$GAME["empire"]->army->data["covertagents_level"]), 100);
				$food_lost = floor(($enemy_empire->data["food"] / 100) * $e);
				$food_lost *= $c;
				if ($food_lost > $enemy_empire->data["food"])
					$food_lost = $enemy_empire->data["food"];

				$GAME["template"]->TPL->set_file("covertop", "covertop/bombingoperations.html");

				$GAME["template"]->TPL->set_var("food_lost",$GAME["template"]->formatFood($food_lost));
		
				$enemy_empire->data["food"] -= $food_lost;
				$enemy_empire->save();
				
				$result .= $GAME["template"]->TPL->process("", "covertop", 2);
				
				$evt = new EventCreator($DB);
				$evt->type = CONF_EVENT_FOODBOMBED;
				$evt->from = $GAME["empire"]->data["id"];
				$evt->to = $enemy_empire->data["id"];
				$evt->params = array("content"=>$result);
				$evt->send();
				

				break;

				/***************************************************************************/
			case CONF_COVERTOP_DEMORALIZETROOPS :
				/***************************************************************************/

				$e = $enemy_empire->army->data["effectiveness"];
				
				if ($e >= (10+$GAME["empire"]->army->data["covertagents_level"]))
									   $e -= (10+$GAME["empire"]->army->data["covertagents_level"]);
				
				$enemy_empire->army->data["effectiveness"] = $e;
				$enemy_empire->save();

				$GAME["template"]->TPL->set_file("covertop", "covertop/demoralizetroops.html");
				$GAME["template"]->TPL->set_var("effectiveness",$e);
				$result .= $GAME["template"]->TPL->process("", "covertop", 2);

				break;

				/***************************************************************************/
			case CONF_COVERTOP_SUPPORTDISSENSION :
				/***************************************************************************/
				$percent = rand(1, 20* ($GAME["empire"]->army->data["covertagents_level"]+1));
				$percent *= $c;
				$percent = floor($percent);
				if ($percent == 0)
					$percent = 1;
				if ($percent > 33)
					$percent = 33;

				$soldiers_lost = floor(($enemy_empire->army->data["soldiers"]/100)*$percent);
				$fighters_lost = floor(($enemy_empire->army->data["fighters"]/100)*$percent);
				$stations_lost = floor(($enemy_empire->army->data["stations"]/100)*$percent);
				$lightcruisers_lost = floor(($enemy_empire->army->data["lightcruisers"]/100)*$percent);
				$heavycruisers_lost = floor(($enemy_empire->army->data["heavycruisers"]/100)*$percent);
				$generals_lost = floor(($enemy_empire->army->data["generals"]/100)*$percent);
				$covertagents_lost = floor(($enemy_empire->army->data["covertagents"]/100)*$percent);

				$reclaim_percent = rand(1,10);
				$soldiers_reclaimed = floor(($soldiers_lost/100)*$reclaim_percent);
				$fighters_reclaimed = floor(($fighters_lost/100)*$reclaim_percent);
				$stations_reclaimed = floor(($stations_lost/100)*$reclaim_percent);
				$lightcruisers_reclaimed = floor(($lightcruisers_lost/100)*$reclaim_percent);
				$heavycruisers_reclaimed = floor(($heavycruisers_lost/100)*$reclaim_percent);
				$generals_reclaimed = floor(($generals_lost/100)*$reclaim_percent);
				$covertagents_reclaimed = floor(($covertagents_lost/100)*$reclaim_percent);


				$GAME["template"]->TPL->set_file("covertop", "covertop/supportdissension.html");
				$GAME["template"]->TPL->set_var("soldiers_lost",$GAME["template"]->FormatNumber($soldiers_lost));	
				$GAME["template"]->TPL->set_var("fighters_lost",$GAME["template"]->FormatNumber($fighters_lost));	
				$GAME["template"]->TPL->set_var("stations_lost",$GAME["template"]->FormatNumber($stations_lost));	
				$GAME["template"]->TPL->set_var("lightcruisers_lost",$GAME["template"]->FormatNumber($lightcruisers_lost));	
				$GAME["template"]->TPL->set_var("heavycruisers_lost",$GAME["template"]->FormatNumber($heavycruisers_lost));	
				$GAME["template"]->TPL->set_var("generals_lost",$GAME["template"]->FormatNumber($generals_lost));	
				$GAME["template"]->TPL->set_var("covertagents_lost",$GAME["template"]->FormatNumber($covertagents_lost));	
				$GAME["template"]->TPL->set_var("soldiers_reclaimed",$GAME["template"]->FormatNumber($soldiers_reclaimed));	
				$GAME["template"]->TPL->set_var("fighters_reclaimed",$GAME["template"]->FormatNumber($fighters_reclaimed));	
				$GAME["template"]->TPL->set_var("stations_reclaimed",$GAME["template"]->FormatNumber($stations_reclaimed));	
				$GAME["template"]->TPL->set_var("lightcruisers_reclaimed",$GAME["template"]->FormatNumber($lightcruisers_reclaimed));	
				$GAME["template"]->TPL->set_var("heavycruisers_reclaimed",$GAME["template"]->FormatNumber($heavycruisers_reclaimed));	
				$GAME["template"]->TPL->set_var("generals_reclaimed",$GAME["template"]->FormatNumber($generals_reclaimed));	
				$GAME["template"]->TPL->set_var("covertagents_reclaimed",$GAME["template"]->FormatNumber($covertagents_reclaimed));	
		
				$enemy_empire->army->data["soldiers"] -= $soldiers_lost;
				$enemy_empire->army->data["fighters"] -= $fighters_lost;
				$enemy_empire->army->data["stations"] -= $stations_lost;
				$enemy_empire->army->data["lightcruisers"] -= $lightcruisers_lost;
				$enemy_empire->army->data["heavycruisers"] -= $heavycruisers_lost;
				$enemy_empire->army->data["generals"] -= $generals_lost;
				$enemy_empire->army->data["covertagents"] -= $covertagents_lost;
				$enemy_empire->save();
				
				$result .= $GAME["template"]->TPL->process("", "covertop", 2);
				
				$msg = $GAME["template"]->TPL->process("", "covertop", 2);

				$evt = new EventCreator($DB);
				$evt->type = CONF_EVENT_DISSENSION;
				$evt->from = $GAME["empire"]->data["id"];
				$evt->params = array("content"=>$msg);
				$evt->to = $enemy_empire->data["id"];
				$evt->send();	
				
				
				break;

				/***************************************************************************/
			case CONF_COVERTOP_CARRIERSSABOTAGE :
				/***************************************************************************/
				$percent = rand(10, 20 * ($GAME["empire"]->army->data["covertagents_level"]+1));
				$percent *= $c;
				$percent = floor($percent);
				if ($percent <= 0)
					$percent = 1;
				if ($percent > 50)
					$percent = 50;

				$carriers_lost = floor(($empire->data["carriers"] / 100) * $percent);
				$GAME["template"]->TPL->set_file("covertop", "covertop/carrierssabotage.html");
				
				$GAME["template"]->TPL->set_var("carriers_lost",$GAME["template"]->formatNumber($carriers_lost));
				
				$result .= $GAME["template"]->TPL->process("", "covertop", 2);
				
				$msg = "<b>" . $GAME["template"]->formatNumber($carriers_lost) . LANG_CARRIERS_EXPLODED."</b>\r\n";

				$enemy_empire->army->data["carriers"] -= $carriers_lost;
				$enemy_empire->save();
				
				$evt = new EventCreator($DB);
				$evt->type = CONF_EVENT_CARRIERS_SABOTAGE;
				$evt->from = $GAME["empire"]->data["id"];
				$evt->to = $enemy_empire->data["id"];
				$evt->params = array("content"=>$msg);
				$evt->send();

				break;

				/***************************************************************************/
			case CONF_COVERTOP_COMMUNICATIONSSPYING :
				/***************************************************************************/

				$rs = $DB->Execute("SELECT * FROM tb_message WHERE msg_to=" . $enemy_empire->data["id"] . " ORDER BY id DESC LIMIT 0,".(5+$GAME["empire"]->army->data["covertagents_level"]));

				while (!$rs->EOF) {
					$result .= $GAME["template"]->showMessage($rs->fields)."<br/>";

					$rs->MoveNext();
				}

				break;

				/***************************************************************************/
			case CONF_COVERTOP_INSURGENTAID :
				/***************************************************************************/

				$GAME["template"]->TPL->set_file("covertop", "covertop/insurgentaid.html");

				$civil_status = $rs->fields["civil_status"];
				$r = rand(0, count($CONF_CIVIL_STATUS) - 1);
				$r2 = ((count($CONF_CIVIL_STATUS) - 1) - $civil_status);
				if ($r < $r2) {
					
			
					$r = rand(0, 4);
					if ($r <= $GAME["empire"]->army->data["covertagents_level"]) {
						$civil_status += 1;
						if ($civil_status > (count($CONF_CIVIL_STATUS) - 2))
							$civil_status = count($CONF_CIVIL_STATUS) - 2;
					}
									
					$enemy_empire->data["civil_status"] = $civil_status;
					$enemy_empire->save();
				}

				$GAME["template"]->TPL->set_var("civil_status",$CONF_CIVIL_STATUS[$civil_status]);
				
				$result .= $GAME["template"]->TPL->process("", "covertop", 2);

				break;

				/***************************************************************************/
			case CONF_COVERTOP_SENDSPY :
				/***************************************************************************/

				$GAME["template"]->TPL->set_file("covertop", "covertop/sendspy.html");
				$GAME["template"]->TPL->set_var("empire_name", $enemy_empire->data["name"]);
				$GAME["template"]->TPL->set_var("empire_emperor", $enemy_empire->data["emperor"]);
				$GAME["template"]->TPL->set_var("credits", (rand(0, 4) > $GAME["empire"]->army->data["covertagents_level"] ? "???" : $GAME["template"]->formatCredits($enemy_empire->data["credits"])));
				$GAME["template"]->TPL->set_var("population", (rand(0, 4) > $GAME["empire"]->army->data["covertagents_level"] ? "???" : $GAME["template"]->formatPopulation($enemy_empire->data["population"])));
				$GAME["template"]->TPL->set_var("food", (rand(0, 4) > $GAME["empire"]->army->data["covertagents_level"] ? "???" : $GAME["template"]->formatFood($enemy_empire->data["food"])));
				$GAME["template"]->TPL->set_var("civil_status", (rand(0, 4) > $GAME["empire"]->army->data["covertagents_level"] ? "???" : $CONF_CIVIL_STATUS[$enemy_empire->data["civil_status"]]));
				$GAME["template"]->TPL->set_var("commandship", (rand(0, 4) > $GAME["empire"]->army->data["covertagents_level"] ? "???" : $enemy_empire->army->data["commandship"]));
				$GAME["template"]->TPL->set_var("taxrate", (rand(0, 4) > $GAME["empire"]->army->data["covertagents_level"] ? "???" : $enemy_empire->data["taxrate"]));

				$GAME["template"]->TPL->set_var("effectiveness", (rand(0, 4) > $GAME["empire"]->army->data["covertagents_level"] ? "???" : $enemy_empire->army->data["effectiveness"]));

				srand(time(NULL));

				for ($i = 0; $i < count($CONF_PLANETS); $i++) {

					$r = rand(0, 4);
					if ($r > $GAME["empire"]->army->data["covertagents_level"])
						$GAME["template"]->TPL->set_var($CONF_PLANETS[$i] .
						"_planets", "???");
					else
						$GAME["template"]->TPL->set_var($CONF_PLANETS[$i] .
						"_planets", $GAME["template"]->formatNumber($enemy_empire->planets->data[$CONF_PLANETS[$i] . "_planets"]));
				}

				for ($i = 0; $i < count($CONF_UNITS); $i++) {

					$r = rand(0, 4);
					if ($r > $GAME["empire"]->army->data["covertagents_level"])
						$GAME["template"]->TPL->set_var($CONF_UNITS[$i], "???");
					else
						$GAME["template"]->TPL->set_var($CONF_UNITS[$i], $GAME["template"]->formatNumber($enemy_empire->army->data[$CONF_UNITS[$i]]));
				}

				$result .= $GAME["template"]->TPL->process("", "covertop", 2);

		} else {

		$casualties = floor(($GAME["empire"]->army->data["covertagents"] / 100) * 5);
		$result .= LANG_YOUR_COVERTAGENTS_WERE_CAUGHT . " (" . $GAME["template"]->formatNumber($casualties) . ")";
		$GAME["empire"]->army->data["covertagents"] -= $casualties;

		$evt = new EventCreator($DB);
		$evt->from = $GAME["empire"]->data["id"];
		$evt->to = $empire;
		$evt->type = CONF_EVENT_SPYCAUGHT;
		$evt->params = array (
			"opname" => $CONF_COVERT_OPERATIONS[$operation]["name"],
			"empire_id" => $GAME["empire"]->data["id"],
			"empire_name" => $GAME["empire"]->data["name"],
			"empire_emperor" => $GAME["empire"]->data["emperor"],
			"gender" => $GAME["empire"]->data["gender"]
		);
		$evt->send();

	}

	$GAME["empire"]->data["credits"] -= $CONF_COVERT_OPERATIONS[$operation]["cost_credits"];
	$GAME["empire"]->army->data["covert_points"] -= $CONF_COVERT_OPERATIONS[$operation]["cost_points"];

	$GAME["empire"]->save();
	$enemy_empire->save();

	$evt = new EventCreator($DB);
	$evt->from = -1;
	$evt->to = $GAME["empire"]->data["id"];
	$evt->type = CONF_EVENT_COVERTOP_RESULT;
	$evt->params = array (
		"result" => $result
	);
	$evt->send();

	$GAME["system"]->redirect("covert.php");
}

////////////////////////////////////////////////////////////////////////////////
// Display page
////////////////////////////////////////////////////////////////////////////////
$GAME["template"]->setPage("covert.html");

/* Populate empires */
$empires = array ();
$rs = $DB->Execute("SELECT * FROM tb_empire WHERE active=1 AND admin=0 AND protection_turns_left = 0 ORDER BY emperor ASC");
while (!$rs->EOF) {
	if ($rs->fields["id"] != $GAME["empire"]->data["id"]) {

		$empire = array ();
		$empire["id"] = $rs->fields["id"];
		$empire["name"] = $GAME["template"]->displayEmpire($rs->fields["emperor"], $rs->fields["name"], false);

		$rs2 = $DB->Execute("SELECT tb_coalition.name FROM tb_member,tb_coalition WHERE tb_member.empire=" . $rs->fields["id"] . " AND tb_member.coalition = tb_coalition.id");
		if (!$rs2->EOF)
			$empire["name"] .= " [" . $rs2->fields["name"] . "]";

		$empires[] = $empire;

	}

	$rs->MoveNext();
}

$GAME["template"]->setLoop("empires", $empires);

/* Populate operations */
$operations = array ();
for ($i = 0; $i < count($CONF_COVERT_OPERATIONS); $i++) {
	$op = array ();
	$op["id"] = $i;
	$op["name"] = $CONF_COVERT_OPERATIONS[$i]["name"] . " (COST: " . $GAME["template"]->formatNumber($CONF_COVERT_OPERATIONS[$i]["cost_points"]) . " points, " . $GAME["template"]->FormatNumber($CONF_COVERT_OPERATIONS[$i]["cost_credits"]) . " cr.)";

	$operations[] = $op;
}
$GAME["template"]->setLoop("operations", $operations);

$GAME["template"]->setVar("covert_points", $GAME["empire"]->army->data["covert_points"]);

print $GAME["template"]->render();
?> 
