<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

require_once("include/init.php");
require_once("include/init_ingame.php");


//////////////////////////////////////////////////////////////////////
// Handle request
//////////////////////////////////////////////////////////////////////

/* Kicked from coalition */
if (isset($_GET["coalition_transferownership"]))
{
		if (!$GAME["empire"]->coalition->isOwner()) $GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_YOU_NEED_TO_BE_THE_OWNER));
		
		$GAME["empire"]->coalition->transferOwnership($_GET["coalition_transferownership"]);		
}

/* Kicked from coalition */
if (isset($_GET["coalition_kick"]))
{
	$id = $_GET["coalition_kick"];
	
	if (!$GAME["empire"]->coalition->isMember()) 
		$GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_YOU_NEED_TO_BE_IN_A_COALITION));
	
	if (($_SESSION["empire_id"] != $id) && (!$GAME["empire"]->coalition->isOwner()))
		$GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_YOU_NEED_TO_BE_THE_OWNER));
	
	if (!$GAME["empire"]->coalition->isMemberFromId($id)) 
		$GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_INVALID_EMPIRE_ID));
	
	if ($GAME["empire"]->coalition->isOwnerFromId($id)) 
		$GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_CANT_KICK_COALITION_OWNER));

	$rs = $DB->Execute("SELECT * FROM tb_empire WHERE id=".$id);
	if ($rs->EOF) 
			$GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_INVALID_EMPIRE_ID));

	$GAME["empire"]->coalition->kickMember($id);
	$GAME["system"]->redirect("diplomacy.php",array("NOTICE",LANG_EMPIRE_KICKED_FROM_COALITION));
}

/* Accept to join a coalition */
if (isset($_GET["coalition_yes"]))
{

	$id = $_GET["coalition_yes"];

	$rs = $DB->Execute("SELECT * FROM tb_member WHERE empire=".addslashes($id)." AND level=1");
	if ($rs->EOF) $GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_INVALID_COALITION_ID));
	$rs = $DB->Execute("SELECT * FROM tb_coalition WHERE id=".$rs->fields["coalition"]);
	
	if (isset($_SESSION["member"])) $GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_INVALID_IN_A_COALITION));
	
	
	$count = $DB->Execute("SELECT COUNT(*) FROM tb_member WHERE coalition=".$rs->fields["id"]);
	$count = $count->fields[0];
	if ($count > CONF_MAXIMUM_COALITION_MEMBERS) {
		$GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_THE_COALITION_IS_FULL));	
	}
	
	$query = "INSERT INTO tb_member (date,empire,coalition,level)
	VALUES(
	".time(NULL).",
	".$GAME["empire"]->data["id"].",
	".$rs->fields["id"].",
	0
	);";

	$DB->Execute($query);

	// etablish a default treaty [major alliance] to every member
	$rs2 = $DB->Execute("SELECT * FROM tb_member WHERE coalition=".$rs->fields["id"]." AND empire <> ".$GAME["empire"]->data["id"]);	
	while(!$rs2->EOF)
	{
		
		$DB->Execute("DELETE FROM tb_treaty WHERE empire_from=".$GAME["empire"]->data["id"]." AND empire_to=".$rs2->fields["empire"]);	
		$DB->Execute("DELETE FROM tb_treaty WHERE empire_to=".$GAME["empire"]->data["id"]." AND empire_from=".$rs2->fields["empire"]);	
		
		$DB->Execute("INSERT INTO tb_treaty (empire_from,empire_to,type,date,status) VALUES(".$GAME["empire"]->data["id"].",".$rs2->fields["empire"].",2,".time(NULL).",".CONF_TREATY_ACCEPTED.")");
		$rs2->MoveNext();
		
	}

	$query = "DELETE FROM tb_event WHERE event_to=".$GAME["empire"]->data["id"]." AND event_from=".addslashes($id)." AND event_type=".CONF_EVENT_COALITION_INVITE.";";	
	$DB->Execute($query);
	$query = "DELETE FROM tb_event WHERE event_to=".addslashes($id)." AND event_from=".$GAME["empire"]->data["id"]." AND event_type=".CONF_EVENT_COALITION_INVITE.";";	
	$DB->Execute($query);
	

	$evt = new EventCreator($DB);
	$evt->type = CONF_EVENT_COALITION_JOINED;
	$evt->from = $GAME["empire"]->data["id"];
	$evt->to = addslashes($id);
	$evt->params  = array("empire_id"=>$GAME["empire"]->data["id"],"empire_name"=>$GAME["empire"]->data["name"],"empire_emperor"=>$GAME["empire"]->data["emperor"],"gender"=>$GAME["empire"]->data["gender"]);
	$evt->send();	

	$GAME["system"]->redirect("diplomacy.php",array("NOTICE"=>LANG_COALITION_INVITATION_ACCEPTED));
	

}


/* Decline a invitation */
if (isset($_GET["coalition_no"]))
{
	$id = $_GET["coalition_no"];


	$query = "DELETE FROM tb_event WHERE event_to=".$GAME["empire"]->data["id"]." AND event_from=".addslashes($id)." AND event_type=".CONF_EVENT_COALITION_INVITE.";";	
	$DB->Execute($query);
	$query = "DELETE FROM tb_event WHERE event_to=".addslashes($id)." AND event_from=".$GAME["empire"]->data["id"]." AND event_type=".CONF_EVENT_COALITION_INVITE.";";	
	$DB->Execute($query);


	$evt = new EventCreator($DB);
	$evt->type = CONF_EVENT_COALITION_REFUSED;
	$evt->from = $GAME["empire"]->data["id"];
	$evt->to = addslashes($id);
	$evt->params  = array("empire_id"=>$GAME["empire"]->data["id"],"empire_name"=>$GAME["empire"]->data["name"],"empire_emperor"=>$GAME["empire"]->data["emperor"],"gender"=>$GAME["empire"]->data["gender"]);
	$evt->send();	
	
	
	$GAME["system"]->redirect("diplomacy.php",array("NOTICE"=>LANG_COALITION_INVITATION_REFUSED));
			

}


/* Invite someone into a coalition */
if (isset($_POST["coalition_invite"]))
{
	
	if (!$GAME["empire"]->coalition->isOwner())
		$GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_YOU_NEED_TO_BE_THE_OWNER));

	$rs = $DB->Execute("SELECT * FROM tb_empire WHERE admin=0 AND active=1 AND id=".addslashes($_POST["coalition_invite"]));
		
	if ($rs->EOF) {
		$GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_INVALID_EMPIRE_ID));
	}
	
	$rs2 = $DB->Execute("SELECT * FROM tb_member WHERE empire=".addslashes($_POST["coalition_invite"]));
	if (!$rs2->EOF) {
		$GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_THIS_MEMBER_IS_ALREADY_IN_ANOTHER_COALITION));	
	}

	$count = $DB->Execute("SELECT COUNT(*) FROM tb_member WHERE coalition=".$rs->fields["id"]);
	$count = $count->fields[0];
	if ($count > CONF_MAXIMUM_COALITION_MEMBERS) {
		$GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_THE_COALITION_IS_FULL));	
	}

	
	$evt = new EventCreator($DB);
	$evt->type = CONF_EVENT_COALITION_INVITE;
	$evt->from = $_SESSION["empire_id"];
	$evt->to = $_POST["coalition_invite"];
	$evt->sticky = 1;
	$evt->params  = array("empire_id"=>$GAME["empire"]->data["id"],"empire_name"=>$GAME["empire"]->data["name"],"empire_emperor"=>$GAME["empire"]->data["emperor"],"gender"=>$GAME["empire"]->data["gender"],"coalition_name"=>$GAME["empire"]->coalition->data["name"]);
	$evt->send();
	
	
	$GAME["system"]->redirect("diplomacy.php",array("NOTICE"=>LANG_COALITION_INVITATION_SENT));

}

/* Disband your coalition */
if (isset($_GET["disband_coalition"]))
{
	
	if (!$GAME["empire"]->coalition->isMember()) 
		$GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_YOU_NEED_TO_BE_IN_A_COALITION));
	
	if (!$GAME["empire"]->coalition->isOwner())
		$GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_YOU_NEED_TO_BE_THE_OWNER));

	$GAME["empire"]->coalition->disband();
	$GAME["system"]->redirect("diplomacy.php",array("NOTICE"=>LANG_COALITION_DISBANDED));
}

/* Create a new coalition */
if (isset($_POST["coalition_name"]))
{
	if ($GAME["empire"]->coalition->isMember()) {
		$GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_ALREADY_IN_A_COALITION));
	}

	$coalition_name = stripslashes($_POST["coalition_name"]);
	if ($coalition_name == "") {
		$GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_INVALID_COALITION_NAME));
	}
	
	$rs = $DB->Execute("SELECT * FROM tb_coalition WHERE name='".addslashes($coalition_name)."'");
	if (!$rs->EOF) {
		$GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_COALITION_NAME_ALREADY_USED));
	}
	
	
	$GAME["empire"]->coalition->create($coalition_name,$_SESSION["empire_id"]);	
	
	$GAME["system"]->redirect("diplomacy.php",array("NOTICE"=>LANG_NEW_COALITION_CREATED));
}

/* Break a active treaty */
if (isset($_GET["break"]))
{
	$treaty_data = $GAME["empire"]->diplomacy->getTreaty($_GET["break"]);
	if ($treaty_data == null) {
		$GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_INVALID_TREATY_ID));
		
	}
	

	if ($treaty_data["status"] == CONF_TREATY_BREAK_PENDING) 
	{
		$GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_YOU_CANT_BREAK_A_PENDING_PROPOSAL));
	} else {
	
		if ($treaty_data["status"] == CONF_TREATY_ACCEPT_PENDING)
		{
			$GAME["empire"]->diplomacy->deleteTreaty($_GET["break"]);
		} else {
			
			$target_id = $treaty_data["empire_from"];
			if ($target_id == $_SESSION["empire_id"]) $target_id = $treaty_data["empire_to"];
			
			$GAME["empire"]->diplomacy->breakTreaty($_GET["break"],$GAME["empire"]->data,$target_id);
		}

	
	}
	
	$GAME["system"]->redirect("diplomacy.php",array("NOTICE"=>LANG_TREATY_SUCCESSFULLY_BREAKED));
	
	
}

/* Accept a treaty */
if (isset($_GET["yes"]))
{

	$id = $_GET["yes"];

	$query = "UPDATE tb_treaty SET status=".CONF_TREATY_ACCEPTED." WHERE empire_from=".$_SESSION["empire_id"]." AND empire_to=".addslashes($id)." AND status=".CONF_TREATY_ACCEPT_PENDING;
	$DB->Execute($query);
	$query = "UPDATE tb_treaty SET status=".CONF_TREATY_ACCEPTED." WHERE empire_from=".addslashes($id)." AND empire_to=".$_SESSION["empire_id"]." AND status=".CONF_TREATY_ACCEPT_PENDING;
	$DB->Execute($query);

	$query = "DELETE FROM tb_event WHERE event_to=".$_SESSION["empire_id"]." AND event_from=".addslashes($id)." AND event_type=".CONF_EVENT_PENDINGTREATY.";";	
	$DB->Execute($query);
	$query = "DELETE FROM tb_event WHERE event_to=".addslashes($id)." AND event_from=".$_SESSION["empire_id"]." AND event_type=".CONF_EVENT_PENDINGTREATY.";";	
	$DB->Execute($query);
	

	$evt = new EventCreator($DB);
	$evt->type = CONF_EVENT_ACCEPTEDTREATY;
	$evt->from = $_SESSION["empire_id"];
	$evt->to = $id;
	$evt->params = array("empire_id"=>$GAME["empire"]->data["id"],"empire_name"=>$GAME["empire"]->data["name"],"empire_emperor"=>$GAME["empire"]->data["emperor"],"gender"=>$GAME["empire"]->data["gender"]);	
	$evt->send();
			

	$GAME["system"]->redirect("diplomacy.php",array("NOTICE"=>LANG_TREATY_SUCCESSFULLY_ACCEPTED));	

}


/* Refuse a treaty */
if (isset($_GET["no"]))
{
	$id = $_GET["no"];

	$query = "DELETE FROM tb_treaty WHERE empire_from=".$_SESSION["empire_id"]." AND empire_to=".addslashes($id);
	$DB->Execute($query);
	$query = "DELETE FROM tb_treaty WHERE empire_from=".addslashes($id)." AND empire_to=".$_SESSION["empire_id"];
	$DB->Execute($query);

	$query = "DELETE FROM tb_event WHERE event_to=".$_SESSION["empire_id"]." AND event_from=".addslashes($id)." AND event_type=".CONF_EVENT_PENDINGTREATY.";";	
	$DB->Execute($query);
	$query = "DELETE FROM tb_event WHERE event_to=".addslashes($id)." AND event_from=".$_SESSION["empire_id"]." AND event_type=".CONF_EVENT_PENDINGTREATY.";";	
	$DB->Execute($query);


	$evt = new EventCreator($DB);
	$evt->type = CONF_EVENT_REFUSEDTREATY;
	$evt->from = $_SESSION["empire_id"];
	$evt->to = $id;
	$evt->params = array("empire_id"=>$GAME["empire"]->data["id"],"empire_name"=>$GAME["empire"]->data["name"],"empire_emperor"=>$GAME["empire"]->data["emperor"],"gender"=>$GAME["empire"]->data["gender"]);	
	$evt->send();
	
	$GAME["system"]->redirect("diplomacy.php");	

}

/* Propose a treaty */
if (isset($_POST["treaty"]))
{
	if (!isset($_POST["empire"])) {
		$GAME["system"]->redirect("diplomay.php",array("WARNING"=>LANG_NO_EMPIRE_SELECTED));	
	}
	
	$rs = $DB->Execute("SELECT * FROM tb_empire WHERE admin=0 AND active=1 AND id=".addslashes($_POST["empire"]));
	if ($rs->EOF) {
		$GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_INVALID_EMPIRE_ID));
	}
	
	if ($rs->fields["id"] == $_SESSION["empire_id"]) {
		$GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_INVALID_EMPIRE_ID));
	}


	if (($_POST["treaty"] < 0) || ($_POST["treaty"] > (count($CONF_DIPLOMACY_TREATIES)-1)))
	{
		$GAME["system"]->redirect("diplomacy.php",array("WARNING"=>LANG_INVALID_TYPE_OF_TREATY));
	}

	$already = $GAME["empire"]->diplomacy->treatyFrom($_POST["empire"]);
	

	if ($already != null) {
		$GAME["system"]->redirect("diplomacy.php",array("NOTICE"=>LANG_ANOTHER_TREATY_IS_ACTIVE));
	}

	$GAME["empire"]->diplomacy->sendTreaty($_POST["treaty"],$GAME["empire"]->data,$rs->fields);
	$GAME["system"]->redirect("diplomacy.php",array("NOTICE"=>LANG_TREATY_PROPOSITION_SENT));
	
}


////////////////////////////////////////////////////////////////
// Render page
////////////////////////////////////////////////////////////////

$GAME["template"]->setPage("diplomacy.html");


/* Populate treaties */
$treaties = array();
for ($i=0;$i<count($CONF_DIPLOMACY_TREATIES);$i++)
{
	$treaty = array();
	$treaty["id"] = $i;
	$treaty["name"] = $CONF_DIPLOMACY_TREATIES[$i];		
	
	$treaties[] = $treaty;
}

$GAME["template"]->setLoop("treaties",$treaties);


/* Populate active treaties */
$listing = array();

for ($i=0;$i<count($GAME["empire"]->diplomacy->data);$i++)
{
	$item = array();
	$item["empire"] = $GAME["empire"]->diplomacy->data[$i]["empire_from"];
	if ($_SESSION["empire_id"] == $item["empire"]) 
		$item["empire"] = $GAME["empire"]->diplomacy->data[$i]["empire_to"];
	
	$rs = $DB->Execute("SELECT * FROM tb_empire WHERE id=".$item["empire"]);
	
	$item["empire"] = $rs->fields["emperor"]."@".$rs->fields["name"];
	$item["empire_id"] = $rs->fields["id"];

	$item["treaty"] = $CONF_DIPLOMACY_TREATIES[$GAME["empire"]->diplomacy->data[$i]["type"]];
	
	$item["bgcolor"] =  ($i % 2 == 0?"#667777":"#778888");
	$item["background"] =  ($i % 2 == 0?"images/background2.jpg":"images/background3.jpg");

	$item["date"] =  $GAME["template"]->formatTime(time(NULL) - $GAME["empire"]->diplomacy->data[$i]["date"]);
	$item["status"] = LANG_UNKNOWN;
	if ($GAME["empire"]->diplomacy->data[$i]["status"] == CONF_TREATY_ACCEPT_PENDING) $item["status"] = LANG_ACCEPT_PENDING;
	if ($GAME["empire"]->diplomacy->data[$i]["status"] == CONF_TREATY_ACCEPTED) $item["status"] = LANG_ACTIVE;
	if ($GAME["empire"]->diplomacy->data[$i]["status"] == CONF_TREATY_BREAK_PENDING) $item["status"] = LANG_BREAK_PENDING;

	$item["id"] = $GAME["empire"]->diplomacy->data[$i]["id"];
	$listing[] = $item;

}

$GAME["template"]->setLoop("listing",$listing);


/* Populate empires */

$empires = array();
$rs = $DB->Execute("SELECT * FROM tb_empire WHERE admin=0 AND active=1 ORDER BY emperor ASC");
while (!$rs->EOF)
{
	if ($rs->fields["id"] != $_SESSION["empire_id"]) {

		if ($GAME["empire"]->diplomacy->treatyFrom($rs->fields["id"]) == null) {

			$empire = array();
			$empire["id"] = $rs->fields["id"];
			$empire["name"] = $GAME["template"]->displayEmpire($rs->fields["emperor"],$rs->fields["name"],$GAME["empire"]->data["networth"]);
			
			$rs2 = $DB->Execute("SELECT tb_coalition.name FROM tb_member,tb_coalition WHERE tb_member.empire=".$rs->fields["id"]." AND tb_member.coalition = tb_coalition.id");
			if (!$rs2->EOF) $empire["name"] .= " [".$rs2->fields["name"]."]";
			
			$empires[] = $empire;
		}
	}

	$rs->MoveNext();
}

$GAME["template"]->setLoop("empires",$empires);

/* Create coalition form */
if (!$GAME["empire"]->coalition->isMember())
{
	$GAME["template"]->setVar("form_coalition_create",$GAME["template"]->TPL->process("","form_coalition_create_block",2));
	$GAME["template"]->setVar("form_coalition_manage","");
 	$GAME["template"]->setVar("form_coalition_invite","");

}
else
{
	
	$GAME["template"]->setVar("form_coalition_create","");
	$GAME["template"]->setVar("coalition_name",$GAME["empire"]->coalition->data["name"]);
	$GAME["template"]->setVar("coalition_logo",$GAME["empire"]->coalition->data["logo"]);

	////////////////////////////////////////////////////////////////
	// Populate active members
	////////////////////////////////////////////////////////////////
	$coalition_listing = array();

	$all_members = $GAME["empire"]->coalition->members;
	$all_members[] = $GAME["empire"]->coalition->member;
	
	for ($i=0;$i<count($all_members);$i++)
	{
		$item = array();
	
		$rs = $DB->Execute("SELECT * FROM tb_empire WHERE id=".$all_members[$i]["empire"]);

		$item["empire"] = $rs->fields["emperor"]."@".$rs->fields["name"];
		$item["empire_id"] = $rs->fields["id"];

		$item["bgcolor"] =  ($i % 2 == 0?"#667777":"#778888");
		$item["background"] =  ($i % 2 == 0?"images/background2.jpg":"images/background3.jpg");

		$item["date"] = $GAME["template"]->formatTime(time(NULL) - $all_members[$i]["date"]);
		$item["status"] = LANG_MEMBER;
		if ($all_members[$i]["level"] == 1) $item["status"] = LANG_OWNER;
		$item["id"] = $all_members[$i]["id"];
		$coalition_listing[] = $item;
		$rs->MoveNext();

	}

	$GAME["template"]->setLoop("coalition_listing",$coalition_listing);
	$GAME["template"]->setVar("form_coalition_manage",$GAME["template"]->TPL->process("","form_coalition_manage_block",2));
	
	if ($GAME["empire"]->coalition->isMember())
	{

		/* Populate empires */
		$empires_coalition = array();
		$rs = $DB->Execute("SELECT * FROM tb_empire WHERE admin=0 AND active=1 ORDER BY emperor ASC");
		while (!$rs->EOF)
		{
			if ($rs->fields["id"] != $_SESSION["empire_id"]) {

				$rs2 = $DB->Execute("SELECT * FROM tb_member WHERE empire=".$rs->fields["id"]);

				if ($rs2->EOF) {
					$empire = array();
					$empire["id"] = $rs->fields["id"];
					$empire["name"] = $GAME["template"]->displayEmpire($rs->fields["emperor"],$rs->fields["name"],$GAME["empire"]->data["networth"]);
					$empires_coalition[] = $empire;
				}
			}
			$rs->MoveNext();
		}


		$GAME["template"]->setLoop("empires_coalition",$empires_coalition);

		$GAME["template"]->setVar("form_coalition_invite",$GAME["template"]->TPL->process("","form_coalition_invite_block",2));

	} else {
		$GAME["template"]->setVar("form_coalition_invite","");
	}

}


print $GAME["template"]->render();

?> 
