<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

require_once("include/init.php");
require_once("include/init_ingame.php");


$prices = $GAME["gameplay_costs"]->getFoodPrices();

///////////////////////////////////////////////////////////////////////////////
// Handle requests
///////////////////////////////////////////////////////////////////////////////

if (isset($_GET["sell"]))
{
	$sell = floor($_GET["sell"]);
	
	if ($GAME["empire"]->data["food_traded"] == 1) {
		$GAME["system"]->redirect("foodmarket.php",array("WARNING"=>LANG_ALREADY_TRADED_FOOD));
	}
	
	if (($sell < 0) || ($sell > $GAME["empire"]->data["food"]))
	{
		$GAME["system"]->redirect("foodmarket.php",array("WARNING"=>LANG_INVALID_FOOD_QUANTITY));
	}

	$GAME["empire"]->data["credits"] += ($sell * ($prices["sell"]));
	$GAME["empire"]->data["food"] -= $sell;
	$GAME["empire"]->data["food_traded"] = 1;
	$GAME["empire"]->save();

	$GAME["template"]->coord["food"] += $sell;
		
	$query = "UPDATE tb_coordinator SET food=".$GAME["template"]->coord["food"];
	$DB->Execute($query);


	$notice = LANG_FOOD_SOLD;
	$notice = str_replace("{qty}",$GAME["template"]->formatFood($sell),$notice);
	$notice = str_replace("{credits}",$GAME["template"]->formatCredits($sell*$prices["sell"]),$notice);
	$GAME["system"]->redirect("foodmarket.php",array("NOTICE"=>$notice));
}



if (isset($_GET["buy"]))
{
	
	$buy = floor($_GET["buy"]);
		
	if ($GAME["empire"]->data["food_traded"] == 1) {
		$GAME["system"]->redirect("foodmarket.php",array("WARNING"=>LANG_ALREADY_TRADED_FOOD));
	}
	
	if (($buy < 0) || 
		($buy > $GAME["template"]->coord["food"]) ||
	 	($buy > floor($GAME["empire"]->data["credits"]/$prices["buy"])))
	{
		$GAME["system"]->redirect("foodmarket.php",array("WARNING"=>LANG_INVALID_FOOD_QUANTITY));
	}
	
	
	$GAME["empire"]->data["credits"] -= ($buy * ($prices["buy"]));
	$GAME["empire"]->data["food"] += $buy;
	$GAME["empire"]->data["Food_traded"] = 1;
	$GAME["empire"]->save();

	$GAME["template"]->coord["food"] -= $buy;
		
	$query = "UPDATE tb_coordinator SET food=".$GAME["template"]->coord["food"];
	$DB->Execute($query);


	$notice = LANG_FOOD_BOUGHT;
	$notice = str_replace("{qty}",$GAME["template"]->formatFood($buy),$notice);
	$notice = str_replace("{credits}",$GAME["template"]->formatCredits($buy*$prices["buy"]),$notice);
	$GAME["system"]->redirect("foodmarket.php",array("NOTICE"=>$notice));
}


///////////////////////////////////////////////////////////////////////////////
// Display page
///////////////////////////////////////////////////////////////////////////////

$GAME["template"]->setPage("foodmarket.html");
$GAME["template"]->setVar("foodmarket_available",$GAME["template"]->formatFood($GAME["template"]->coord["food"]));
$GAME["template"]->setVar("foodmarket_demand",$prices["demand"]);
$GAME["template"]->setVar("foodmarket_buy",$GAME["template"]->formatCredits($prices["buy"]));
$GAME["template"]->setVar("foodmarket_sell",$GAME["template"]->formatCredits($prices["sell"]));

$maxfood = floor($GAME["empire"]->data["credits"] /  $prices["buy"]);
if ($maxfood > $GAME["template"]->coord["food"]) $maxfood = $GAME["template"]->coord["food"];

$GAME["template"]->setVar("food_buy_max",$GAME["template"]->formatNumber($maxfood));
$GAME["template"]->setVar("food_sell_max",$GAME["template"]->formatNumber($GAME["empire"]->data["food"]));

print $GAME["template"]->render();

?> 
