<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

require_once("include/init.php");

if ($GAME["template"]->coord["game_status"]==1)
if (time(NULL) >= $GAME["template"]->coord["restart_date"]) {

        $GAME["system"]->Reset();
	$GAME["system"]->redirect("login.php");
}


if ($GAME["session"]->isActive()) $GAME["empire"]->load($_SESSION["empire_id"]);

$GAME["template"]->setPage("hall_of_fame.html");
$GAME["template"]->setVar("game_status",($GAME["template"]->coord["game_status"]==0?LANG_GAME_STATUS_ACTIVE:LANG_GAME_STATUS_ENDED));

if ($GAME["template"]->coord["game_status"]==0)
	$GAME["template"]->setVar("restart_date","<a href=\"login.php\">Started</a>");
else {
	$GAME["template"]->setVar("restart_date",$GAME["template"]->formatTime($GAME["template"]->coord["restart_date"]-time(NULL)));
}
$rs = $DB->Execute("SELECT * FROM tb_hall_of_fame ORDER BY id DESC LIMIT 0,5");

$games = array();

while(!$rs->EOF)
{
	$game = $rs->fields;
	$game["date"] = date("m/d/Y",$game["date"]);
	$game["elapsed"] = round($game["elapsed"]/(60*60*24),2);
	$game["gold_networth"] = $GAME["template"]->formatNumber($game["gold_networth"]);
	$game["silver_networth"] = $GAME["template"]->formatNumber($game["silver_networth"]);
	$game["bronze_networth"] = $GAME["template"]->formatNumber($game["bronze_networth"]);
	$games[] = $game;
	$rs->MoveNext();
}

$GAME["template"]->setLoop("games",$games);
print $GAME["template"]->render();

?>
