<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

require_once("include/init.php");
require_once("include/init_ingame.php");


ob_clean();

header("Content-type: image/jpeg");

if (!isset($_GET["data"])) die();

$data = $_GET["data"];

$data = explode(",",$data);
if (count($data) != 40) die();

$gd = imagecreatetruecolor(600,100);
$color_white = imagecolorallocate($gd,255,255,255);
$color_gray = imagecolorallocate($gd,80,100,100);
$color_gray2 = imagecolorallocate($gd,130,130,130);
$color_black = imagecolorallocate($gd,0,0,0);
$color_red = imagecolorallocate($gd,255,100,100);
$color_green = imagecolorallocate($gd,0,255,255);
$color_darkgreen = imagecolorallocate($gd,255,255,255);
$color_darkred = imagecolorallocate($gd,50,200,200);
$color_blue = imagecolorallocate($gd,0,0,255);

imagefilledrectangle($gd,0,0,600,100,$color_green);
imagefilledrectangle($gd,1,1,598,98,$color_gray);

$max = 0;
for ($i=0;$i<40;$i++)
{
	if ($data[$i] <= 0) $data[$i] = 1;
	if ($data[$i] > $max) $max = $data[$i];
}

for ($i=0;$i<40;$i++)
{


	imageline($gd,7+($i*15),1,7+($i*15),99,$color_gray2);
	if ($i != 0)
	{
		$d1 = $data[$i-1];
		$d2 = $data[$i];
		$d1 /= $max;
		$d2 /= $max;
		$pos1 = round($d1*80);
		$pos2 = round($d2*80);
		$pos1 = 90-$pos1;
		$pos2 = 90-$pos2;

		if ($pos1 >= $pos2)
		{
			imageline($gd,7+(($i-1)*15),$pos1-1,7+($i*15),$pos2-1,$color_darkgreen);
			imageline($gd,7+(($i-1)*15),$pos1,7+($i*15),$pos2,$color_darkgreen);
			imageline($gd,7+(($i-1)*15),$pos1+1,7+($i*15),$pos2+1,$color_darkgreen);
		}
		else
		{
			imageline($gd,7+(($i-1)*15),$pos1-1,7+($i*15),$pos2-1,$color_darkred);
			imageline($gd,7+(($i-1)*15),$pos1,7+($i*15),$pos2,$color_darkred);
		}	imageline($gd,7+(($i-1)*15),$pos1+1,7+($i*15),$pos2+1,$color_darkred);
	
	}
}

imagejpeg($gd,"",$GAME["empire"]->data["jpeg_quality"]);
imagedestroy($gd);
	

?>