<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

require_once("include/init.php");
require_once("include/init_ingame.php");

if (!isset($_GET["data"])) die();

function imageSmoothArc( &$img, $cx, $cy, $w, $h, $color, $start, $stop) {
    // Written from scratch by Ulrich Mierendorff, 06/2006
    $fillColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 0 );
    $w /= 2;
    $h /= 2;
    $cdx = $w * cos(M_PI/4);
    $cdy = $h * sin(M_PI/4);
    
    $xStart = $w * cos($start);
    $yStart = $h * sin($start);
    $xStop = $w * cos(min(M_PI,$stop));
    $yStop = $h * sin(min(M_PI,$stop));
    if ( $start < M_PI/2 ) {
        $yy = 0;
        for ( $x = 0; $x <= $xStart; $x += 1 ) {
            if ( $x < $xStop ) {
                $y1 = $x/$xStop*$yStop;
            } else {
                $y1 = $h * sqrt( 1 - pow( $x,2 ) / pow( $w,2 ) );
            }
            $y2 = $x/$xStart*$yStart;
            $d1 = $y1 - floor($y1);
            $d2 = $y2 - floor($y2);
            $y1 = floor($y1);
            $y2 = floor($y2);
            imageLine($img, $cx + $x, $cy - $y1, $cx + $x, $cy - $y2, $fillColor);
            $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d1*100 );
            imageSetPixel($img, $cx + $x, $cy - $y1 - 1, $diffColor);
            $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], $d2*100 );
            imageSetPixel($img, $cx + $x, $cy - $y2 + 1, $diffColor);
            for ( $yy; $yy <= $y1; $yy += 1 ) {
                if ( $yy < $yStart ) {
                    $x1 = $yy/$yStart*$xStart;
                } else {
                    $x1 = $w * sqrt( 1 - pow( $yy,2 ) / pow( $h,2 ) );
                }
                $d1 = $x1 - floor($x1);
                $x1 = floor($x1);
                $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d1*100 );
                imageSetPixel($img, $cx + $x1 + 1, $cy - $yy, $diffColor);
                if ($stop < M_PI/2) {
                    $x2 = $yy/$yStop*$xStop;
                    $d2 = $x2 - floor($x2);
                    $x2 = floor($x2);
                    $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], $d2*100 );
                    imageSetPixel($img, $cx + $x2, $cy - $yy, $diffColor);
                }
            }
        }
    }
    if ( $start < M_PI && $stop > M_PI/2 ) {
        $yy = 0;
        for ( $x = 0; $x >= $xStop; $x -= 1 ) {
            if ( $x > $xStart ) {
                $y1 = $x/$xStart*$yStart;
            } else {
                $y1 = $h * sqrt( 1 - pow( $x,2 ) / pow( $w,2 ) );
            }
            $y2 = $x/$xStop*$yStop;
            $d1 = $y1 - floor($y1);
            $d2 = $y2 - floor($y2);
            $y1 = floor($y1);
            $y2 = floor($y2);
            imageLine($img, $cx + $x, $cy - $y1, $cx + $x, $cy - $y2, $fillColor);
            $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d1*100 );
            imageSetPixel($img, $cx + $x, $cy - $y1 - 1, $diffColor);
            $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], $d2*100 );
            imageSetPixel($img, $cx + $x, $cy - $y2 + 1, $diffColor);
            for ( $yy; $yy <= $y1; $yy += 1 ) {
                if ( $yy < $yStop ) {
                    $x1 = -$yy/$yStop*$xStop;
                } else {
                    $x1 = $w * sqrt( 1 - pow( $yy,2 ) / pow( $h,2 ) );
                }
                $d1 = $x1 - floor($x1);
                $x1 = floor($x1);
                $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d1*100 );
                imageSetPixel($img, $cx - $x1 - 1, $cy - $yy, $diffColor);
                if ( $start > M_PI/2 ) {
                    $x2 = $yy/$yStart*$xStart;
                    $d2 = $x2 - floor($x2);
                    $x2 = floor($x2);
                    $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], $d2*100 );
                    imageSetPixel($img, $cx + $x2, $cy - $yy, $diffColor);
                }
            }
        }
    }
    
    $xStart = $w * cos(max(M_PI,$start));
    $yStart = $h * sin(max(M_PI,$start));
    $xStop = $w * cos($stop);
    $yStop = $h * sin($stop);
    if ( $start < 3*M_PI/2 && $stop > M_PI) {
        $yy = 0;
        for ( $x = 0; $x >= $xStart; $x -= 1 ) {
            if ( $x > $xStop) {
                $y1 = $x/$xStop*$yStop;
            } else {
                $y1 = -$h * sqrt( 1 - pow( $x,2 ) / pow( $w,2 ) );
            }
            $y2 = $x/$xStart*$yStart;
            $d1 = $y1 - floor($y1);
            $d2 = $y2 - floor($y2);
            $y1 = floor($y1);
            $y2 = floor($y2);
            imageLine($img, $cx + $x, $cy - $y1, $cx + $x, $cy - $y2, $fillColor);
            $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], $d1*100 );
            imageSetPixel($img, $cx + $x, $cy - $y1 + 1, $diffColor);
            $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d2*100 );
            imageSetPixel($img, $cx + $x, $cy - $y2 - 1, $diffColor);
            for ( $yy; $yy >= $y1; $yy -= 1 ) {
                if ( $yy > $yStart ) {
                    $x1 = -$yy/$yStart*$xStart;
                } else {
                    $x1 = $w * sqrt( 1 - pow( $yy,2 ) / pow( $h,2 ) );
                }
                $d1 = $x1 - floor($x1);
                $x1 = floor($x1);
                $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d1*100 );
                imageSetPixel($img, $cx - $x1 - 1, $cy - $yy, $diffColor);
                if ($stop < 3*M_PI/2) {
                    $x2 = $yy/$yStop*$xStop;
                    $d2 = $x2 - floor($x2);
                    $x2 = floor($x2);
                    $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d2*100 );
                    imageSetPixel($img, $cx + $x2 + 1, $cy - $yy, $diffColor);
                }
            }
        }
        
    }
    if ( $start < 2*M_PI && $stop > 3*M_PI/2 ) {
        $yy = 0;
        for ( $x = 0; $x <= $xStop; $x += 1 ) {
            if ( $x < $xStart )  {
                $y1 = $x/$xStart*$yStart;
            } else {
                $y1 = -$h * sqrt( 1 - pow( $x,2 ) / pow( $w,2 ) );
            }
            $y2 = $x/$xStop*$yStop;
            $d1 = $y1 - floor($y1);
            $d2 = $y2 - floor($y2);
            $y1 = floor($y1);
            $y2 = floor($y2);
            imageLine($img, $cx + $x, $cy - $y1, $cx + $x, $cy - $y2, $fillColor);
            $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], $d1*100 );
            imageSetPixel($img, $cx + $x, $cy - $y1 + 1, $diffColor);
            $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d2*100 );
            imageSetPixel($img, $cx + $x, $cy - $y2 - 1, $diffColor);
            for ( $yy; $yy >= $y1; $yy -= 1 ) {
                if ( $yy > $yStop ) {
                    $x1 = $yy/$yStop*$xStop;
                } else {
                    $x1 = $w * sqrt( 1 - pow( $yy,2 ) / pow( $h,2 ) );
                }
                $d1 = $x1 - floor($x1);
                $x1 = floor($x1);
                $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d1*100 );
                imageSetPixel($img, $cx + $x1 + 1, $cy - $yy, $diffColor);
                if ( $start > 3*M_PI/2 ) {
                    $x2 = $yy/$yStart*$xStart;
                    $d2 = $x2 - floor($x2);
                    $x2 = floor($x2);
                    $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], $d2*100 );
                    imageSetPixel($img, $cx + $x2 , $cy - $yy, $diffColor);
                }
            }
        }
    }
}


$data = base64_decode($_GET["data"]);

$data = explode(";",$data);

$gd = imagecreatetruecolor(660,200);

$colors = array();
$colors[] = array(array(255,0,0),imagecolorallocate($gd,255,0,0));
$colors[] = array(array(0,255,0),imagecolorallocate($gd,0,255,0));
$colors[] = array(array(255,128,128),imagecolorallocate($gd,255,128,128));
$colors[] = array(array(128,64,128),imagecolorallocate($gd,128,64,128));
$colors[] = array(array(255,255,0),imagecolorallocate($gd,255,255,0));
$colors[] = array(array(0,255,255),imagecolorallocate($gd,0,255,255));
$colors[] = array(array(64,128,128),imagecolorallocate($gd,64,128,128));
$colors[] = array(array(0,0,255),imagecolorallocate($gd,0,0,255));
$colors[] = array(array(128,64,0),imagecolorallocate($gd,128,64,0));
$colors[] = array(array(64,255,128),imagecolorallocate($gd,64,255,128));
$color_white = array(array(255,255,255),imagecolorallocate($gd,255,255,255));
$color_black = array(array(0,0,0),imagecolorallocate($gd,0,0,0));

$DEG2RAD = M_PI / 180;
$offset = 0;

for ($i=0;$i<count($data);$i++)
{
	
	$item = explode(":",$data[$i]);
	$name = $item[0];

	if (count($item) > 1) 
		$value = $item[1];
	else
		$value = 1;

	$angle = floor((360 / 100)*$value);
	$start = $offset * $DEG2RAD;
	$stop = ($offset + $angle) * $DEG2RAD;
	imageSmoothArc($gd,100,100,150,150,$colors[$i][0],$start,$stop);
	$offset += $angle;
	
	$x = 210;
	if ($i >= 5) $x += 210;

	$y = 45+(($i%5)*25);
	imagefilledrectangle($gd,$x+0,$y+0,$x+25,$y+12,$colors[$i][1]);
	imagestring($gd,3,$x+2,$y,floor($value)."%",$color_black[1]);
	imagestring($gd,2,$x+30,$y-2,$name,$color_white[1]);
}



header("Content-type: image/jpeg");
imagejpeg($gd,"",$GAME["empire"]->data["jpeg_quality"]);
imagedestroy($gd);
	

?>