<?php
//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2006.09.01 : ybo : Major code changes, OOP
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

class EventCreator
{
	var $DB;
	var $type;
	var $from;
	var $to;
	var $params;
	var $seen;
	var $sticky;
	var $height;
	

	//////////////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////////////
	function EventCreator($DB)
	{
		$this->DB = $DB;
		$this->sticky = 0;
		$this->seen = 0;
		$this->height = 160;
	}


	//////////////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////////////
	function broadcast()
	{
	
		$query = "SELECT * FROM tb_empire WHERE active=1";
				
		$recipients = $this->DB->Execute($query);		
		while(!$recipients->EOF)
		{
			$query = "INSERT INTO tb_event (event_type,event_from,event_to,params,seen,sticky,date,height) ".
			"VALUES(".$this->type.",".$this->from.",".$recipients->fields["id"].",'".addslashes(serialize($this->params))."',".$this->seen.",".$this->sticky.",".time(NULL).",".$this->height.")";	
			if (!$this->DB->Execute($query)) trigger_error($this->DB->ErrorMsg());
			$recipients->MoveNext();
		}
		
		// garbage collection
		$timeout_unseen = time(NULL) - CONF_UNSEEN_EVENT_TIMEOUT;
		$timeout_seen = time(NULL) - CONF_SEEN_EVENT_TIMEOUT;

		if (!$this->DB->Execute("DELETE FROM tb_event WHERE date < $timeout_unseen AND seen=0")) trigger_error($this->DB->ErrorMsg());
		if (!$this->DB->Execute("DELETE FROM tb_event WHERE date < $timeout_seen AND seen=1")) trigger_error($this->DB->ErrorMsg());
		
	}


	//////////////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////////////
	function send()
	{
		global $GAME;
		if ((isset($GAME["ai_turn"])) && ($GAME["ai_turn"]==true)) return;
		$query = "INSERT INTO tb_event (event_type,event_from,event_to,params,seen,sticky,date,height) ".
		"VALUES(".$this->type.",".$this->from.",".$this->to.",'".addslashes(serialize($this->params))."',".$this->seen.",".$this->sticky.",".time(NULL).",".$this->height.")";	
		if (!$this->DB->Execute($query)) trigger_error($this->DB->ErrorMsg());
			
		
		// garbage collection
		$timeout_unseen = time(NULL) - CONF_UNSEEN_EVENT_TIMEOUT;
		$timeout_seen = time(NULL) - CONF_SEEN_EVENT_TIMEOUT;

		if (!$this->DB->Execute("DELETE FROM tb_event WHERE date < $timeout_unseen AND seen=0")) trigger_error($this->DB->ErrorMsg());
		if (!$this->DB->Execute("DELETE FROM tb_event WHERE date < $timeout_seen AND seen=1")) trigger_error($this->DB->ErrorMsg());
	}
}


?>