<?php
//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2006.09.01 : ybo : Major code changes, OOP
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

class Planets
{

	var $DB;
	var $TEMPLATE;
	var $data;
	var $data_footprint;
	
	///////////////////////////////////////////////////////////////////////
	//
	///////////////////////////////////////////////////////////////////////
	function Planets($DB,$TEMPLATE)
	{
		$this->DB = $DB;
		$this->TEMPLATE = $TEMPLATE;
	}

	///////////////////////////////////////////////////////////////////////
	//
	///////////////////////////////////////////////////////////////////////
	function load($empire_id)
	{
		$this->data = $this->DB->Execute("SELECT * FROM tb_planets WHERE empire=".addslashes($empire_id));	
		if (!$this->data) trigger_error($this->DB->ErrorMsg());
		if ($this->data->EOF) return false;
		$this->data = $this->data->fields;

		$this->data_footprint = md5(serialize($this->data));


		return true;
	}

	///////////////////////////////////////////////////////////////////////
	//
	///////////////////////////////////////////////////////////////////////
	function save()
	{
		if (md5(serialize($this->data)) == $this->data_footprint) return;

		$query = "UPDATE tb_planets SET ";
		reset($this->data);
		while (list($key,$value) = each($this->data))
		{
			if ($key == "id") continue;
			if ($key == "empire") continue;
			if (is_numeric($key)) continue;
			if ((is_numeric($value)) && ($key != "logo"))
				$query .= "$key=$value,";
			else
				$query .= "$key='".addslashes($value)."',";
			
		}

		$query = substr($query,0,strlen($query)-1); // removing remaining ,
		$query .= " WHERE empire=".$this->data["empire"];
		if (!$this->DB->Execute($query)) trigger_error($this->DB->ErrorMsg());

	}


	///////////////////////////////////////////////////////////////////////
	//
	///////////////////////////////////////////////////////////////////////
	function getCount()
	{
		$count = 0;
		$count += $this->data["food_planets"];
		$count += $this->data["ore_planets"];
		$count += $this->data["tourism_planets"];
		$count += $this->data["supply_planets"];
		$count += $this->data["gov_planets"];
		$count += $this->data["edu_planets"];
		$count += $this->data["research_planets"];
		$count += $this->data["urban_planets"];
		$count += $this->data["petro_planets"];
		$count += $this->data["antipollu_planets"];

		return $count;
	}
	
	///////////////////////////////////////////////////////////////////////
	//
	///////////////////////////////////////////////////////////////////////
	function releaseAll()
	{
		$this->DB->BeginTrans();		
		$coord_planets = $this->DB->Execute("SELECT * FROM tb_coordinator");
		if (!$coord_planets) trigger_error($this->DB->ErrorMsg());

		$coord_planets->fields["food_planets"] += $this->data["food_planets"];
		$coord_planets->fields["ore_planets"] += $this->data["ore_planets"];
		$coord_planets->fields["tourism_planets"] += $this->data["tourism_planets"];
		$coord_planets->fields["supply_planets"] += $this->data["supply_planets"];
		$coord_planets->fields["gov_planets"] += $this->data["gov_planets"];
		$coord_planets->fields["edu_planets"] += $this->data["edu_planets"];
		$coord_planets->fields["research_planets"] += $this->data["research_planets"];
		$coord_planets->fields["urban_planets"] += $this->data["urban_planets"];
		$coord_planets->fields["petro_planets"] += $this->data["petro_planets"];
		$coord_planets->fields["antipollu_planets"] += $this->data["antipollu_planets"];
		
		$query = "UPDATE tb_coordinator SET ".
		"food_planets=".$coord_planets->fields["food_planets"].",".
		"ore_planets=".$coord_planets->fields["ore_planets"].",".
		"tourism_planets=".$coord_planets->fields["tourism_planets"].",".
		"supply_planets=".$coord_planets->fields["supply_planets"].",".
		"gov_planets=".$coord_planets->fields["gov_planets"].",".
		"edu_planets=".$coord_planets->fields["edu_planets"].",".
		"research_planets=".$coord_planets->fields["research_planets"].",".
		"urban_planets=".$coord_planets->fields["urban_planets"].",".
		"petro_planets=".$coord_planets->fields["petro_planets"].",".
		"antipollu_planets=".$coord_planets->fields["antipollu_planets"];
		
		if (!$this->DB->Execute($query)) trigger_error($this->DB->ErrorMsg());
		$this->DB->CompleteTrans();

		
		$evt = new EventCreator($this->DB);
		$evt->type = CONF_EVENT_PLANETS_RELEASED;
		$evt->from = -1;
		$empire_data = $this->DB->Execute("SELECT id,emperor,name,gender FROM tb_empire WHERE id=".$this->data["empire"]);
		if (!$empire_data) trigger_error($this->DB->ErrorMsg());
		$empire_data = $empire_data->fields;
		$evt->params  = array("gender"=>$empire_data["gender"],"empire_id"=>$empire_data["id"],"empire_name"=>$empire_data["name"],"empire_emperor"=>$empire_data["emperor"],"planets_data"=>$this->data);
		$evt->broadcast();
		

	}
}


?>
