<?php
//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2006.09.01 : ybo : Major code changes, OOP
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

class Research
{

	var $DB;
	var $TEMPLATE;
	var $tech_data;
	var $tech_done;


	///////////////////////////////////////////////////////////////////////
	//
	///////////////////////////////////////////////////////////////////////
	function Research($DB,$TEMPLATE)
	{
		$this->DB = $DB;
		$this->TEMPLATE = $TEMPLATE;

		$this->tech_data = array();
		$this->tech_done = array();		
	}



	///////////////////////////////////////////////////////////////////////
	//
	///////////////////////////////////////////////////////////////////////
	function load($empire_id)
	{
		$rs = $this->DB->Execute("SELECT * FROM tb_research_tech");	
		if (!$rs) trigger_error($this->DB->ErrorMsg());
		while(!$rs->EOF)
		{
			$this->tech_data[] = $rs->fields;
			$rs->MoveNext();
		}

		$rs = $this->DB->Execute("SELECT * FROM tb_research_done WHERE empire_id=".addslashes($empire_id));	
		if (!$rs) trigger_error($this->DB->ErrorMsg());
		while(!$rs->EOF)
		{
			$this->tech_done[] = $rs->fields["tech_id"];
			$rs->MoveNext();
		}


		return true;
	}


	///////////////////////////////////////////////////////////////////////
	//
	///////////////////////////////////////////////////////////////////////
	function getLevel($level)
	{
		$techs = array();
		for ($i=0;$i<count($this->tech_data);$i++)
		{
			if ($this->tech_data[$i]["level"] == $level) $techs[] = $this->tech_data[$i];	
		}
		
		return $techs;
		
	}

	///////////////////////////////////////////////////////////////////////
	//
	///////////////////////////////////////////////////////////////////////
	function getTechFromId($tech_id)
	{
		for ($i=0;$i<count($this->tech_data);$i++)
		{
			if ($this->tech_data[$i]["id"] == $tech_id) return $this->tech_data[$i];
		}	
	
		return null;
	}	

	///////////////////////////////////////////////////////////////////////
	//
	///////////////////////////////////////////////////////////////////////
	function getGrowthPoints($planets,$production)
	{
		$points = floor(($planets/100) * $production);
		$points *= CONF_RESEARCH_POINTS_PER_PLANET;

		return $points;
	}	
}


?>
