<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2006.09.01 : ybo : Major code changes, OOP
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

class Session {
	var $DB;

	//////////////////////////////////////////////////////////////////////
	// Constructor
	//////////////////////////////////////////////////////////////////////
	function Session($DB) {
		$this->DB = $DB;

		if (isset ($_GET["SESSID"]))
			session_start($_GET["SESSID"]);
		else
			session_start();

		if (isset ($_SESSION["empire_id"])) {

			$rs = $this->DB->Execute("SELECT * FROM tb_session WHERE empire=" . addslashes($_SESSION["empire_id"]));
			if (!$rs) trigger_error($this->DB->ErrorMsg());
			if ($rs->EOF) {
				if (!$this->DB->Execute("INSERT INTO tb_session (empire,lastdate,hostname) " .
				"VALUES(" . addslashes($_SESSION["empire_id"]) . "," .
				time(NULL) . ",'" .
				addslashes($_SERVER["REMOTE_ADDR"]) . "')")) trigger_error($this->DB->ErrorMsg());

			}
			// update session date
			if (!$this->DB->Execute("UPDATE tb_session " .
			"SET lastdate = " . time(NULL) . " WHERE empire=" . addslashes($_SESSION["empire_id"]))) trigger_error($this->DB->ErrorMsg());

		}

		// delete old sessions
		$date_timeout = time(NULL) - CONF_SESSION_TIMEOUT;
		if (!$this->DB->Execute("DELETE FROM tb_session WHERE lastdate < $date_timeout")) trigger_error($this->DB->ErrorMsg());

		$this->UpdateGameStatus();
	}

	//////////////////////////////////////////////////////////////////////
	// Logout of the system
	//////////////////////////////////////////////////////////////////////
	function logout() {
		if (isset ($_SESSION["empire_id"]))
			if (!$this->DB->Execute("DELETE FROM tb_session WHERE empire=".$_SESSION["empire_id"])) trigger_error($this->DB->ErrorMsg());

		session_destroy();
		$_SESSION = null;
	}

	//////////////////////////////////////////////////////////////////////
	// Login of the system
	//////////////////////////////////////////////////////////////////////
	function login($username, $password) {

		global $CONF_PREMIUM_MEMBERS;

		if ($this->getOnlinePLayers() >= CONF_MAX_SESSIONS) {
			if (!in_array($username,$CONF_PREMIUM_MEMBERS))
				die(LANG_TOO_MUCH_PLAYERS_ONLINE);
		}
		
		$empire = $this->DB->Execute("SELECT id FROM tb_empire WHERE email='" . addslashes($username) . "' AND " .
		"password='" . md5($password) . "' AND active > 0");

		if (!$empire) trigger_error($this->DB->ErrorMsg());
		if ($empire->EOF)
			return false;

		$_SESSION["empire_id"] = $empire->fields["id"];
		$_SESSION["email"] = $username;

		if (!$this->DB->Execute("INSERT INTO tb_session (empire,lastdate,hostname) " .
		"VALUES(" . $_SESSION["empire_id"] . "," .
		time(NULL) . ",'" .
		$_SERVER["REMOTE_ADDR"] . "')")) trigger_error($this->DB->ErrorMsg());

		if (!$this->DB->Execute("INSERT INTO tb_log_login (empire,date,hostname) " .
		"VALUES(" . $empire->fields["id"] . "," . time(NULL) . ",'" . addslashes($_SERVER["REMOTE_ADDR"]) . "')")) trigger_error($this->DB->ErrorMsg());

		if (!$this->DB->Execute("UPDATE tb_empire SET timeout_mail_sent=0,last_hostname='" . addslashes($_SERVER["REMOTE_ADDR"]) . "' " .
		"WHERE id=" . $empire->fields["id"])) trigger_error($this->DB->ErrorMsg());

		return true;
	}

	//////////////////////////////////////////////////////////////////////
	// Empire is active?
	//////////////////////////////////////////////////////////////////////
	function isActive() {

		if (!isset ($_SESSION["empire_id"]))
			return 0;

		$empire = $this->DB->Execute("SELECT * FROM tb_empire WHERE id=" . $_SESSION["empire_id"]);
		if (!$empire) trigger_error($this->DB->ErrorMsg());
		return $empire->fields["active"];
	}

	//////////////////////////////////////////////////////////////////////
	// how much online players?
	//////////////////////////////////////////////////////////////////////
	function getOnlinePLayers() {
		$count = $this->DB->Execute("SELECT COUNT(*) FROM tb_session");
		if (!$count) trigger_error($this->DB->ErrorMsg());
		return $count->fields[0];
	}


	//////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////
	function UpdateGameStatus()
	{

		$update_file = false;

		// 60 seconds update
		if ((file_exists("game_status.txt")) && ((time(NULL) - filectime("game_status.txt")>60))) $update_file = true;
		if (!file_exists("game_status.txt")) $update_file = true;


		if (!$update_file) return;

		$fd = fopen("game_status.txt","w");
		if (!$fd) die("Unable to create game_status.txt");

		fwrite($fd,"Server Name: ".CONF_GAME_NAME."\r\n");
		fwrite($fd,"Server Version: ".CONF_GAME_VERSION."\r\n");
		fwrite($fd,"Turns per day: ".CONF_TURNS_PER_DAY."\r\n");
		fwrite($fd,"Protection Turns: ".CONF_PROTECTION_TURNS."\r\n");
		fwrite($fd,"Online Players: ".$this->getOnlinePlayers()."\r\n");
		fwrite($fd,"Premium Required: ".(CONF_GAMETYPE_PREMIUM_ONLY?"True":"False")."\r\n");

		$count = $this->DB->Execute("SELECT COUNT(*) FROM tb_empire WHERE active=1");
		if (!$count) trigger_error($this->DB->ErrorMsg());
		$count = $count->fields[0];

		fwrite($fd,"Registered Players: ".$count."\r\n");
		fwrite($fd,"Max Players: ".CONF_MAXPLAYERS."\r\n");

		$date = $this->DB->Execute("SELECT date FROM tb_coordinator");
		if (!$date) trigger_error($this->DB->ErrorMsg());
		$date = $date->fields[0];

		fwrite($fd,"Date/Timestamp: ".$date."\r\n");

		if (CONF_VICTORY_CONDITION_RESEARCH_RACE) 
			fwrite($fd,"Victory conditions: CLASSIC,RESEARCH\r\n");
		else
			fwrite($fd,"Victory conditions: CLASSIC\r\n");
	
		fclose($fd);

	}


}
?>
