<?php
//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:	http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2006.09.01 : ybo : Major code changes, OOP
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//


class Template
{
	var $DB;
	var $TPL;
	var $page_name;
	var $events_data;
	var $notices_data;
	var $coord;
	var $events_count;
	var $events_height;
	var $ingame;
	
	//////////////////////////////////////////////////////////////////////
	// Constructor
	//////////////////////////////////////////////////////////////////////
	function Template($DB,$TPL)
	{
		
		$this->DB = $DB;
		$this->TPL = $TPL;
		$this->events_data = "";
		$this->events_count = 0;
		$this->notices_data = "";
		$this->coord = $this->DB->Execute("SELECT * FROM tb_coordinator");
		$this->coord = $this->coord->fields;
		$this->ingame = true;
	}

	//////////////////////////////////////////////////////////////////////
	// Set Page
	//////////////////////////////////////////////////////////////////////
	function setPage($page_name)
{	
		$this->TPL->set_file("page",$page_name,TPL_BLOCK);
		$this->page_name = $page_name;

		$file = explode("/",$_SERVER["SCRIPT_FILENAME"]);
		$file = $file[count($file)-1];

		
		if ((isset($_SESSION["empire_id"])) && 
		($file != "login.php")  && 
		($file != "register.php")  && 
		($file != "register_complete.php")  && 
		($file != "galaxypedia.php") && 
		($file != "scoreboard.php")&& 
		($file != "starmap.php")&& 
		($file != "shoutbox.php")&& 
		($file != "newspaper.php")&& 
		($file != "show_active.php")&& 
		($file != "show_empire.php")&& 
		($file != "show_coalition.php")&& 
		($file != "hall_of_fame.php")) $this->ingame = true; else $this->ingame = false;

	}


	//////////////////////////////////////////////////////////////////////
	// Render the page
	//////////////////////////////////////////////////////////////////////
	function render()
	{
		global $CONF_PREMIUM_MEMBERS;
				 
		if (isset($_GET["NOTICE"])) $this->showNotice($_GET["NOTICE"],false);
		if (isset($_GET["WARNING"])) $this->showNotice($_GET["WARNING"],true);


		$render_banners = true;
		
		if (isset($_SESSION["email"])) {
				   if (isset($CONF_PREMIUM_MEMBERS)) {
					  if (in_array($_SESSION["email"],$CONF_PREMIUM_MEMBERS))
						  $render_banners = false;
		   }
		   
		}
		
		
		$file = explode("/",$_SERVER["SCRIPT_FILENAME"]);
		$file = $file[count($file)-1];
		
		if (($file == "show_empire.php") || 
		($file == "show_active.php") || 
		($file == "galaxypedia.php")) $render_banners = false;
	
		
		
		$this->TPL->set_var("version",CONF_GAME_VERSION);
		$this->TPL->set_var("game_name",CONF_GAME_NAME);
		if (!isset($_SESSION["FORCE_BROWSER"]))
			$this->TPL->set_var("browser_unsupported","");
		else
			$this->TPL->set_var("browser_unsupported","_unsupported");

		$this->TPL->set_var("color_normal",TPL_COLOR_NORMAL);
		$this->TPL->set_var("color_highlight",TPL_COLOR_HIGHLIGHT);

		// dynamic variables

		$bulletin_data = $this->DB->Execute("SELECT * FROM tb_bulletin");
		$bulletin_data = $bulletin_data->fields["content"];
		$this->TPL->set_var("bulletin",$bulletin_data);

		$this->TPL->set_var("game_date",date("m/d/y",$this->coord["date"]));
			
		$date = time(NULL) - $this->coord["date"];
		$this->TPL->set_var("game_life",floor($date / (60*60*24)));

		$online_players = $this->DB->Execute("SELECT COUNT(*) FROM tb_session");
		$this->TPL->set_var("online_players",$online_players->fields[0]);

		$total_players = $this->DB->Execute("SELECT COUNT(*) FROM tb_empire WHERE active=1");
		$this->TPL->set_var("total_players",$total_players->fields[0]);
		
		
		if ($this->events_data == "") {
			$this->TPL->set_var("events_data",$this->notices_data);

		} else {
			$this->TPL->set_file("events_data_file","events_data.html");
			if ($this->events_height > 500) $this->events_height = 500;

			$this->TPL->set_var("events_div_size",$this->events_height+50);
			$this->TPL->set_var("events_content_size",$this->events_height."px");
			
			$this->TPL->set_var("events_data_content",$this->events_data);
			$this->TPL->set_var("events_data",$this->TPL->process("","events_data_file",2).$this->notices_data);
		}

		// EMBED in a page
		if ($this->ingame) {

			$this->TPL->set_file("ingame_frame","ingame.html",true);
			$this->TPL->set_var("page_content",$this->TPL->process("","page",2));
			$this->TPL->set_var("page_title",$file);
	
		// static variables
		
			if ($render_banners) {
		
				$this->TPL->set_var("banner_top_code",TPL_BANNER_TOP_CODE);
		  		$this->TPL->set_var("block_premium_ads",$this->TPL->process("","premium_ads",2));
				$this->TPL->set_var("banner_bottom_code",TPL_BANNER_BOTTOM_CODE);
			
			} else {
				
				$this->TPL->set_var("banner_top_code","");
				$this->TPL->set_var("banner_bottom_code","");
				$this->TPL->set_var("block_premium_ads","");
			
			}
		

			return $this->TPL->process("","ingame_frame",2);
			

		} else {
			$this->TPL->set_file("ingame_frame","simple_frame.html",true);
			$this->TPL->set_var("page_content",$this->TPL->process("","page",2));
			$this->TPL->set_var("page_title",$file);
			

			if ($render_banners) {
		
				$this->TPL->set_var("banner_top_code",TPL_BANNER_TOP_CODE);
				$this->TPL->set_var("banner_bottom_code",TPL_BANNER_BOTTOM_CODE);
			
			} else {
				$this->TPL->set_var("banner_top_code","");
				$this->TPL->set_var("banner_bottom_code","");
			}
		
			return $this->TPL->process("","ingame_frame",2);
		}

	}



	//////////////////////////////////////////////////////////////////////
	// Show notice
	//////////////////////////////////////////////////////////////////////
	function showNotice($msg,$isWarning = false)
	{
		
		if ($isWarning)
			$this->TPL->set_file("page_notice","warning".($this->ingame==true?"_ingame":"").".html");
		else
			$this->TPL->set_file("page_notice","notice".($this->ingame==true?"_ingame":"").".html");

		$this->TPL->set_var("msg",stripslashes($msg));

		$this->notices_data .= $this->TPL->process("","page_notice",2);

	}

	//////////////////////////////////////////////////////////////////////
	// Show event
	//////////////////////////////////////////////////////////////////////
	function showEvent($msg,$isWarning = false)
	{
		
		if ($isWarning)
			$this->TPL->set_file("page_notice","warning".($this->ingame==true?"_ingame":"").".html");
		else
			$this->TPL->set_file("page_notice","notice".($this->ingame==true?"_ingame":"").".html");

		$this->TPL->set_var("msg",stripslashes($msg));

		$this->events_data .= $this->TPL->process("","page_notice",2);
		$this->events_count++;
		
	}



	//////////////////////////////////////////////////////////////////////
	// Show notice
	//////////////////////////////////////////////////////////////////////
	function getNotice($msg,$isWarning = false)
	{
		if ($isWarning)
			$this->TPL->set_file("page_notice","warning".($this->ingame==true?"_ingame":"").".html");
		else
			$this->TPL->set_file("page_notice","notice".($this->ingame==true?"_ingame":"").".html");

		$this->TPL->set_var("msg",stripslashes($msg));

		return $this->TPL->process("","page_notice",2);

	}



	//////////////////////////////////////////////////////////////////////
	// Show file
	//////////////////////////////////////////////////////////////////////
	function showFile($file)
	{
		$this->TPL->set_file("page_notice",$file);
		return $this->TPL->process("","page_notice",2);

	}
	
	//////////////////////////////////////////////////////////////////////
	// Set variable
	//////////////////////////////////////////////////////////////////////
	function setVar($name,$value)
	{
		$this->TPL->set_var($name,$value);
	}

	//////////////////////////////////////////////////////////////////////
	// Set loop
	//////////////////////////////////////////////////////////////////////
	function setLoop($name,$value)
	{
		$this->TPL->set_loop($name,$value);
	}

	//////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////
	function formatNumber($number)
	{
		$output = number_format($number);	
		
		return $output;
	}



	//////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////
	function formatCredits($number,$html=true)
	{
		$output = $this->formatNumber($number);
		
		if ($html)
			return "<b style=\"color:".TPL_COLOR_NORMAL."\">$output</b>".
			"&nbsp;<b style=\"color:".TPL_COLOR_HIGHLIGHT."\">Cr.</b>";
		else
			return $output." Cr.";

	}


	//////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////
	function formatFood($number,$html=true)
	{
		$output = $this->formatNumber($number);
		
		if ($html)
			return "<b style=\"color:".TPL_COLOR_NORMAL."\">$output</b>".
			"&nbsp;<b style=\"color:".TPL_COLOR_HIGHLIGHT."\">Mgt.</b>";
		else
			return $output." Mgt.";

	}
	
	//////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////
	function formatPopulation($number,$html=true)
	{
		$output = $this->formatNumber($number);
		
		if ($html)
			return "<b style=\"color:".TPL_COLOR_NORMAL."\">$output</b>".
			"&nbsp;<b style=\"color:".TPL_COLOR_HIGHLIGHT."\">M</b>";
		else
			return $output." M";

	}

	//////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////
	function formatTime($date)
	{
		$days = floor($date / (60*60*24));
		$date -= ($days * 60*60*24);
		$hours = str_pad(floor($date / (60*60)),2,"0",STR_PAD_LEFT);
		$date -= ($hours * 60*60);
		$minutes = str_pad(floor($date / (60)),2,"0",STR_PAD_LEFT);
		return $days."d ".$hours.":".$minutes;
	}	
	
	
	//////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////
	function displayEmpireHTML($id,$emperor,$empire,$your_networth)
	{
		global $DB,$CONF_PREMIUM_MEMBERS;

		$emperor = stripslashes($emperor);
		$empire = stripslashes($empire);
		$text = "<table style=\"margin-bottom: 0px;display:inline;\" border=0 cellspacing=0 cellpadding=1><tr>";
		$text .= "<td><img src=\"img_logo.php?empire=$id\" border=\"1\" width=\"32\" height=\"32\" bordercolor=\"white\" style=\"border-color:white\"></td>";

		$rs = $DB->Execute("SELECT tb_coalition.logo,tb_member.* FROM tb_coalition,tb_member WHERE tb_member.empire=$id AND tb_coalition.id = tb_member.coalition");
	
		if (!$rs->EOF)
		{
			$text .= "<td><img src=\"img_logo.php?data=".$rs->fields["logo"]."\" border=\"1\" width=\"32\" height=\"32\" bordercolor=\"white\" style=\"border-color:white\"></td>";
		}

	
		$text .= "<td>&nbsp;<a href=\"javascript:show_info($id);\" style=\"text-decoration:none\"><b style=\"color:white\">$emperor</b><b style=\"color:darkcyan\">@</b><b style=\"color:#CACACA\">$empire</b></a>";

		if ($your_networth!="") {
		
			$rs = $DB->Execute("SELECT email,networth,admin FROM tb_empire WHERE id=".addslashes($id));
		if (isset($CONF_PREMIUM_MEMBERS))
			if (in_array($rs->fields["email"],$CONF_PREMIUM_MEMBERS)) $text .= "*P* ";
		if ($rs->fields["admin"]==1) $text .= "*A* ";
			$enemy_networth = $rs->fields["networth"];
			if ($enemy_networth == 0) $enemy_networth = 1;
			if ($your_networth == 0) $your_networth = 1;
			
			$percent = round(($enemy_networth / $your_networth)*100,3);
			if ($percent > 100) 
		   		$text .= "&nbsp;<b style=\"font-size:10px;color:#FF9999;font-family:verdana\">(".$percent." %</b>";
			else
		   		$text .= "&nbsp;<b style=\"font-size:10px;color:lightgreen;font-family:verdana\">(".$percent." %)</b>";
		
		}

		$text .="</td></tr></table>";
		return $text;
	}


	//////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////
	function displayEmpire($emperor,$empire,$your_networth)
	{
		global $DB,$CONF_PREMIUM_MEMBERS;
	
		$emperor = stripslashes($emperor);
		$empire = stripslashes($empire);
		$text = $emperor ."@".$empire." ";
	
	

		if ($your_networth!="") {
		
			$rs = $DB->Execute("SELECT email,networth,admin FROM tb_empire WHERE emperor='".addslashes($emperor)."'");
		if (isset($CONF_PREMIUM_MEMBERS))
			if (in_array($rs->fields["email"],$CONF_PREMIUM_MEMBERS)) $text .= "*P* ";
		if ($rs->fields["admin"]==1) $text .= "*A* ";
			$enemy_networth = $rs->fields["networth"];
			if ($enemy_networth == 0) $enemy_networth = 1;
			if ($your_networth == 0) $your_networth = 1;
			
			$percent = round(($enemy_networth / $your_networth)*100,3);
			if ($percent > 100) 
		   		$text .= " (".$percent." %)";
			else
		   		$text .= " (".$percent." %)";
		
		}


		return $text;
	}
	

	//////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////
	function showMessage($msg_data)
	{
		$params = unserialize($msg_data["params"]);
		
		$this->TPL->set_file("msg_body","message/body.html");
		$this->TPL->set_var("subject",stripslashes($params["subject"]));
		$this->TPL->set_var("content",stripslashes($params["content"]));
		$this->TPL->set_var("date",$this->formatTime(time(NULL) - $msg_data["date"]));
		
		
		$rs = $this->DB->Execute("SELECT * FROM tb_empire WHERE id=".$msg_data["event_from"]);
		$this->TPL->set_var("author",$this->displayEmpireHTML($rs->fields["id"],$rs->fields["emperor"],$rs->fields["name"],""));

		$this->TPL->set_var("id",$msg_data["id"]);

		
		if ($rs->fields["id"] == $_SESSION["empire_id"])
			$this->TPL->set_var("bgcolor","#336666");
		else
			$this->TPL->set_var("bgcolor","#447777");
		
		return $this->TPL->process("","msg_body",2);
	}
}


?>
