<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2006.09.01 : ybo : Major code changes, OOP
// 2007.02.04 : ybo : Reviewed the code for public release
// 2007.02.05 : ybo : Add support for both PHP4 and PHP5
//
//---------------------------------------------------------------------------//

// SYSTEM DEFINITIONS

define("CONF_GAME_VERSION", "2.3.2");

// IG GAME SETTINGS

define("CONF_GAME_NAME", "Server 2.3.2");

define("CONF_VICTORY_CONDITION_CLASSIC_GAME", 60 * 60 * 24 * 30); // 30 days
define("CONF_VICTORY_CONDITION_RESEARCH_RACE", true);

define("CONF_GAME_RESTART_DELAY", 60 * 5); // 5 minutes
define("CONF_GAMETYPE_PREMIUM_ONLY", false);

define("CONF_MAXPLAYERS", 500);
define("CONF_TIMEZONE", "America/Montreal");

define("CONF_TURNS_PER_DAY", 25);

define("CONF_MAX_STORED_TURNS", 25);
define("CONF_ACTIVATION_TIMEOUT", (60 * 60 * 24) * 2); // 48h

define("CONF_ACTIVITY_TIMEOUT", (60 * 60 * 24) * 7); // 1 week

define("CONF_SESSION_TIMEOUT", 60 * 6);
define("CONF_MAX_SESSIONS", 20);

define("CONF_ACTIVATION_REQUIRED", false);
define("CONF_UNSEEN_EVENT_TIMEOUT", (60 * 60 * 24) * 10); // 10 days;
define("CONF_SEEN_EVENT_TIMEOUT", (60 * 60 * 24) * 5); // 5 days;

define("CONF_MAXIMUM_COALITION_MEMBERS", 5);

define("CONF_TOPLIST_COUNT", 20);

define("CONF_BLACKMARKET_MINIMUM_NETWORTH", 50000000);
define("CONF_BLACKMARKET_COVERT_RATIO_PERCENT", 400);
define("CONF_BLACKMARKET_RANDOMNESS", 10);
define("CONF_BLACKMARKET_PRICE_LIGHTCRUISERS", 25000);
define("CONF_BLACKMARKET_PRICE_NUKES", 5000000000);
define("CONF_BLACKMARKET_PRICE_TELEPORT", 2000000000);
define("CONF_BLACKMARKET_PRICE_EXTRAPROTECTION", 1000000000);

define("CONF_PROTECTION_TURNS", 20); // use 20

define("CONF_TRADE_TAXRATE", 30);
define("CONF_TRADE_MAXCONVOYS", 3);

define("CONF_FOODMARKET_GROWTH", 10000000);

// DATABASE SETTINGS

define("CONF_DATABASE_DRIVER", "mysqlt");
define("CONF_DATABASE_HOSTNAME", "127.0.0.1");
define("CONF_DATABASE_USERNAME", "changeme");
define("CONF_DATABASE_PASSWORD", "changeme");
define("CONF_DATABASE_NAME", "changeme");

// MAIL SETTINGS

define("CONF_MAIL_FROM", "changeme");
define("CONF_MAIL_SMTP", "127.0.0.1");

// STARTING VALUES

define("CONF_START_CREDITS", 60000000);
define("CONF_START_FOOD", 1000);
define("CONF_START_POPULATION", 400);

define("CONF_START_FOOD_PLANETS", 3);
define("CONF_START_ORE_PLANETS", 7);
define("CONF_START_TOURISM_PLANETS", 4);
define("CONF_START_SUPPLY_PLANETS", 0);
define("CONF_START_GOV_PLANETS", 1);
define("CONF_START_EDU_PLANETS", 2);
define("CONF_START_RESEARCH_PLANETS", 1);
define("CONF_START_URBAN_PLANETS", 2);
define("CONF_START_PETRO_PLANETS", 0);
define("CONF_START_ANTIPOLLU_PLANETS", 3);

define("CONF_START_SOLDIERS", 100);
define("CONF_START_GENERALS", 2);
define("CONF_START_FIGHTERS", 20);
define("CONF_START_STATIONS", 12);

define("CONF_RANDOMEVENT_PERCENTAGE", 10);

// population growth

define("CONF_POP_DEAD", 0.01);
define("CONF_POP_BORN", 0.04);
define("CONF_POP_POLLUTION", 0.000002);
define("CONF_POP_URBAN", 0.015);
define("CONF_POP_OVERCROWD", 20000);
define("CONF_POP_OVERCROWD_GETOUT", 0.3);
define("CONF_POP_EDUCATION", 50);
define("CONF_POP_TAXRATE", 0.0025);
define("CONF_POP_TAXRATE_GETOUT", 0.0015);
define("CONF_POP_CIVILSTATUS", 0.05);
define("CONF_PLANETS_CIVILSTATUS", 0.2);
define("CONF_PETRO_POLLUTION", 0.1);
define("CONF_ANTIPOLLUTION", 0.5);

define("CONF_INCOME_ORE", 4000);
define("CONF_INCOME_PETROLEUM", 20000);
define("CONF_INCOME_TOURISM", 8000);
define("CONF_INCOME_CIVILSTATUS", 4);
define("CONF_INCOME_POPTAX", 1);
define("CONF_INCOME_URBANTAX", 0.0003);
define("CONF_INTERGALACTIC_TAX", 0.003);

define("CONF_MAINTENANCE_PLANETS", 145);
define("CONF_MAINTENANCE_SOLDIER", 20);
define("CONF_MAINTENANCE_FIGHTER", 60);
define("CONF_MAINTENANCE_STATION", 80);
define("CONF_MAINTENANCE_LIGHTCRUISER", 60);
define("CONF_MAINTENANCE_HEAVYCRUISER", 100);
define("CONF_MAINTENANCE_CARRIER", 50);

define("CONF_FOOD_PRODUCTION", 12);
define("CONF_FOOD_POPULATION_EATING", 0.006);
define("CONF_FOOD_SOLDIERS_EATING", 0.003);

define("CONF_MILITARY_PRODUCTION_SOLDIER", 70);
define("CONF_MILITARY_PRODUCTION_GENERAL", 15);
define("CONF_MILITARY_PRODUCTION_FIGHTER", 40);
define("CONF_MILITARY_PRODUCTION_STATION", 30);
define("CONF_MILITARY_PRODUCTION_HEAVYCRUISER", 40);
define("CONF_MILITARY_PRODUCTION_CARRIER", 20);
define("CONF_MILITARY_PRODUCTION_COVERT", 15);
define("CONF_MILITARY_PRODUCTION_CREDITS", 4000);

define("CONF_RESEARCH_LIGHTCRUISER", 4);

define("CONF_FORUM_POSTS_PER_PAGE", 20);
define("CONF_MAX_PLANET_BUY", 5000000);

// EVENTS 

define("CONF_EVENT_NEWEMPIRE", 0);
define("CONF_EVENT_COLLAPSEDEMPIRE", 1);
define("CONF_EVENT_LOTTERYWINNER", 2);
define("CONF_EVENT_PENDINGTREATY", 3);
define("CONF_EVENT_ACCEPTEDTREATY", 4);
define("CONF_EVENT_REFUSEDTREATY", 5);
define("CONF_EVENT_BREAKTREATY", 6);
define("CONF_EVENT_TRADESENT", 7);
define("CONF_EVENT_SPYCAUGHT", 8);
define("CONF_EVENT_DISSENSION", 9);
define("CONF_EVENT_FOODBOMBED", 10);
define("CONF_EVENT_HOSTAGES", 11);
define("CONF_EVENT_GUERILLA_REVEALED", 12);
define("CONF_EVENT_GUERILLA_STEALTH", 13);
define("CONF_EVENT_INVADED", 14);
define("CONF_EVENT_ELIMINATED", 15);
define("CONF_EVENT_NOTICE", 16);
define("CONF_EVENT_WARNING", 17);
define("CONF_EVENT_NEWTURN", 18);
define("CONF_EVENT_WRATHOFKHAN", 19);
define("CONF_EVENT_TREATY_CASUALTIES", 20);
define("CONF_EVENT_EMPIREATTACKED", 21);
define("CONF_EVENT_COALITION_CREATED", 22);
define("CONF_EVENT_COALITION_DISBANDED", 23);
define("CONF_EVENT_COALITION_JOINED", 24);
define("CONF_EVENT_COALITION_KICKED", 25);
define("CONF_EVENT_COALITION_INVITE", 26);
define("CONF_EVENT_COALITION_REFUSED", 27);
define("CONF_EVENT_CARRIERS_SABOTAGE", 28);
define("CONF_EVENT_PLANETS_RELEASED", 29);
define("CONF_EVENT_COALITION_OWNERSHIP_CHANGED", 30);
define("CONF_EVENT_MESSAGE", 31);
define("CONF_EVENT_PIRATERAID", 32);
define("CONF_EVENT_RESEARCHDONE", 33);
define("CONF_EVENT_FOODGROWTH", 34);
define("CONF_EVENT_MONEYGROWTH", 35);
define("CONF_EVENT_MILITARYPRODUCTION", 36);
define("CONF_EVENT_POPULATIONGROWTH", 37);
define("CONF_EVENT_RANDOMEVENT", 38);
define("CONF_EVENT_CIVILSTATUS", 39);
define("CONF_EVENT_TURNCOMPLETED", 40);
define("CONF_EVENT_COVERTOP_RESULT", 41);
define("CONF_EVENT_PIRATEBUST", 42);
define("CONF_EVENT_TRADECONVOY_RECEIVED", 43);
define("CONF_EVENT_TRADECONVOY_RAIDEDBYPIRATE", 44);
define("CONF_EVENT_BOND_PAYOUT", 45);
define("CONF_EVENT_CONVOY_RETREAT",46);
define("CONF_EVENT_FUNDAMENTAL_COMPLETED", 47);
define("CONF_EVENT_EMPIRE_TELEPORTED", 48);
define("CONF_EVENT_EMPIRE_BUY_NUKES", 49);
define("CONF_EVENT_NUCLEARWARFARE_BUSTED", 50);
define("CONF_EVENT_NUCLEARWARFARE_FOILED", 51);
define("CONF_EVENT_NUCLEARWARFARE_ATTACKED", 52);
define("CONF_EVENT_INCOMING_INVASION", 53);
define("CONF_EVENT_INCOMING_DEFENSE", 54);
define("CONF_EVENT_SENDING_DEFENSE", 55);
define("CONF_EVENT_INVASION_REPORT", 56);
define("CONF_EVENT_CONVOY_BACK", 57);

// NETWORTH

define("CONF_NETWORTH_POPULATION", 0);
define("CONF_NETWORTH_PLANETS", 10);
define("CONF_NETWORTH_CREDITS", 0);
define("CONF_NETWORTH_MILITARY_SOLDIER", 0.0005);
define("CONF_NETWORTH_MILITARY_FIGHTER", 0.001);
define("CONF_NETWORTH_MILITARY_STATION", 0.002);
define("CONF_NETWORTH_MILITARY_LIGHTCRUISER", 0.001);
define("CONF_NETWORTH_MILITARY_HEAVYCRUISER", 0.002);
define("CONF_NETWORTH_MILITARY_CARRIER", 0.005);
define("CONF_NETWORTH_MILITARY_GENERAL", 0.001);
define("CONF_NETWORTH_MILITARY_COVERT", 0.001);

// SOLAR BANK

define("CONF_SOLARBANK_LOAN_BASE_RATE", 50);
define("CONF_SOLARBANK_LOAN_LOTTERY", 10);
define("CONF_SOLARBANK_LOAN_MAXTURNS", 20);
define("CONF_SOLARBANK_LOAN_BASE_AMOUNT", 999999);
define("CONF_SOLARBANK_LOAN_MAXLOANS", 3);
define("CONF_SOLARBANK_BOND_BASE_RATE", 10);
define("CONF_SOLARBANK_BOND_MAXTURNS", 30);
define("CONF_SOLARBANK_BOND_MAXBONDS", 5);
define("CONF_SOLARBANK_LOTTERY", 10);

// LOTTERY
define("CONF_LOTTERY_TICKETPRICE", 10000);
define("CONF_LOTTERY_TICKETRATIO", 25);
define("CONF_LOTTERY_MAXTICKETS", 100);

// COST
define("CONF_COST_SOLDIER", 280);
define("CONF_COST_FIGHTER", 380);
define("CONF_COST_STATION", 520);
define("CONF_COST_GENERAL", 780);
define("CONF_COST_COMMANDSHIP", 20000);
define("CONF_COST_COVERT", 4090);
define("CONF_COST_HEAVYCRUISER", 1900);
define("CONF_COST_CARRIER", 1430);
define("CONF_COST_INFLATION", 0.001);
define("CONF_COST_PLANET_FOOD", 8000);
define("CONF_COST_PLANET_ORE", 6000);
define("CONF_COST_PLANET_TOURISM", 8000);
define("CONF_COST_PLANET_SUPPLY", 11500);
define("CONF_COST_PLANET_GOV", 7500);
define("CONF_COST_PLANET_EDU", 8000);
define("CONF_COST_PLANET_RESEARCH", 23000);
define("CONF_COST_PLANET_URBAN", 8000);
define("CONF_COST_PLANET_PETROLEUM", 11500);
define("CONF_COST_PLANET_ANTIPOLLU", 10500);
define("CONF_COST_SELLRATIO", 4);
define("CONF_COST_FOOD", 20);
define("CONF_COST_INCREMENT", 0.0002);

define("CONF_FOODMARKET_PRICE_BUY", 100000);
define("CONF_FOODMARKET_PRICE_SELL", 1000);
define("CONF_FOODMARKET_AVG", 500000000);

define("CONF_POPULATION_STARVING", 20);
define("CONF_SOLDIERS_STARVING", 10);
define("CONF_BANKRUPT_PLANETS", 10);
define("CONF_BANKRUPT_MILITARY", 10);

define("CONF_RESEARCH_POINTS_PER_PLANET", 4);

// carrier transportation
define("CONF_CARRIER_MONEY", 0.000001);
define("CONF_CARRIER_FOOD", 0.0001);
define("CONF_CARRIER_GENERAL", 0.001);
define("CONF_CARRIER_COVERT", 0.001);
define("CONF_CARRIER_SOLDIER", 0.001);
define("CONF_CARRIER_FIGHTER", 0.005);
define("CONF_CARRIER_LIGHTCRUISER", 0.01);
define("CONF_CARRIER_HEAVYCRUISER", 0.1);
define("CONF_TRADE_MAXCARRIERS", 5000000);
define("CONF_TRADE_PIRATERAID", "50");

define("CONF_TRADETAX_MONEY", 0.01);
define("CONF_TRADETAX_FOOD", 0.1);
define("CONF_TRADETAX_GENERAL", 1);
define("CONF_TRADETAX_COVERT", 1);
define("CONF_TRADETAX_SOLDIER", 1);
define("CONF_TRADETAX_FIGHTER", 2);
define("CONF_TRADETAX_LIGHTCRUISER", 20);
define("CONF_TRADETAX_HEAVYCRUISER", 30);

define("CONF_TREATY_ACCEPT_PENDING", 0);
define("CONF_TREATY_ACCEPTED", 1);
define("CONF_TREATY_BREAK_PENDING", 2);

define("CONF_COVERTAGENTS_PER_GOVPLANET", 300);
define("CONF_GENERALS_PER_GOVPLANET", 50);

define("CONF_TOO_MUCH_COVERTAGENTS_PERCENTAGE", 50);
define("CONF_TOO_MUCH_COVERTAGENTS_LOST_PERCENTAGE", 25);

define("CONF_COVERTOP_SENDSPY", 0);
define("CONF_COVERTOP_INSURGENTAID", 1);
define("CONF_COVERTOP_SUPPORTDISSENSION", 2);
define("CONF_COVERTOP_DEMORALIZETROOPS", 3);
define("CONF_COVERTOP_BOMBINGOPERATIONS", 4);
define("CONF_COVERTOP_RELATIONSSPYING", 5);
define("CONF_COVERTOP_TAKEHOSTAGES", 6);
define("CONF_COVERTOP_CARRIERSSABOTAGE", 7);
define("CONF_COVERTOP_COMMUNICATIONSSPYING", 8);

define("CONF_COVERTPOINTS_PER_TURN", 5);

define("CONF_MAX_COVERTPOINTS", 50);

define("CONF_CONVOY_INVASION", 0);
define("CONF_CONVOY_DEFENSE", 1);
define("CONF_CONVOY_INVASION_RETREAT", 2);
define("CONF_CONVOY_DEFENSE_RETREAT", 3);

// BATTLE RELATED

// INVASION

define("CONF_INVASION_ATTACK_ROUNDS", 20); // orig: 35

define("CONF_INVASION_PLANETS_MINIMUM", "30"); // 30-90% base
define("CONF_INVASION_PLANETS_MAXIMUM", "90"); // 30-90% base

define("CONF_INVASION_EFFECTIVENESS_WON", 20);
define("CONF_INVASION_EFFECTIVENESS_LOST", 10);
define("CONF_PIRATE_EFFECTIVENESS_WON", 15);
define("CONF_PIRATE_EFFECTIVENESS_LOST", 5);
define("CONF_EFFECTIVENESS_GROWTH_PER_TURN", 2);

define("CONF_INVASION_DEFENSE_BONUS", 1.5);
define("CONF_INVASION_CARRIERS_DAMAGE", 5);
define("CONF_INVASION_LIGHTCRUISER_PROTECTION_ROUNDS", 3);
define("CONF_INVASION_RANDOMNESS", 20);

// GUERILLA

define("CONF_GUERILLA_SOLDIER_DEFENSE", 4);
define("CONF_GUERILLA_SOLDIER_LOST", 10);
define("CONF_GUERILLA_ATTACK_ROUNDS", 5);

$units_info = array ();
$units_info["soldiers_0"] = array (
	"guerilla" => 1,
	"invasion_ground" => 1,
	"invasion_orbital" => 0,
	"invasion_space" => 0,
	"pirate_bust" => 0.5
);
$units_info["soldiers_1"] = array (
	"guerilla" => 1.5,
	"invasion_ground" => 1,
	"invasion_orbital" => 0,
	"invasion_space" => 0,
	"pirate_bust" => 1
);
$units_info["soldiers_2"] = array (
	"guerilla" => 0.5,
	"invasion_ground" => 2,
	"invasion_orbital" => 1,
	"invasion_space" => 0,
	"pirate_bust" => 2
);

$units_info["fighters_0"] = array (
	"guerilla" => 0,
	"invasion_ground" => 0.5,
	"invasion_orbital" => 1,
	"invasion_space" => 0,
	"pirate_bust" => 0.5
);
$units_info["fighters_1"] = array (
	"guerilla" => 0,
	"invasion_ground" => 0.5,
	"invasion_orbital" => 2,
	"invasion_space" => 1,
	"pirate_bust" => 1
);
$units_info["fighters_2"] = array (
	"guerilla" => 0,
	"invasion_ground" => 0.5,
	"invasion_orbital" => 3,
	"invasion_space" => 1,
	"pirate_bust" => 2
);

$units_info["stations_0"] = array (
	"guerilla" => 0,
	"invasion_ground" => 0.5,
	"invasion_orbital" => 1,
	"invasion_space" => 0,
	"pirate_bust" => 0.5
);
$units_info["stations_1"] = array (
	"guerilla" => 0,
	"invasion_ground" => 0.5,
	"invasion_orbital" => 2,
	"invasion_space" => 0,
	"pirate_bust" => 1
);
$units_info["stations_2"] = array (
	"guerilla" => 0,
	"invasion_ground" => 1,
	"invasion_orbital" => 1,
	"invasion_space" => 1,
	"pirate_bust" => 2
);

$units_info["lightcruisers_0"] = array (
	"guerilla" => 0,
	"invasion_ground" => 0,
	"invasion_orbital" => 1,
	"invasion_space" => 1,
	"pirate_bust" => 0.5
);
$units_info["lightcruisers_1"] = array (
	"guerilla" => 0,
	"invasion_ground" => 0.1,
	"invasion_orbital" => 2,
	"invasion_space" => 1,
	"pirate_bust" => 1
);
$units_info["lightcruisers_2"] = array (
	"guerilla" => 0,
	"invasion_ground" => 0.2,
	"invasion_orbital" => 3,
	"invasion_space" => 1,
	"pirate_bust" => 2
);

$units_info["heavycruisers_0"] = array (
	"guerilla" => 0,
	"invasion_ground" => 0,
	"invasion_orbital" => 1,
	"invasion_space" => 1,
	"pirate_bust" => 0.5
);
$units_info["heavycruisers_1"] = array (
	"guerilla" => 0,
	"invasion_ground" => 0,
	"invasion_orbital" => 1,
	"invasion_space" => 2,
	"pirate_bust" => 1
);
$units_info["heavycruisers_2"] = array (
	"guerilla" => 0,
	"invasion_ground" => 0.5,
	"invasion_orbital" => 1,
	"invasion_space" => 3,
	"pirate_bust" => 2
);
//
//$units_info["carriers_0"] = array("toughness"=>1,"speed"=>1);
//
$units_info["carriers_0"] = array (
	"toughness" => 1,
	"speed" => 1,
	"cargo_hold" => 1
);
$units_info["carriers_1"] = array (
	"toughness" => 2,
	"speed" => 2,
	"cargo_hold" => 2
);
$units_info["carriers_2"] = array (
	"toughness" => 4,
	"speed" => 4,
	"cargo_hold" => 4
);

$units_info["commandship_0"] = array (
	"bonus" => 1
);
$units_info["commandship_1"] = array (
	"bonus" => 2
);
$units_info["commandship_2"] = array (
	"bonus" => 3
);

// PIRATE BATTLE

define("CONF_PIRATE_DEFENSE", 4);
define("CONF_PIRATE_BASEVALUE", 1000);

define("CONF_NUCLEARWARFARE_BASE_DAMAGE", 40);
define("CONF_NUCLEARWARFARE_EXTRA_DAMAGE", 25);

// RESEARCH
define("CONF_RESEARCH_BASECOST", 4000000);

define("CONF_RESET_COORDINATOR_FOOD", "200000000");
define("CONF_RESET_COORDINATOR_PLANETS", "3000000000");

$CONF_PREMIUM_MEMBERS = array();

// empty

$CONF_BANNED_HOSTS = array(); 

?>
