<?php
//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2006.09.01 : ybo : Major code changes, OOP
// 2007.02.04 : ybo : Reviewed the code for public release
// 2007.02.05 : ybo : Add support for both PHP4 and PHP5
//
//---------------------------------------------------------------------------//


// BASIC INCLUSIONS

require_once("config.php");

// check for banned IP
if (isset($_SERVER["REMOTE_ADDR"])) {
	$ban_hostname = $_SERVER["REMOTE_ADDR"];
	for ($i=0;$i<count($CONF_BANNED_HOSTS);$i++) {
		$host = $CONF_BANNED_HOSTS[$i];
		$host = str_replace("*","",$host);
		$len = strlen($host);
		if (substr($host,0,$len) == substr($ban_hostname,0,$len)) {
			header("Location: banned.html");
			die();
		}
	}

}


if (isset($_SERVER["X_FORWARDED_FOR"])) {
	$ban_hostname = $_SERVER["X_FORWARDED_FOR"];
	for ($i=0;$i<count($CONF_BANNED_HOSTS);$i++) {
		$host = $CONF_BANNED_HOSTS[$i];
		$host = str_replace("*","",$host);
		$len = strlen($host);
		if (substr($host,0,$len) == substr($ban_hostname,0,$len)) {
			header("Location: banned.html");
			die();
		}
	}
}

require_once("template.php");
require_once("classes/event_creator.php");
require_once("classes/event_renderer.php");
require_once("classes/system.php");
require_once("classes/session.php");
require_once("classes/template.php");
require_once("classes/empire.php");
require_once("classes/army.php");
require_once("classes/invasion.php");
require_once("classes/planets.php");
require_once("classes/gameplay_costs.php");
require_once("classes/coalition.php");
require_once("classes/production.php");
require_once("classes/supply.php");
require_once("classes/diplomacy.php");
require_once("classes/research.php");
require_once("classes/advisors/agricultural.php");
require_once("classes/advisors/military.php");
require_once("classes/advisors/population.php");
require_once("classes/news_creator.php");

// ThirdParties

require_once("thirdparty/adodb/adodb.inc.php");
require_once("thirdparty/phemplate.class.php");
require_once("thirdparty/phpmailer/class.phpmailer.php");
require_once("thirdparty/error_handler.php");

// basic PHP initialization

function phpnum() {
$version = explode('.', phpversion());
return (int) $version[0];
}
function is_php5() { return phpnum() == 5; }
function is_php4() { return phpnum() == 4; }

if (is_php5()) {
	 date_default_timezone_set(CONF_TIMEZONE); 
}

ob_start();	// output buffering
set_time_limit(30); // maximum of 30 seconds for execution

// if 'register_globals' directive is active, halt the process
if (ini_get("register_globals")==1)
{
	die("Disable register_globals PHP Directive!");
}

// Initialize database
$DB = NewADOConnection(CONF_DATABASE_DRIVER);
if (!$DB->Connect(CONF_DATABASE_HOSTNAME,CONF_DATABASE_USERNAME,CONF_DATABASE_PASSWORD,CONF_DATABASE_NAME)) trigger_error($DB->ErrorMsg());


// set language
if (!isset($_SESSION["language"])) $_SESSION["language"] = "english";

if (isset($_GET["LANG"])) {
        $language_full_path = "include/lang/".str_replace(".","",$_GET["LANG"]).".php";
	if (file_exists($language_full_path)) {
		$_SESSION["language"] = str_replace(".","",$_GET["LANG"]);
	}
}

require_once("include/lang/".$_SESSION["language"].".php");

// CREATING THE TEMPLATE OBJECT

if (file_exists("include/template/default/".$_SESSION["language"]."/"))
   $TPL = new phemplate("include/template/default/".$_SESSION["language"]."/");
else
   $TPL = new phemplate("include/template/default/english/");

// initialize various subsystems

$GAME = array();
$GAME["system"] = new System($DB);

$GAME["session"] = new Session($DB);
$GAME["template"] = new Template($DB,$TPL);
$GAME["gameplay_costs"] = new GameplayCosts($DB);
$GAME["empire"] = new Empire($DB, $GAME["template"],$GAME["gameplay_costs"]);

$GAME["system"]->init();


// DETECT BROWSER COMPATIBILITY
if (isset($_GET["FORCE_BROWSER"])) $_SESSION["FORCE_BROWSER"] = true;

if (!isset($_SESSION["FORCE_BROWSER"]))
if (strpos($_SERVER["HTTP_USER_AGENT"],"Konqueror")) {
	
	header("Location: getfirefox.html");
	die();	
}

?>
