<?php
//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2006.09.01 : ybo : Major code changes, OOP
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

// verify if session is active
$active = $GAME["session"]->isActive();
if ($active == 0) $GAME["system"]->redirect("login.php");

////////////////////////////////////////////////////////////////////
// security and basic handling
////////////////////////////////////////////////////////////////////
$empire_loaded = $GAME["empire"]->load($_SESSION["empire_id"]);

if ($empire_loaded["code"] == false) 
	$GAME["system"]->redirect("login.php",array("WARNING"=>$empire_loaded["desc"]));

$output = $GAME["empire"]->checkForEnoughCredits();
if ($output != "") $GAME["template"]->showNotice($output,true);

$output = $GAME["empire"]->checkForEnoughFood();
if ($output != "") $GAME["template"]->showNotice($output,true);



if ($GAME["empire"]->data["active"] != 2) // already collapsed
if (!$GAME["empire"]->checkForEnoughPopulation()) {

	$GAME["empire"]->collapse();
	$GAME["empire"]->updateNetworth();
	$GAME["empire"]->save();

} else {

	$GAME["empire"]->updateNetworth();
	$GAME["empire"]->save();
	
}


if ($GAME["empire"]->data["active"]==2) {
		$GAME["template"]->showNotice($GAME["template"]->showFile("collapsed.html"),true);
	unset($_POST);
	unset($_GET);
	$file = $_SERVER["SCRIPT_FILENAME"];
	$file = explode("/",$file);
	$file = $file[count($file)-1];
	
	if ($file != "lastturn.php") $GAME["system"]->redirect("lastturn.php");
}



if ($GAME["template"]->coord["game_status"]==1) {
	$GAME["system"]->redirect("hall_of_fame.php");
}


////////////////////////////////////////////////////////////////////////////////////
// display variables
////////////////////////////////////////////////////////////////////////////////////

$GAME["template"]->setVar("empire_short",$GAME["empire"]->data["name"]);
$GAME["template"]->setVar("emperor_short",$GAME["empire"]->data["emperor"]);

// time /turns related 
$day = 60*60*24;
$timeslice = floor($day/CONF_TURNS_PER_DAY);
$elapsed = time(NULL) - $GAME["template"]->coord["last_turns_update"];
		
$nexttime = $timeslice - $elapsed;
$nexttime_date = date("m/d/Y g:i:s A",(time(NULL) + $nexttime));
$GAME["template"]->setVar("turns_next_date",$nexttime_date);

$time_date = date("m/d/Y g:i:s A",(time(NULL)));
$GAME["template"]->setVar("turns_now_date",$time_date);
		
if ($nexttime < 0) $nexttime = 0;
$nexttime = floor($nexttime / 60)." min. , ".($nexttime%60) ." seconds";
$GAME["template"]->setVar("turns_next",$nexttime);

$GAME["template"]->setVar("creation_date",date("m/d/Y",$GAME["empire"]->data["date"]));
$GAME["template"]->setVar("networth",$GAME["template"]->formatNumber($GAME["empire"]->data["networth"]));
$GAME["template"]->setVar("credits",$GAME["template"]->formatCredits($GAME["empire"]->data["credits"]));
$GAME["template"]->setVar("population",$GAME["template"]->formatPopulation($GAME["empire"]->data["population"]));
$GAME["template"]->setVar("gender",($GAME["empire"]->data["gender"]=="M"?LANG_EMPEROR:LANG_EMPRESS));
if ($GAME["empire"]->data["active"]==2)
	$GAME["template"]->setVar("civil_status",LANG_COLLAPSED);
else
	$GAME["template"]->setVar("civil_status",$CONF_CIVIL_STATUS[$GAME["empire"]->data["civil_status"]]);

$GAME["template"]->setVar("food",$GAME["template"]->formatFood($GAME["empire"]->data["food"]));
$GAME["template"]->setVar("generals",$GAME["template"]->formatNumber($GAME["empire"]->army->data["generals"]));
$GAME["template"]->setVar("covertagents",$GAME["template"]->formatNumber($GAME["empire"]->army->data["covertagents"]));
$GAME["template"]->setVar("effectiveness",$GAME["empire"]->army->data["effectiveness"]);
$GAME["template"]->setVar("soldiers",$GAME["template"]->formatNumber($GAME["empire"]->army->data["soldiers"]));
$GAME["template"]->setVar("fighters",$GAME["template"]->formatNumber($GAME["empire"]->army->data["fighters"]));
$GAME["template"]->setVar("stations",$GAME["template"]->formatNumber($GAME["empire"]->army->data["stations"]));
$GAME["template"]->setVar("light_cruisers",$GAME["template"]->formatNumber($GAME["empire"]->army->data["lightcruisers"]));
$GAME["template"]->setVar("heavy_cruisers",$GAME["template"]->formatNumber($GAME["empire"]->army->data["heavycruisers"]));
$GAME["template"]->setVar("carriers",$GAME["template"]->formatNumber($GAME["empire"]->army->data["carriers"]));
$GAME["template"]->setVar("planets_count",$GAME["template"]->formatNumber($GAME["empire"]->planets->getCount()));
$GAME["template"]->setVar("commandship",$GAME["empire"]->army->data["commandship"]);
$GAME["template"]->setVar("research_level",$GAME["template"]->formatNumber($GAME["empire"]->data["research_points"]));
$GAME["template"]->setVar("turns_played",$GAME["template"]->formatNumber($GAME["empire"]->data["turns_played"]));
$GAME["template"]->setVar("turns_left",$GAME["template"]->formatNumber($GAME["empire"]->data["turns_left"]));
$GAME["template"]->setVar("protection_turns_left",$GAME["template"]->formatNumber($GAME["empire"]->data["protection_turns_left"]));
$GAME["template"]->setVar("empires_eliminated",$GAME["template"]->formatNumber($GAME["empire"]->data["empires_eliminated"]));

// research icons
$GAME["template"]->setVar("soldiers_level",$GAME["empire"]->army->data["soldiers_level"]);
$GAME["template"]->setVar("fighters_level",$GAME["empire"]->army->data["fighters_level"]);
$GAME["template"]->setVar("stations_level",$GAME["empire"]->army->data["stations_level"]);
$GAME["template"]->setVar("generals_level",$GAME["empire"]->army->data["generals_level"]);
$GAME["template"]->setVar("commandship_level",$GAME["empire"]->army->data["commandship_level"]);
$GAME["template"]->setVar("covertagents_level",$GAME["empire"]->army->data["covertagents_level"]);
$GAME["template"]->setVar("lightcruisers_level",$GAME["empire"]->army->data["lightcruisers_level"]);
$GAME["template"]->setVar("heavycruisers_level",$GAME["empire"]->army->data["heavycruisers_level"]);
$GAME["template"]->setVar("carriers_level",$GAME["empire"]->army->data["carriers_level"]);

// planets
$GAME["template"]->setVar("food_planets",$GAME["template"]->formatNumber($GAME["empire"]->planets->data["food_planets"]));
$GAME["template"]->setVar("ore_planets",$GAME["template"]->formatNumber($GAME["empire"]->planets->data["ore_planets"]));
$GAME["template"]->setVar("tourism_planets",$GAME["template"]->formatNumber($GAME["empire"]->planets->data["tourism_planets"]));
$GAME["template"]->setVar("supply_planets",$GAME["template"]->formatNumber($GAME["empire"]->planets->data["supply_planets"]));
$GAME["template"]->setVar("gov_planets",$GAME["template"]->formatNumber($GAME["empire"]->planets->data["gov_planets"]));
$GAME["template"]->setVar("edu_planets",$GAME["template"]->formatNumber($GAME["empire"]->planets->data["edu_planets"]));
$GAME["template"]->setVar("research_planets",$GAME["template"]->formatNumber($GAME["empire"]->planets->data["research_planets"]));
$GAME["template"]->setVar("urban_planets",$GAME["template"]->formatNumber($GAME["empire"]->planets->data["urban_planets"]));
$GAME["template"]->setVar("petro_planets",$GAME["template"]->formatNumber($GAME["empire"]->planets->data["petro_planets"]));
$GAME["template"]->setVar("antipollu_planets",$GAME["template"]->formatNumber($GAME["empire"]->planets->data["antipollu_planets"]));

// production
$GAME["template"]->setVar("food_short",$GAME["empire"]->production->data["food_short"]);
$GAME["template"]->setVar("ore_short",$GAME["empire"]->production->data["ore_short"]);
$GAME["template"]->setVar("tourism_short",$GAME["empire"]->production->data["tourism_short"]);
$GAME["template"]->setVar("supply_short",$GAME["empire"]->production->data["supply_short"]);
$GAME["template"]->setVar("edu_short",$GAME["empire"]->production->data["edu_short"]);
$GAME["template"]->setVar("research_short",$GAME["empire"]->production->data["research_short"]);
$GAME["template"]->setVar("urban_short",$GAME["empire"]->production->data["urban_short"]);
$GAME["template"]->setVar("petro_short",$GAME["empire"]->production->data["petro_short"]);
$GAME["template"]->setVar("antipollu_short",$GAME["empire"]->production->data["antipollu_short"]);

$GAME["template"]->setVar("empire_id",$GAME["empire"]->data["id"]);

$GAME["template"]->TPL->set_file("menu","menu.html");

$GAME["template"]->setVar("game_menu",$GAME["template"]->TPL->process("","menu",2));



if (file_exists("images/empires/".$_SESSION["empire_id"].".jpg"))
	$GAME["template"]->setVar("logo","images/empires/".$_SESSION["empire_id"].".jpg");
else
	$GAME["template"]->setVar("logo","img_logo.php?empire=".$_SESSION["empire_id"]);



if (!file_exists("images/avatars/".$GAME["empire"]->data["id"].".jpg"))
	$GAME["template"]->setVar("emperor_avatar","images/avatars/anonymous.jpg");
else
	$GAME["template"]->setVar("emperor_avatar","images/avatars/".$GAME["empire"]->data["id"].".jpg");
	


$file = explode("/",$_SERVER["SCRIPT_FILENAME"]);
$file = $file[count($file)-1];

if ($file != "galaxypedia.php") {
////////////////////////////////////////////////////////////////////////////////////
// Display unseen events
////////////////////////////////////////////////////////////////////////////////////

$events = new EventRenderer($DB,$TPL,$GAME["template"]);
$events_data = $events->displayUnseenEvents($GAME["empire"]->data);
$GAME["template"]->events_height = $events_data["total_height"];
$events_data = $events_data["events_output"];

for ($i=0;$i<count($events_data);$i++) {
	$GAME["template"]->showEvent($events_data[$i]);	
}

if ($GAME["empire"]->data["admin"]==1) $GAME["template"]->showNotice("<a style=\"color:white;text-decoration:none\" href=\"admin.php\">".LANG_ADMINISTRATION_MODE."</a>");

if ($file != "blackmarket.php")
	if ($GAME["empire"]->data["blackmarket"]==1) $GAME["template"]->showNotice("<a style=\"color:white;text-decoration:none\" href=\"blackmarket.php\">".LANG_YOUR_COVERT_AGENTS_SUCCESSFULLY_CONTACTED_ILLEGAL_BLACK_MARKET."</a>");

}
			

?>