<?php


//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

function NewTurn_handleCivilStatus() {

	global $CONF_CIVIL_STATUS, $DB, $GAME;

	srand(time(NULL));
	$msg = "";

	// Civil unrest augmentation
	if ($GAME["empire"]->army->data["covertagents"] > ($GAME["empire"]->planets->data["gov_planets"] * CONF_COVERTAGENTS_PER_GOVPLANET)) {
		$r = rand(0, 100);

		if ($r <= CONF_TOO_MUCH_COVERTAGENTS_PERCENTAGE) {
			$GAME["empire"]->data["civil_status"]++;
			if ($GAME["empire"]->data["civil_status"] > 7)
				$GAME["empire"]->data["civil_status"] = 7;

			$msg .= LANG_INTERNAL_CONFLICTS_ERUPT."\r\n<br/>";
			$covertagents_lost = floor(($GAME["empire"]->army->data["covertagents"] / 100) * CONF_TOO_MUCH_COVERTAGENTS_LOST_PERCENTAGE);
			$GAME["empire"]->army->data["covertagents"] -= $covertagents_lost;
			$msg .= $GAME["template"]->formatNumber($covertagents_lost) . LANG_COVERT_AGENTS_FOUND_DEAD."\r\n<br/>";
		}

	}

	// Civil unrest recovery
	if (($GAME["empire"]->data["credits"] > 0) && ($GAME["empire"]->data["food"] > 0)) {

		// having covert agents will help to bring back the stability
		$covert = ($GAME["empire"]->army->data["covertagents"] / ($GAME["empire"]->planets->getCount() * CONF_PLANETS_CIVILSTATUS)) * 100;

		$r = rand(0, 100);
		if ($r <= $covert) {
			$GAME["empire"]->data["civil_status"]--;
			if ($GAME["empire"]->data["civil_status"] < 0)
				$GAME["empire"]->data["civil_status"] = 0;
			else
				$msg .= LANG_INSURGENCY_RECOVERING."<br>\r\n";
		}
	}

	if ($GAME["empire"]->data["civil_status"] != 0) {
		$msg .= "*** " . ($GAME["empire"]->data["civil_status"] * 8) .LANG_YOUR_ARMY_DISBANDED."<br/>\r\n";

		$GAME["empire"]->army->data["soldiers"] -= floor($GAME["empire"]->army->data["soldiers"] / 100) * ($GAME["empire"]->data["civil_status"] * 8);
		$GAME["empire"]->army->data["fighters"] -= floor($GAME["empire"]->army->data["fighters"] / 100) * ($GAME["empire"]->data["civil_status"] * 8);
		$GAME["empire"]->army->data["lightcruisers"] -= floor($GAME["empire"]->army->data["lightcruisers"] / 100) * ($GAME["empire"]->data["civil_status"] * 8);
		$GAME["empire"]->army->data["heavycruisers"] -= floor($GAME["empire"]->army->data["heavycruisers"] / 100) * ($GAME["empire"]->data["civil_status"] * 8);
		$GAME["empire"]->army->data["carriers"] -= floor($GAME["empire"]->army->data["carriers"] / 100) * ($GAME["empire"]->data["civil_status"] * 8);

	
	}

	$evt = new EventCreator($DB);
	$evt->from = -1;
	$evt->to = $GAME["empire"]->data["id"];
	$evt->seen = 1;
	$evt->type = CONF_EVENT_CIVILSTATUS;
	$evt->params = array("content"=>$msg,"civil_status"=>$CONF_CIVIL_STATUS[$GAME["empire"]->data["civil_status"]],"civil_status_id"=>$GAME["empire"]->data["civil_status"]);
	$evt->send();
	
}
?>