<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

function NewTurn_handleFoodGrowth()
{
		global $DB,$GAME;

	$food_initial = $GAME["empire"]->data["food"];
	$food_final = 0;
	$food_produced = 0;
	$food_eaten_by_population = 0;
	$food_eaten_by_soldiers = 0;
	$growrate = 0;

	/////////////////////////////////////////////
	// FOODMARKET UPDATE
	/////////////////////////////////////////////
	$foodmarket_update = time(NULL) - $GAME["template"]->coord["last_food_update"];
	if ($foodmarket_update > (60*60))
	{
		$newfood = $GAME["template"]->coord["food"] + CONF_FOODMARKET_GROWTH;
		$DB->Execute("UPDATE tb_coordinator SET food=$newfood,last_food_update=".time(NULL));
		$GAME["template"]->coord["food"] = $newfood;
	}

	/////////////////////////////////////////////
	// FOOD PRODUCED
	/////////////////////////////////////////////

	// first, raw production calculated.
	$food_produced_prime = $GAME["empire"]->planets->data["food_planets"] * CONF_FOOD_PRODUCTION;
	$food_produced_prime = $GAME["system"]->alterNumber(round(($food_produced_prime/100) * $GAME["empire"]->production->data["food_short"]),5);

	$food_produced_civilunrest = ($food_produced_prime * ($GAME["empire"]->data["civil_status"] * CONF_POP_CIVILSTATUS));
	
	// calculating procuced food
	$food_produced = $food_produced_prime - $food_produced_civilunrest;

	$food_eaten_by_population = $GAME["system"]->alterNumber(round($GAME["empire"]->data["population"] * CONF_FOOD_POPULATION_EATING),5);
	$food_eaten_by_soldiers = $GAME["system"]->alterNumber(round($GAME["empire"]->army->data["soldiers"] * CONF_FOOD_SOLDIERS_EATING),5);

	// total
	$food_final = $food_initial + $food_produced - $food_eaten_by_population - $food_eaten_by_soldiers;

	if ($food_initial == 0) $growrate = 0;
	else
	{
		$growrate = substr(((($food_final - $food_initial) / $food_initial)*100),0,5);
	}

	
	$evt = new EventCreator($DB);
	$evt->type = CONF_EVENT_FOODGROWTH;
	$evt->from = -1;
	
	$evt->to = $GAME["empire"]->data["id"];
	$evt->params = array(
		"food_initial"=>$GAME["template"]->formatFood($food_initial),
		"food_produced"=>$GAME["template"]->formatFood($food_produced),
		"food_eaten_by_population"=>$GAME["template"]->formatFood($food_eaten_by_population),
		"food_eaten_by_soldiers"=>$GAME["template"]->formatFood($food_eaten_by_soldiers),
		"food_final"=>$GAME["template"]->formatFood($food_final),
		"growrate"=>$growrate
	);
	
	$evt->seen = 1;
	$evt->send();
	
	$GAME["empire"]->data["food"] = $food_final;

	
}


?>