<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

function NewTurn_HandleLotteryPayout()
{
	global $DB,$GAME;
	if ($GAME["template"]->coord["lottery_date"] < time(NULL))
	{
		// we determine who is a winner
		$pool = array();
		$range = 0;

		$rs = $DB->Execute("SELECT * FROM tb_empire WHERE lottery_tickets > 0 AND active=1");
		while(!$rs->EOF)
		{
				
			$p = array();
			$p["empire"] = $rs->fields["id"];
			$p["start"] = $range;
			$range += $rs->fields["lottery_tickets"];
			$p["end"] = $range;
			$pool[] = $p;			
			$rs->MoveNext();
		}



		if (count($pool) != 0) {

			srand(time(NULL));
			
			$winner = rand(0,$range);
			$winner_empire = -1;

			for ($i=0;$i<count($pool);$i++)
			{
				if (($pool[$i]["start"] <= $winner) && ($pool[$i]["end"] > $winner))
				{
					$winner_empire = $pool[$i]["empire"];
					break;
				}
			}

		
			if ($winner_empire != -1) {
 				$rs = $DB->Execute("SELECT * FROM tb_empire WHERE id=$winner_empire");
				$DB->Execute("UPDATE tb_empire SET credits=".($rs->fields["credits"]+$GAME["template"]->coord["lottery_cash"])." WHERE id=$winner_empire");
				
				$evt = new EventCreator($DB);
				$evt->type = CONF_EVENT_LOTTERYWINNER;
				$evt->from = -1;
				$evt->params = array("empire_id"=>$rs->fields["id"],"empire_emperor"=>$rs->fields["emperor"],"empire_name"=>$rs->fields["name"],"gender"=>$rs->fields["gender"],"lottery_cash"=>$GAME["template"]->coord["lottery_cash"]);
				$evt->broadcast();
			
				$GAME["template"]->coord["lottery_cash"] = 0;
			}
		}

	}

	if ($GAME["template"]->coord["lottery_cash"] == 0)
	{		
		$date = mktime(0,0,1,date("m"),date("d")+1,date("Y"));

		$jackpot = 0;		
		$count = 0;
		$rs = $DB->Execute("SELECT credits FROM tb_empire WHERE admin=0 AND active=1");
		while (!$rs->EOF)
		{
			$jackpot += abs($rs->fields["credits"]);
			$count++;
			$rs->MoveNext();
		}
		
		$jackpot /= ($count>0?$count:1);
		
		$jackpot = $GAME["system"]->alterNumber($jackpot,25);
		
		$query = "UPDATE tb_coordinator SET lottery_cash=".$jackpot.",lottery_date=$date";
		$DB->Execute($query);

		$query = "UPDATE tb_empire SET lottery_tickets=0 WHERE active = 1";
		$DB->Execute($query);

	}

}

?>