<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

function NewTurn_HandleMilitaryProduction()
{
	global $DB,$GAME;
	
	$production =  round(($GAME["empire"]->planets->data["supply_planets"]/100)*$GAME["empire"]->production->data["supply_short"]);
	$production += rand(0,$production/16);
	$production /= 100;

	$psoldiers = $GAME["system"]->alterNumber(floor($GAME["empire"]->supply->data["rate_soldier"] * $production * CONF_MILITARY_PRODUCTION_SOLDIER),5);
	$pfighters = $GAME["system"]->alterNumber(floor($GAME["empire"]->supply->data["rate_fighter"] * $production * CONF_MILITARY_PRODUCTION_FIGHTER),5);
	$pstations = $GAME["system"]->alterNumber(floor($GAME["empire"]->supply->data["rate_station"] * $production * CONF_MILITARY_PRODUCTION_STATION),5);
	$pcredits = $GAME["system"]->alterNumber(floor($GAME["empire"]->supply->data["rate_credits"] * $production * CONF_MILITARY_PRODUCTION_CREDITS),5);

	$plightcruisers = (($GAME["empire"]->planets->data["research_planets"]/100)*$GAME["empire"]->production->data["research_short"]) *  CONF_RESEARCH_LIGHTCRUISER;
	$plightcruisers += rand(0,$plightcruisers/16);
	$plightcruisers = $GAME["system"]->alterNumber($plightcruisers,5);

	$pheavycruisers = $GAME["system"]->alterNumber(floor($GAME["empire"]->supply->data["rate_heavycruiser"] * $production * CONF_MILITARY_PRODUCTION_HEAVYCRUISER),5);
	$pcarriers = $GAME["system"]->alterNumber(floor($GAME["empire"]->supply->data["rate_carrier"] * $production * CONF_MILITARY_PRODUCTION_CARRIER),5);
	$pgenerals = $GAME["system"]->alterNumber(floor($GAME["empire"]->supply->data["rate_general"] * $production * CONF_MILITARY_PRODUCTION_GENERAL),5);
	$pcovertagents = $GAME["system"]->alterNumber(floor($GAME["empire"]->supply->data["rate_covert"] * $production * CONF_MILITARY_PRODUCTION_COVERT),5);
	
	$GAME["empire"]->army->data["soldiers"] += $psoldiers;
	$GAME["empire"]->army->data["fighters"] += $pfighters;
	$GAME["empire"]->army->data["stations"] += $pstations;
	$GAME["empire"]->army->data["lightcruisers"] += $plightcruisers;
	$GAME["empire"]->army->data["heavycruisers"] += $pheavycruisers;
	$GAME["empire"]->army->data["carriers"] += $pcarriers;
	$GAME["empire"]->army->data["covertagents"] += $pcovertagents;
	$GAME["empire"]->army->data["generals"] += $pgenerals;
	$GAME["empire"]->data["credits"] += $pcredits;
	

	
	if ($GAME["empire"]->army->data["commandship"] != 0) {
		$GAME["empire"]->army->data["commandship"] += 5;
		if ($GAME["empire"]->army->data["commandship"] > 100) $GAME["empire"]->army->data["commandship"] = 100;
	}
	
	$evt = new EventCreator($DB);
	$evt->from = -1;
	$evt->type = CONF_EVENT_MILITARYPRODUCTION;
	$evt->to = $GAME["empire"]->data["id"];
	$evt->seen = 1;
	$evt->params = array(
		"soldiers"=>$GAME["template"]->formatNumber($GAME["empire"]->army->data["soldiers"]),
		"fighters"=>$GAME["template"]->formatNumber($GAME["empire"]->army->data["fighters"]),
		"stations"=>$GAME["template"]->formatNumber($GAME["empire"]->army->data["stations"]),
		"lightcruisers"=>$GAME["template"]->formatNumber($GAME["empire"]->army->data["lightcruisers"]),
		"heavycruisers"=>$GAME["template"]->formatNumber($GAME["empire"]->army->data["heavycruisers"]),
		"carriers"=>$GAME["template"]->formatNumber($GAME["empire"]->army->data["carriers"]),
		"covertagents"=>$GAME["template"]->formatNumber($GAME["empire"]->army->data["covertagents"]),
		"psoldiers"=>$GAME["template"]->formatNumber($psoldiers),
		"pfighters"=>$GAME["template"]->formatNumber($pfighters),
		"pstations"=>$GAME["template"]->formatNumber($pstations),
		"pcredits"=>$GAME["template"]->formatCredits($pcredits),
		"plightcruisers"=>$GAME["template"]->formatNumber($plightcruisers),
		"pheavycruisers"=>$GAME["template"]->formatNumber($pheavycruisers),
		"pcarriers"=>$GAME["template"]->formatNumber($pcarriers),
		"pcovertagents"=>$GAME["template"]->formatNumber($pcovertagents),
		"pgenerals"=>$GAME["template"]->formatNumber($pgenerals),
		 "soldiers_level"=>$GAME["empire"]->army->data["soldiers_level"],
		"fighters_level"=>$GAME["empire"]->army->data["fighters_level"],
		"stations_level"=>$GAME["empire"]->army->data["stations_level"],
		"lightcruisers_level"=>$GAME["empire"]->army->data["lightcruisers_level"],
		"heavycruisers_level"=>$GAME["empire"]->army->data["heavycruisers_level"],
		"carriers_level"=>$GAME["empire"]->army->data["carriers_level"],
		"covertagents_level"=>$GAME["empire"]->army->data["covertagents_level"],
		"generals_level"=>$GAME["empire"]->army->data["generals_level"]
	);
	
	$evt->send();
}

?>