<?php


//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

function NewTurn_handleMoneyGrowth() {
	
	global $DB, $GAME;
	
	$money_initial = $GAME["empire"]->data["credits"];
	$money_final = 0;
	$growrate = 0;
	$playerscount = $DB->Execute("SELECT COUNT(*) FROM tb_empire WHERE active=1");
	$playerscount = $playerscount->fields[0];

	$galactic_tax_income = floor(($GAME["template"]->coord["taxcash"] / $playerscount) / 200);
	if ($GAME["empire"]->data["turns_played"] < 20) {
		$galactic_tax_income = floor($GAME["empire"]->data["turns_played"]*($galactic_tax_income/20));
	}
	
	$query = "UPDATE tb_coordinator SET taxcash=" . ($GAME["template"]->coord["taxcash"] - $galactic_tax_income);
	$DB->Execute($query);

	$GAME["template"]->coord["taxcash"] -= $galactic_tax_income;

	$population_tax_income = $GAME["system"]->alterNumber(floor($GAME["empire"]->data["population"] * $GAME["empire"]->data["taxrate"] * CONF_INCOME_POPTAX), 5);

	$urban_tax_income = floor($GAME["empire"]->data["population"] * $GAME["empire"]->planets->data["urban_planets"] * CONF_INCOME_URBANTAX);
	$urban_tax_income = $GAME["system"]->alterNumber(floor(($urban_tax_income / 100) * $GAME["empire"]->production->data["urban_short"]), 5);

	$ore_production_income = ($GAME["empire"]->planets->data["ore_planets"] + $GAME["empire"]->data["turns_played"]) * CONF_INCOME_ORE;
	$ore_production_income = $GAME["system"]->alterNumber(floor(($ore_production_income / 100) * $GAME["empire"]->production->data["ore_short"]), 5);

	$tourism_income = ($GAME["empire"]->planets->data["tourism_planets"] + $GAME["empire"]->data["turns_played"]) * CONF_INCOME_TOURISM;
	$tourism_income = $GAME["system"]->alterNumber(floor(($tourism_income / 100) * $GAME["empire"]->production->data["tourism_short"]), 5);

	$tourism_civilunrest = ($tourism_income * ($GAME["empire"]->data["civil_status"] * CONF_POP_CIVILSTATUS));
	$tourism_income -= $tourism_civilunrest;
	if ($tourism_income < 0)
		$tourism_income = 0;

	$petro_production_income = $GAME["empire"]->planets->data["petro_planets"] * (floor((100 - (@ ($GAME["empire"]->planets->data["petro_planets"] / $GAME["empire"]->planets->getCount()) * 100)) / 100 * CONF_INCOME_PETROLEUM));

	$petro_production_income = $GAME["system"]->alterNumber(floor(($petro_production_income / 100) * $GAME["empire"]->production->data["petro_short"]), 5);

	$income = $galactic_tax_income + $population_tax_income + $urban_tax_income + $ore_production_income + $tourism_income + $petro_production_income;

	$galactic_tax_payment = $GAME["system"]->alterNumber(floor(($GAME["empire"]->data["credits"] + $income) * (CONF_INTERGALACTIC_TAX / 100)), 5);
	if ($galactic_tax_payment > 0) {
		$query = "UPDATE tb_coordinator SET taxcash=" . ($GAME["template"]->coord["taxcash"] + $galactic_tax_payment);
		$GAME["template"]->coord["taxcash"] += $galactic_tax_payment;
		$DB->Execute($query);
	}

	$planets_maintenance = $GAME["system"]->alterNumber((($GAME["empire"]->planets->getCount() - $GAME["empire"]->planets->data["gov_planets"]) * (CONF_MAINTENANCE_PLANETS + $GAME["empire"]->data["turns_played"])), 5);
	$planets_maintenance_reduction = floor((($GAME["empire"]->planets->data["gov_planets"]*4) / ($GAME["empire"]->planets->getCount() - $GAME["empire"]->planets->data["gov_planets"])) * $planets_maintenance);

	$planets_maintenance -= $planets_maintenance_reduction;
	if ($planets_maintenance < 0) $planets_maintenance = 0;
	
	$military_maintenance = $GAME["empire"]->army->data["soldiers"] * CONF_MAINTENANCE_SOLDIER;
	$military_maintenance += $GAME["empire"]->army->data["fighters"] * CONF_MAINTENANCE_FIGHTER;
	$military_maintenance += $GAME["empire"]->army->data["stations"] * CONF_MAINTENANCE_STATION;
	$military_maintenance += $GAME["empire"]->army->data["lightcruisers"] * CONF_MAINTENANCE_LIGHTCRUISER;
	$military_maintenance += $GAME["empire"]->army->data["heavycruisers"] * CONF_MAINTENANCE_HEAVYCRUISER;
	$military_maintenance += $GAME["empire"]->army->data["carriers"] * CONF_MAINTENANCE_CARRIER;

	if ($military_maintenance < 0) $military_maintenance = 0;

	$military_maintenance = $GAME["system"]->alterNumber($military_maintenance, 5);
	
	/* Bond payment */
	$query = "SELECT * FROM tb_bond WHERE empire=".$GAME["empire"]->data["id"];
	$rs = $DB->Execute($query);
	while(!$rs->EOF) {
		
		$rs->fields["turns_left"]--;
		if ($rs->fields["turns_left"] ==0) {

			$GAME["empire"]->data["credits"] += $rs->fields["current_credits"];
			$income += $rs->fields["current_credits"];
			$GAME["empire"]->save();
			$DB->Execute("DELETE FROM tb_bond WHERE id=".$rs->fields["id"]);
			
			$evt = new EventCreator($DB);
			$evt->from = -1;
			$evt->seen = 1;
			
			$evt->to = $GAME["empire"]->data["id"];
			$evt->type = CONF_EVENT_BOND_PAYOUT;
			$evt->params = array("current_credits"=>$rs->fields["current_credits"]);
			$evt->send();
			
		} else {
		
			$rs->fields["current_credits"] += floor(($rs->fields["current_credits"] / 100) * $rs->fields["rate"]);
			$DB->Execute("UPDATE tb_bond SET turns_left=".$rs->fields["turns_left"].",current_credits=".$rs->fields["current_credits"]." WHERE id=".$rs->fields["id"]);	
		}
		
		$rs->MoveNext();
	}
	
	/* Loans management */
	$loans_payment = 0;

	$query = "SELECT * FROM tb_loan WHERE empire=" . $GAME["empire"]->data["id"];
	$rs = $DB->Execute($query);
	while (!$rs->EOF) {
	
		if ($rs->fields["turns_left"] == 0) {

			$DB->Execute("DELETE FROM tb_loan WHERE id=" .	$rs->fields["id"]);
		}

		if ($rs->fields["turns_left"] > 0) {
			$loan = $rs->fields["current_credits"] / $rs->fields["turns_left"];
			$loan = $loan + (($loan / 100) * $rs->fields["rate"]);
			$loan = round($loan);

			$loans_payment += $loan;

			$DB->Execute("UPDATE tb_loan SET current_credits=" .
			 ($rs->fields["current_credits"] - ($rs->fields["current_credits"] / $rs->fields["turns_left"])) . ",turns_left=" . ($rs->fields["turns_left"] - 1) . " WHERE id=" . $rs->fields["id"]);
		
		}

		$rs->MoveNext();
		
	}

	if ($loans_payment != 0) {

		$tolottery = round(($loans_payment / 100) * CONF_SOLARBANK_LOTTERY);
		$DB->Execute("UPDATE tb_coordinator SET lotery_cash=" . ($GAME["template"]->coord["lottery_cash"] + $tolottery));
	}

	$payment = $galactic_tax_payment + $loans_payment + $planets_maintenance + $military_maintenance;

	$money_final = $money_initial + $income - $payment;
	$money_lastturn = $GAME["empire"]->data["last_credits"];

	if ($money_lastturn == 0)
		$money_lastturn = 1;
	if ($money_initial <= 0) {
		$growrate = 0;
	} else {
		$growrate = (($money_final - $money_lastturn) / $money_lastturn) * 100;
		$growrate = substr($growrate, 0, 5);
	}

	
	$total_incomes = $galactic_tax_income + $population_tax_income + $urban_tax_income + $ore_production_income + $tourism_income + $petro_production_income;
	$total_payments = $galactic_tax_payment + $planets_maintenance + $military_maintenance;

	$evt = new EventCreator($DB);
	$evt->seen = 1;
	$evt->from = -1;
	$evt->to = $GAME["empire"]->data["id"];
	$evt->type = CONF_EVENT_MONEYGROWTH;
	$evt->params = array(
		"money_initial"=>$GAME["template"]->formatCredits($money_initial),
		"galactic_tax_income"=>$GAME["template"]->formatCredits($galactic_tax_income),
		"population_tax_income"=>$GAME["template"]->formatCredits($population_tax_income),
		"taxrate"=>$GAME["empire"]->data["taxrate"],
		"urban_tax_income"=>$GAME["template"]->formatCredits($urban_tax_income),
		"ore_production_income"=>$GAME["template"]->formatCredits($ore_production_income),
		"tourism_income"=>$GAME["template"]->formatCredits($tourism_income),
		"petro_production_income"=>$GAME["template"]->formatCredits($petro_production_income),
		"galactic_tax_payment"=>$GAME["template"]->formatCredits($galactic_tax_payment),
		"planets_maintenance"=>$GAME["template"]->formatCredits($planets_maintenance),
		"military_maintenance"=>$GAME["template"]->formatCredits($military_maintenance),
		"money_final"=>$GAME["template"]->formatCredits($money_final),
		"loans_payment"=>$GAME["template"]->formatCredits($loans_payment),
		"total_incomes"=>$GAME["template"]->formatCredits($total_incomes),
		"total_payments"=>$GAME["template"]->formatCredits($total_payments),
		"growrate"=>$growrate
	);
	$evt->send();
	
	$GAME["empire"]->data["last_credits"] = $money_final;
	$GAME["empire"]->data["credits"] = $money_final;

}
?>