<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

function NewTurn_handlePirateRaid()
{
	global $DB,$GAME;

	srand(time(NULL));
	$malus = 0;
	$rs = $DB->Execute("SELECT COUNT(*) FROM tb_empire WHERE last_hostname='".addslashes($GAME["empire"]->data["last_hostname"])."'");
	if ($rs->fields[0] > 2) {
		$malus += (2*($rs->fields[0]-1));
		$r = rand(1,2);
	}
	else {
		if ($GAME["empire"]->data["protection_turns_left"] > 0) 
			$r = rand(1,16);
		else
			$r = rand(1,4);
			
	}
	
	if ($r == 1) {

		$pirate = $DB->Execute("SELECT * FROM tb_pirate ORDER BY rand() LIMIT 1");
		$pirate = $pirate->fields;
		$p = rand(1,10+$malus);
		
		$msg = "";
		
		switch(rand(1,16)) 
		{
			
			/*************************************************************/
			case 1:
				$lost_soldiers = floor(($GAME["empire"]->army->data["soldiers"] / 100) * $p);
				if ($lost_soldiers == 0) return;
				$msg = $GAME["template"]->formatNumber($lost_soldiers).LANG_SOLDIERS_DESERTED;
				$GAME["empire"]->army->data["soldiers"] -= $lost_soldiers;
				$pirate["soldiers"] += $lost_soldiers;
			break;
		
			/*************************************************************/
			case 2:	
				$lost_fighters = floor(($GAME["empire"]->army->data["fighters"] / 100) * $p);
				if ($lost_fighters == 0) return;
				$msg = $GAME["template"]->formatNumber($lost_fighters).LANG_FIGHTERS_STOLEN;
				$GAME["empire"]->army->data["fighters"] -= $lost_fighters;
				$pirate["fighters"] += $lost_fighters;
			break;
		
			/*************************************************************/
			case 3:
				$lost_stations = floor(($GAME["empire"]->army->data["stations"] / 100) * $p);
				if ($lost_stations == 0) return;
				$msg = $GAME["template"]->formatNumber($lost_stations).LANG_DEFENSE_STATIONS_STOLEN;
				$GAME["empire"]->army->data["stations"] -= $lost_stations;
				$pirate["stations"] += $lost_stations;
				
			break;

			/*************************************************************/
			case 4:
				$lost_lightcruisers = floor(($GAME["empire"]->army->data["lightcruisers"] / 100) * $p);
				if ($lost_lightcruisers == 0) return;
				$msg = $GAME["template"]->formatNumber($lost_lightcruisers).LANG_LIGHT_CRUISERS_STOLEN;
				$GAME["empire"]->army->data["lightcruisers"] -= $lost_lightcruisers;
				$pirate["lightcruisers"] += $lost_lightcruisers;
				
			break;
			
			/*************************************************************/
			case 5:
				$lost_heavycruisers = floor(($GAME["empire"]->army->data["heavycruisers"] / 100) * $p);
				if ($lost_heavycruisers == 0) return;
				$msg = $GAME["template"]->formatNumber($lost_heavycruisers).LANG_HEAVY_CRUISERS_STOLEN;
				$GAME["empire"]->army->data["heavycruisers"] -= $lost_heavycruisers;
				$pirate["heavycruisers"] += $lost_heavycruisers;
				
			break;

	
			/*************************************************************/
			case 6:
				$lost_carriers = floor(($GAME["empire"]->army->data["carriers"] / 100) * $p);
				if ($lost_carriers == 0) return;
				$msg = $GAME["template"]->formatNumber($lost_carriers).LANG_CARRIERS_STOLEN;
				$GAME["empire"]->army->data["carriers"] -= $lost_carriers;
				$pirate["carriers"] += $lost_carriers;
				
			break;
			

			/*************************************************************/
			case 7:
				$lost_credits = floor(($GAME["empire"]->data["credits"] / 100) * $p);
				if ($lost_credits == 0) return;
				$msg = $GAME["template"]->formatCredits($lost_credits).LANG_STOLEN_BY_PIRATE_GANG;
				$GAME["empire"]->data["credits"] -= $lost_credits;
				$pirate["credits"] += $lost_credits;
				
			break;


			/*************************************************************/
			case 8:
				$lost_food = floor(($GAME["empire"]->data["food"] / 100) * $p);
				if ($lost_food == 0) return;
				$msg = $GAME["template"]->formatFood($lost_food).LANG_STOLEN_BY_PIRATE_GANG;
				$GAME["empire"]->data["food"] -= $lost_food;
				$pirate["food"] += $lost_food;
			break;
				
			/*************************************************************/
			case 9:
				$lost_covertagents = floor(($GAME["empire"]->army->data["covertagents"] / 100) * $p);
				if ($lost_covertagents == 0) return;
				$msg = $GAME["template"]->formatNumber($lost_covertagents).LANG_COVERT_AGENTS_DESERTED;
				$GAME["empire"]->army->data["covertagents"] -= $lost_covertagents;
				$pirate["covertagents"] += $lost_covertagents;
			break;
			
			/*************************************************************/
			case 10:
				$lost_generals = floor(($GAME["empire"]->army->data["generals"] / 100) * $p);
				if ($lost_generals == 0) return;
				$msg = $GAME["template"]->formatNumber($lost_generals).LANG_GENERALS_DESERTED;
				$GAME["empire"]->army->data["generals"] -= $lost_generals;
				$pirate["generals"] += $lost_generals;
			break;
	
	
			/*************************************************************/
			case 11:
				$lost_planets = floor(($GAME["empire"]->planets->data["food_planets"] / 100) * $p);
				if ($lost_planets == 0) return;
				$msg = $GAME["template"]->formatNumber($lost_planets).LANG_FOOD_PLANETS_STOLEN;
				$pirate["food_planets"] += $lost_planets;
				$GAME["empire"]->planets->data["food_planets"] -= $lost_planets;
			break;
			

			/*************************************************************/
			case 12:
				$lost_planets = floor(($GAME["empire"]->planets->data["ore_planets"] / 100) * $p);
				if ($lost_planets == 0) return;
				$msg = $GAME["template"]->formatNumber($lost_planets).LANG_ORE_PLANETS_STOLEN;
				$pirate["ore_planets"] += $lost_planets;
				$GAME["empire"]->planets->data["ore_planets"] -= $lost_planets;
			break;
					
			/*************************************************************/
			case 13:
				$lost_planets = floor(($GAME["empire"]->planets->data["tourism_planets"] / 100) * $p);
				if ($lost_planets == 0) return;
				$msg = $GAME["template"]->formatNumber($lost_planets).LANG_TOURISM_PLANETS_STOLEN;
				$pirate["tourism_planets"] += $lost_planets;
				$GAME["empire"]->planets->data["tourism_planets"] -= $lost_planets;
			break;		


			/*************************************************************/
			case 14:
				$lost_planets = floor(($GAME["empire"]->planets->data["petro_planets"] / 100) * $p);
				if ($lost_planets == 0) return;
				$msg = $GAME["template"]->formatNumber($lost_planets).LANG_PETROLEUM_PLANETS_STOLEN;
				$pirate["petro_planets"] += $lost_planets;
				$GAME["empire"]->planets->data["petro_planets"] -= $lost_planets;
			break;

			/*************************************************************/
			case 15:
				$lost_planets = floor(($GAME["empire"]->planets->data["supply_planets"] / 100) * $p);
				if ($lost_planets == 0) return;
				$msg = $GAME["template"]->formatNumber($lost_planets).LANG_SUPPLY_PLANETS_STOLEN;
				$pirate["supply_planets"] += $lost_planets;
				$GAME["empire"]->planets->data["supply_planets"] -= $lost_planets;
			break;
		
			/*************************************************************/
			case 16:
				$lost_planets = floor(($GAME["empire"]->planets->data["research_planets"] / 100) * $p);
				if ($lost_planets == 0) return;
				$msg = $GAME["template"]->formatNumber($lost_planets).LANG_RESEARCH_PLANETS_STOLEN;
				$pirate["research_planets"] += $lost_planets;
				$GAME["empire"]->planets->data["research_planets"] -= $lost_planets;

			break;
		}

		/* Update pirate networth */
		$networth = 0;
		$networth += ($pirate["credits"] * CONF_NETWORTH_CREDITS);
	
		$planets = 0;
		$planets += $pirate["food_planets"];
		$planets += $pirate["ore_planets"];
		$planets += $pirate["tourism_planets"];
		$planets += $pirate["supply_planets"];
		$planets += $pirate["gov_planets"];
		$planets += $pirate["edu_planets"];
		$planets += $pirate["research_planets"];
		$planets += $pirate["urban_planets"];
		$planets += $pirate["petro_planets"];
		$planets += $pirate["antipollu_planets"];
		$networth += ($planets * CONF_NETWORTH_PLANETS);

		$army = 0;
		$army += $pirate["soldiers"] * CONF_NETWORTH_MILITARY_SOLDIER;
		$army += $pirate["fighters"]* CONF_NETWORTH_MILITARY_FIGHTER;
		$army += $pirate["stations"]* CONF_NETWORTH_MILITARY_STATION;
		$army += $pirate["lightcruisers"]* CONF_NETWORTH_MILITARY_LIGHTCRUISER;
		$army += $pirate["heavycruisers"]* CONF_NETWORTH_MILITARY_HEAVYCRUISER;
		$army += $pirate["carriers"]* CONF_NETWORTH_MILITARY_CARRIER;
		$army += $pirate["generals"]* CONF_NETWORTH_MILITARY_GENERAL;
		$army += $pirate["covertagents"]* CONF_NETWORTH_MILITARY_COVERT;

		$networth += $army;
		
		$pirate["networth"] = floor($networth);
		
		/* Update pirate data */
		$query = "UPDATE tb_pirate SET ";
		while(list($key,$value) = each($pirate)) {
				if ($key == "id") continue;
			if (is_numeric($key)) continue;
			if ((is_numeric($value)) && ($key != "logo"))
				$query .= "$key=$value,";
			else
				$query .= "$key='$value',";
			
		}
		$query = substr($query,0,strlen($query)-1); // removing remaining ,
		$query .= " WHERE id=".$pirate["id"];
		$DB->Execute($query);
		
		$evt = new EventCreator($DB);
		$evt->type = CONF_EVENT_PIRATERAID;
		$evt->from = -1;
		$evt->seen = 1;
		$evt->to = $GAME["empire"]->data["id"];
		$evt->params = array("message"=>str_replace("{pirate_name}",$pirate["name"],$msg));
		$evt->send();
	
	}
}


?>
