<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

function NewTurn_PickRandomEvent()
{
	global $CONF_RANDOM_EVENTS,$GAME,$DB;
	srand(time(NULL));
	$p = rand(0,100);
	if ($p > CONF_RANDOMEVENT_PERCENTAGE) {
		return;
	}
	
	
	// Pick a random event
	$event = $CONF_RANDOM_EVENTS[rand(0,count($CONF_RANDOM_EVENTS)-1)];

	$action = explode("->",$event["value"]);
	$action_params = explode("=",$action[1]);
	$action_label = $action_params[0];
	$action_value = $action_params[1];
	$action_percent = false;
	
	if ($action_value[strlen($action_value)-1] == "%") {
		$action_value = substr($action_value,0,strlen($action_value)-1);
		$action_percent = true;		
	}
	
	$action_positive = true;
	if ($action_value[0] == "-") $action_positive = false;
	$action_value = substr($action_value,1);
		
	switch($action[0]) {
	
		//////////////////////////////////////////////////////////////
		case "empire":
			$initial_value = $GAME["empire"]->data[$action_label];
			$final_value = $initial_value;
			
			if ($action_percent) {
				$initial_value /= 100;
				$value = $initial_value * $action_value;
				
				if ($action_positive)
					$final_value += $value;
				else
					$final_value -= $value;
					
			} else {
				
				if ($action_positive)
					$final_value += $action_value;
				else
					$final_value -= $action_value;
			}
			
			$GAME["empire"]->data[$action_label] = $final_value;
			
		break;
		
		//////////////////////////////////////////////////////////////
		case "production":
			$initial_value = $GAME["empire"]->production->data[$action_label];
			$final_value = $initial_value;
			
			if ($action_percent) {
				$initial_value /= 100;
				$value = $initial_value * $action_value;
				
				if ($action_positive)
					$final_value += $value;
				else
					$final_value -= $value;
					
			} else {
				
				if ($action_positive)
					$final_value += $action_value;
				else
					$final_value -= $action_value;
			}
			
			$GAME["empire"]->production->data[$action_label] = $final_value;
		break;
		
		//////////////////////////////////////////////////////////////
		case "coordinator":

			if ($action_label == "terraform") {
			
				// add planets
				$query = "UPDATE tb_coordinator SET ";
				$query .= "food_planets=".$GAME["template"]->coord["food_planets"]+$action_value.",".
				$query .= "ore_planets=".$GAME["template"]->coord["ore_planets"]+$action_value.",".
				$query .= "supply_planets=".$GAME["template"]->coord["supply_planets"]+$action_value.",".
				$query .= "tourism_planets=".$GAME["template"]->coord["tourism_planets"]+$action_value.",".
				$query .= "supply_planets=".$GAME["template"]->coord["supply_planets"]+$action_value.",".
				$query .= "edu_planets=".$GAME["template"]->coord["edu_planets"]+$action_value.",".
				$query .= "gov_planets=".$GAME["template"]->coord["gov_planets"]+$action_value.",".
				$query .= "research_planets=".$GAME["template"]->coord["research_planets"]+$action_value.",".
				$query .= "petro_planets=".$GAME["template"]->coord["petro_planets"]+$action_value.",".
				$query .= "antipollu_planets=".$GAME["template"]->coord["antipollu_planets"]+$action_value;
					
				$DB->Execute($query);
			}
			
		break;
		
	}
	

	
	// send a event
	$evt = new EventCreator($DB);
	$evt->type = CONF_EVENT_RANDOMEVENT;
	$evt->from = -1;
	$evt->to = $GAME["empire"]->data["id"];
	$evt->seen = 1;
	$evt->params = $event;
	$evt->send();
	
}



?>