<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

function NewTurn_handleResearchGrowth()
{
	global $GAME,$DB;
	
	$points = $GAME["empire"]->research->getGrowthPoints(
		$GAME["empire"]->planets->data["research_planets"],
		$GAME["empire"]->production->data["research_short"]);

	$GAME["empire"]->data["research_points"] += $points;
	
	if ($GAME["empire"]->data["research_tech_id"] == -1) {
	
		// fundamental research
		$maxpoints = ($GAME["empire"]->data["research_level"]+1);
		$maxpoints = $maxpoints * (($maxpoints * $maxpoints) * CONF_RESEARCH_BASECOST);
		if ($GAME["empire"]->data["research_points"] >= $maxpoints)
		{
			$GAME["empire"]->data["research_points"] = 0;
			if ($GAME["empire"]->data["research_level"] != 9) {
				$GAME["empire"]->data["research_level"]++;
				$evt = new EventCreator($DB);
				$evt->type = CONF_EVENT_RESEARCHDONE;
				$evt->from = -1;
				$evt->seen = 1;
				$evt->to = $GAME["empire"]->data["id"];
				$evt->params = array("tech_name"=>LANG_FUNDAMENTAL_RESEARCH,"tech_image"=>"images/research/fundamental.gif");
				$evt->send();
			
				if ($GAME["empire"]->data["research_level"] > 5) {
					$evt = new EventCreator($DB);
					$evt->type = CONF_EVENT_FUNDAMENTAL_COMPLETED;
					$evt->from = -1;
					$evt->seen = 1;
					$evt->to = $GAME["empire"]->data["id"];
					$empire = $GAME["template"]->displayEmpireHTML($GAME["empire"]->data["id"],$GAME["empire"]->data["emperor"],$GAME["empire"]->data["name"],$GAME["empire"]->data["networth"]);
					$evt->params = array("research_level"=>$GAME["empire"]->data["research_level"],"empire"=>$empire);
					$evt->broadcast();
				}
			}
		}
		
	} else {
		
		// specific tech
		$tech_data = $GAME["empire"]->research->getTechFromId($GAME["empire"]->data["research_tech_id"]);
		if ($GAME["empire"]->data["research_points"] >= $tech_data["cost"])
		{
			$GAME["empire"]->data["research_points"] = 0;

			$evt = new EventCreator($DB);
			$evt->type = CONF_EVENT_RESEARCHDONE;
			$evt->from = -1;
			$evt->seen = 1;
			$evt->to = $GAME["empire"]->data["id"];
			$evt->params = array("tech_name"=>$tech_data["name"],"tech_image"=>$tech_data["image"]);
			$evt->send();

			$target = explode("_",$tech_data["target"]);
			switch($target[1]) {
				case "level":
					$GAME["empire"]->army->data[$tech_data["target"]] = floor($tech_data["value"]);
											
				break;
				
				case "protection":
					$GAME["empire"]->data["protection_turns_left"] += floor($tech_data["value"]);
				break;
				
				case "production":

					$GAME["empire"]->production->data[$target[0]."_long"] += floor($tech_data["value"]);
				break;	
			}	
			
			$DB->Execute("INSERT INTO tb_research_done (empire_id,tech_id) VALUES(".$GAME["empire"]->data["id"].",".$tech_data["id"].")");
			$GAME["empire"]->data["research_tech_id"] = -1;	
		}
	}
	
}