<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2007.02.25 : ybo : Galaxypedia is now a standalone application / project
//
//---------------------------------------------------------------------------//

require_once ("include/init.php");

$current_parent = -1;


if (isset($_GET["logout"])) {
	unset($_SESSION["admin"]);
	session_destroy();

}

if (isset ($_GET["parent"]))
	$current_parent = $_GET["parent"];
if (isset($_GET["topic"])) $current_parent = $_GET["topic"];

if (count($_GET) == 0) {
	header("Location: index.php?search=introduction");
	die();
}

if (isset($_GET["admin"])) {
	if ($_GET["admin"] == CONF_ADMIN_PASSWORD) $_SESSION["admin"] = true;
	header("Location: index.php?search=introduction");	
	die();
}


if (isset($_GET["WARNING"])) {
print "<SCRIPT>alert('".$_GET["WARNING"]."');</SCRIPT>";
}

//////////////////////////////////////////////////////////////////////////////
// Handle requests
//////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////
// PDF CREATION
//////////////////////////////////////////////////////////////////////////////
if (isset($_SESSION["admin"])) 
if (isset($_GET["pdf"])) {


require_once("include/thirdparty/class.ezpdf.php");


function recurseTopicTOC($parent_id,$depth,$prefix,&$pdf)
{
	global $DB;

	$rs = $DB->Execute("SELECT * FROM tb_gp_topic WHERE parent=".addslashes($parent_id)." ORDER BY name ASC");
	$count = 0;
	$pad = "";
	for ($i=0;$i<$depth;$i++) $pad .= "      ";
	if ($prefix != "") $pad .= $prefix.".";
	
	while(!$rs->EOF)
	{	
		$count++;
		$pdf->ezText("<b>".$pad.$count."</b> "."<u><c:ilink:topic_".$rs->fields["id"].">".trim($rs->fields["name"])."</c:ilink></u>",16);

		if ($prefix != "")
			recurseTopicTOC($rs->fields["id"],$depth+1,$prefix.".".$count,$pdf);
		else
			recurseTopicTOC($rs->fields["id"],$depth+1,$count,$pdf);
	
		$rs->MoveNext();
	}
	
}

function recurseTopicContent($parent_id,$depth,$prefix,&$pdf)
{
	global $DB;

	$rs = $DB->Execute("SELECT * FROM tb_gp_topic WHERE parent=".addslashes($parent_id)." ORDER BY name ASC");
	$count = 0;
	$pad = "";
//	for ($i=0;$i<$depth;$i++) $pad .= "      ";
	if ($prefix != "") $pad .= $prefix.".";
	
	while(!$rs->EOF)
	{	
		$count++;
		$pdf->addDestination("topic_".$rs->fields["id"],"Fit");
		$pdf->ezText("<b>".$pad.$count." ".$rs->fields["name"]."</b>\n",16);
		$content = stripslashes($rs->fields["content"]);
		$content = str_replace("<br/>","\n",$content);
		$pdf->ezText($content,14,array("justification"=>"full"));
		$pdf->ezText("\n\n",14);


		if ($prefix != "")
			recurseTopicContent($rs->fields["id"],$depth+1,$prefix.".".$count,$pdf);
		else
			recurseTopicContent($rs->fields["id"],$depth+1,$count,$pdf);
	
		$rs->MoveNext();
	
	}

	if ($count > 0) $pdf->ezNewPage();

}
	
$pdf = new Cezpdf('a4','portrait');

$pdf -> ezSetMargins(50,70,50,50);

// put a line top and bottom on all the pages
$all = $pdf->openObject();
$pdf->saveState();
$pdf->setStrokeColor(0,0,0,1);
$pdf->line(20,40,578,40);
$pdf->line(20,822,578,822);
$pdf->addText(20,24,6,'Solar Imperium GalaxyPedia');
$pdf->restoreState();
$pdf->closeObject();
// note that object can be told to appear on just odd or even pages by changing 'all' to 'odd'
// or 'even'.
$pdf->addObject($all,'all');

$pdf->ezSetDy(-100);

$mainFont = 'include/thirdparty/fonts/Helvetica.afm';
// select a font
$pdf->selectFont($mainFont);
$pdf->addJpegFromFile("images/sword.jpg",250,450,100);

$pdf->ezText("GalaxyPedia\n",32,array('justification'=>'centre'));
$pdf->ezText("\n\n\n\n\n\n\n\nSolar Imperium Documentation\nGenerated: ".date("H:i:s m/d/y")."\n",20,array('justification'=>'centre'));
$pdf->ezText("Written by the Galactic Scribe \n<c:alink:http://www.solarimperium.com>http://www.solarimperium.com</c:alink>",12,array('justification'=>'centre'));

$pdf->ezSetDy(-100);

$pdf->openHere('Fit');

$pdf->ezNewPage();

$pdf->ezStartPageNumbers(500,28,10,'','',1);

$pdf->ezText("Table of content\n",20);

recurseTopicTOC(-1,1,"",$pdf);

$pdf->ezNewPage();

recurseTopicContent(-1,1,"",$pdf);

// write file
$fd = fopen("galaxypedia.pdf","wb");
fwrite($fd,$pdf->ezOutput());
fclose($fd);

header("Location: index.php?NOTICE".LANG_PDF_SUCCESSFULLY_CREATED);
die();

////////////////////////////////////////////////////////////////////////////////////////

}



if (isset($_GET["delete_topic"])) {
	if (isset($_SESSION["admin"])) {
			
		$rs = $DB->Execute("SELECT * FROM tb_gp_topic WHERE parent=".addslashes($_GET["delete_topic"]));
					
		if (!$rs->EOF) {
			header("Location: index.php?WARNING=".LANG_TOPIC_NOT_DELETED_SUBTOPICS_FOUND."&topic=".$current_parent);
			die();
		}
	
		$DB->Execute("DELETE FROM tb_gp_topic WHERE id=".addslashes($_GET["delete_topic"]));
		header("Location: index.php?NOTICE=".LANG_TOPIC_DELETED."&topic=".$current_parent);
		die();
	}
}

if (isset($_GET["delete_comment"])) {
	if (isset($_SESSION["admin"])) {
		$DB->Execute("DELETE FROM tb_gp_comment WHERE id=".addslashes($_GET["delete_comment"]));
		header("Location: index.php?NOTICE=".LANG_COMMENT_DELETED."&topic=".$current_parent);
		die();
	}
}

if (isset($_GET["post_comment"])) {

	$comment = "";
	$nickname = "";
	if (isset($_POST["comment_content"])) $comment = $_POST["comment_content"];
	if (isset($_POST["nickname"])) $nickname = $_POST["nickname"];

	if (strlen(addslashes($nickname)) == 0) {
		header("Location: index.php?WARNING=".LANG_EMPTY_TOPIC_NICKNAME."&topic=".$current_parent);
		die();
	}

	if (strlen(addslashes($comment)) == 0) {
		header("Location: index.php?WARNING=".LANG_EMPTY_TOPIC_COMMENT."&topic=".$current_parent);
		die();
	}

	$nickname = str_replace("<","&lt;",$nickname);
	$nickname = str_replace(">","&gt;",$nickname);
	$comment = str_replace("<","&lt;",$comment);
	$comment = str_replace(">","&gt;",$comment);
		
	if (strtoupper($_SESSION["magickey"]) != strtoupper($_POST["code"])) {
		header("Location: index.php?WARNING=".LANG_INVALID_SECURITY_CODE."&topic=".$current_parent);
		die();
	}
			
	$query = "INSERT INTO tb_gp_comment (topic_id,date,nickname,hostname,content) ";
	$query .= "VALUES(".addslashes($current_parent).",".
	time(NULL).",".
	"'".addslashes($nickname)."',".
	"'".addslashes($_SERVER["REMOTE_ADDR"])."',".
	"'".addslashes($comment)."'".
	")";
		
	$DB->Execute($query);
		
	header("Location: index.php?NOTICE=".LANG_COMMENT_POSTED."&topic=".$current_parent);
	die();
}

if (isset ($_GET["post_topic"])) {

if (isset($_SESSION["admin"])) {

		$img1 = "";

		if ($_FILES["topic_image1"]["size"] != 0) {
			
			$fd = fopen($_FILES["topic_image1"]["tmp_name"], "rb");
			$img1 = fread($fd, filesize($_FILES["topic_image1"]["tmp_name"]));
			fclose($fd);
			
		}


		if (addslashes($_POST["topic_name"]) == "")
			header("Location: index.php?WARNING=".LANG_EMPTY_TOPIC_NAME);

		if (addslashes($_POST["topic_content"]) == "")
			Header("Location: index.php?WARNING=".LANG_EMPTY_TOPIC_CONTENT);

		if (isset($_POST["topic_root"])) $current_parent = -1;
		
		
		if ($current_parent != -1) {
			$query = "SELECT parent FROM tb_gp_topic WHERE id=".$current_parent;
			$rs = $DB->Execute($query);
			if ($rs->fields["parent"] != -1) {
				die("You can't post a topic that deep! (second level)");
			}
			
		}
		
		
		
		$query = "INSERT INTO tb_gp_topic (name,content,date,parent,img1) " .
		"VALUES('" . addslashes($_POST["topic_name"]) . "'," .
		"'" . addslashes($_POST["topic_content"]) . "'," .
		time(NULL) . "," .
		intval(addslashes($current_parent)) . "," .
		"'" . addslashes($img1) . "')";

		if (!$DB->Execute($query)) die($DB->ErrorMsg());
		
		header("Location: index.php?NOTICE=".LANG_NEW_TOPIC_POSTED);
		die();
	}

}

if (isset ($_GET["edit_topic"])) {

	if (isset($_SESSION["admin"])) {

		$id = addslashes($_GET["edit_topic"]);
		$img1 = "";
		$img2 = "";
		$img3 = "";
		$img4 = "";

		for ($i=1;$i<=4;$i++) 
		if ($_FILES["topic_image".$i]["size"] != 0) {
			
			$fd = fopen($_FILES["topic_image".$i]["tmp_name"], "rb");
			${"img".$i} = fread($fd, filesize($_FILES["topic_image".$i]["tmp_name"]));
			fclose($fd);
			
		}

		if ($_POST["topic_name"] == "") {
			header("Location: index.php?WARNING=".LANG_EMPTY_TOPIC_NAME);
			die();
		}

		$_POST["topic_content"] = str_replace("\r","",$_POST["topic_content"]);
		$_POST["topic_content"] = str_replace("\n","<br/>",$_POST["topic_content"]);
	
		if ($_POST["topic_content"] == "") {
			header("Location: index.php?WARNING=".LANG_EMPTY_TOPIC_CONTENT);
			die();
		}
			
		

		if (isset($_POST["hide"])) $hide = 1; else $hide = 0;
		
 		$query = "UPDATE tb_gp_topic SET hide=$hide,name='".addslashes($_POST["topic_name"])."',keywords='".addslashes($_POST["keywords"])."',content='".addslashes($_POST["topic_content"])."',short='".addslashes($_POST["topic_short"])."' WHERE id= ".$id;
		if (!$DB->Execute($query)) die($DB->ErrorMsg());
		
		
		for ($i=1;$i<=4;$i++)
		if (${"img".$i} != "") {
 			$query = "UPDATE tb_gp_topic SET img".$i."='".addslashes(${"img".$i})."' WHERE id= ".$id;
			print $query."<br/>";
			$DB->Execute($query);

		}

		header("Location: index.php?NOTICE=".LANG_TOPIC_MODIFIED."&topic=".$current_parent);
		die();
		
	}

}

//////////////////////////////////////////////////////////////////////////////
// Render page
//////////////////////////////////////////////////////////////////////////////
if (isset($_GET["short"])) {
	
	$topic = -1;
	if (isset ($_GET["topic"]))
	$topic = $_GET["topic"];


	$search_results = array();
	if (isset($_GET["search"]) && ($_GET["search"] !="")) {
		$rs = $DB->Execute("SELECT * FROM tb_gp_topic WHERE name like '%".addslashes($_GET["search"])."%' OR  keywords like '%".addslashes($_GET["search"])."%' ORDER BY name");
		while(!$rs->EOF)
		{
			
			$rs->fields["name"] = trim($rs->fields["name"]);
			$search_results[] = $rs->fields;
			$rs->MoveNext();
		}

		$topic = $search_results[0]["id"];
	}



	$topic_data = $DB->Execute("SELECT * FROM tb_gp_topic WHERE id=" . addslashes($topic));
	if ($topic_data->EOF) die("Invalid topic ID");
	$topic_data = $topic_data->fields;
	
	$TPL->set_file("page","galaxypedia_short.html",TPL_BLOCK);
	$topic_content = $topic_data["short"];
	$new_topic_content = "";	
	// non-regexes way		
	$inside = false;
	$tmp_buffer = "";

	for ($i=0;$i<strlen($topic_content);$i++) {

		if ($inside) {
			if ($topic_content[$i] == ']') {
				$inside = false;
				$new_topic_content .= "<a style=\"color:#666666\" href=\"index.php?search=".trim($tmp_buffer)."\">[$tmp_buffer]</a>";
				$tmp_buffer = "";
			} else $tmp_buffer .= $topic_content[$i];

		} else {
			if ($topic_content[$i] == '[') { $inside = true; $tmp_buffer = ""; } else
			$new_topic_content .= $topic_content[$i];
		}

	}
	if (strlen($tmp_buffer) != 0) $new_topic_content .= $tmp_buffer;	
	
	$topic_content = $new_topic_content;
        $new_topic_content = "";
	$inside = false;
	$tmp_buffer = "";

	for ($i=0;$i<strlen($topic_content);$i++) {

		if ($inside) {
			if (substr($topic_content,$i,2) == "@@") {

				$inside = false;
				$tmp_buffer = substr($tmp_buffer,1);
				$new_topic_content .= "<table cellspacing=\"0\" cellpadding=\"6\" style=\"margin:10px;border:1px dashed black\"><tr><td bgcolor=\"#eaeaea\" style=\"color:black;font-family:sans-serif,verdana;font-size:14px;text-align:justify;padding:10px\">".trim($tmp_buffer)."</td></tr></table>";
				$i++;
				$tmp_buffer = "";
			} else $tmp_buffer .= $topic_content[$i];

		} else {
			if (substr($topic_content,$i,2)  == "@@") {  $inside = true; $tmp_buffer = ""; } else
			{
				$new_topic_content .= $topic_content[$i];
			}
		}

	}
	

	if (strlen($tmp_buffer) != 0) $new_topic_content .= $tmp_buffer;

	$topic_content = $new_topic_content;

	$topic_content = str_replace("#image1#","<a href=\"img_galaxypedia.php?topic=".$topic_data["id"]."&pos=1&fullsize\"><img style=\"border:1px solid white\" src=\"img_galaxypedia.php?topic=".$topic_data["id"]."&pos=1\"></a>",$topic_content);
	$topic_content = str_replace("#image2#","<a href=\"img_galaxypedia.php?topic=".$topic_data["id"]."&pos=2&fullsize\"><img style=\"border:1px solid white\" src=\"img_galaxypedia.php?topic=".$topic_data["id"]."&pos=2\"></a>",$topic_content);
	$topic_content = str_replace("#image3#","<a href=\"img_galaxypedia.php?topic=".$topic_data["id"]."&pos=3&fullsize\"><img style=\"border:1px solid white\" src=\"img_galaxypedia.php?topic=".$topic_data["id"]."&pos=3\"></a>",$topic_content);
	$topic_content = str_replace("#image4#","<a href=\"img_galaxypedia.php?topic=".$topic_data["id"]."&pos=4&fullsize\"><img style=\"border:1px solid white\" src=\"img_galaxypedia.php?topic=".$topic_data["id"]."&pos=4\"></a>",$topic_content);

	$TPL->set_var("content",str_replace("\n","<br/><br/>",stripslashes($topic_content)));
	
	print $TPL->process("","page",2);
	die();
}

$TPL->set_file("page","galaxypedia.html",TPL_BLOCK);

// populate main topics listing
$rs = $DB->Execute("SELECT * FROM tb_gp_topic WHERE parent=-1 AND hide=0 ORDER BY name ASC");
$topics = array ();
while (!$rs->EOF) {
	$topics[] = $rs->fields;
	$rs->MoveNext();
}
$TPL->set_loop("topics",$topics);

$topic = -1;
if (isset ($_GET["topic"]))
	$topic = $_GET["topic"];
$topic_data = $DB->Execute("SELECT * FROM tb_gp_topic WHERE id=" . addslashes($topic));

$subtopic_parent = $current_parent;
if (!$topic_data->EOF) {
	
	$subtopic_parent = $topic_data->fields["id"];
	if ($topic_data->fields["parent"] != -1) $subtopic_parent = $topic_data->fields["parent"];
}// populate sub topics listing
$subtopics = array();
if ($current_parent != -1) {
	$rs = $DB->Execute("SELECT * FROM tb_gp_topic WHERE parent=".addslashes($subtopic_parent)." AND hide=0 ORDER BY name ASC");
	print $DB->ErrorMsg();
	
	while (!$rs->EOF) {
		$subtopics[] = $rs->fields;
		$rs->MoveNext();
	}
} 
$TPL->set_loop("subtopics",$subtopics);


if ($topic_data->EOF) {
	// search engine
	
	$search_results = array();
	if (isset($_GET["search"]) && ($_GET["search"] !="")) {
		$rs = $DB->Execute("SELECT * FROM tb_gp_topic WHERE name like '%".addslashes($_GET["search"])."%' OR  keywords like '%".addslashes($_GET["search"])."%' ORDER BY name");
		while(!$rs->EOF)
		{
			
			$rs->fields["name"] = trim($rs->fields["name"]);
			$search_results[] = $rs->fields;
			$rs->MoveNext();
		}

	}
	
	if ((count($search_results) ==1) || ( (count($search_results) > 0) && (isset($_GET["lucky"])))){
		// redirect
		header("Location: index.php?topic=".$search_results[0]["id"]);
		die();
	}
	
	$TPL->set_loop("search_results",$search_results);	
	$TPL->set_var("content", $TPL->process("", "search_block", 2));
	$TPL->set_var("topic", LANG_TOPIC_SEARCH);

	$TPL->set_var("block_comments", "");
	$topic_data = $topic_data->fields;
} else {
	// topic information
	$topic_data = $topic_data->fields;
	if (isset($_SESSION["admin"])) {
		$topic_data["name"] .= "&nbsp;<a href=\"index.php?topic=".$current_parent."&delete_topic=".$topic_data["id"]."\" style=\"font-size:12px;color:white\" onclick=\"return confirm('Are you sure?');\">".LANG_DELETE_TOPIC."</a>";
	}
	
	$TPL->set_var("topic", $topic_data["name"]);
	$TPL->set_var("topic_content_block.name",stripslashes($topic_data["name"]));

	$topic_content = $topic_data["content"];
	$new_topic_content = "";	
	// non-regexes way		
	$inside = false;
	$tmp_buffer = "";

	for ($i=0;$i<strlen($topic_content);$i++) {

		if ($inside) {
			if ($topic_content[$i] == ']') {
				$inside = false;
				$new_topic_content .= "<a style=\"color:#666666\" href=\"index.php?search=".trim($tmp_buffer)."\">[$tmp_buffer]</a>";
				$tmp_buffer = "";
			} else $tmp_buffer .= $topic_content[$i];

		} else {
			if ($topic_content[$i] == '[') { $inside = true; $tmp_buffer = ""; } else
			$new_topic_content .= $topic_content[$i];
		}

	}
	if (strlen($tmp_buffer) != 0) $new_topic_content .= $tmp_buffer;	
	
	$topic_content = $new_topic_content;
        $new_topic_content = "";
	$inside = false;
	$tmp_buffer = "";

	for ($i=0;$i<strlen($topic_content);$i++) {

		if ($inside) {
			if (substr($topic_content,$i,2) == "@@") {

				$inside = false;
				$tmp_buffer = substr($tmp_buffer,1);
				$new_topic_content .= "<table cellspacing=\"0\" cellpadding=\"6\" style=\"margin:10px;border:1px dashed black\"><tr><td bgcolor=\"#eaeaea\" style=\"color:black;font-family:sans-serif,verdana;font-size:14px;text-align:justify;padding:10px\">".trim($tmp_buffer)."</td></tr></table>";
				$i++;
				$tmp_buffer = "";
			} else $tmp_buffer .= $topic_content[$i];

		} else {
			if (substr($topic_content,$i,2)  == "@@") {  $inside = true; $tmp_buffer = ""; } else
			{
				$new_topic_content .= $topic_content[$i];
			}
		}

	}
	

	if (strlen($tmp_buffer) != 0) $new_topic_content .= $tmp_buffer;

	$topic_content = $new_topic_content;

	$topic_content = str_replace("#image1#","<a href=\"img_galaxypedia.php?topic=".$topic_data["id"]."&pos=1&fullsize\"><img style=\"border:1px solid white\" src=\"img_galaxypedia.php?topic=".$topic_data["id"]."&pos=1\"></a>",$topic_content);
	$topic_content = str_replace("#image2#","<a href=\"img_galaxypedia.php?topic=".$topic_data["id"]."&pos=2&fullsize\"><img style=\"border:1px solid white\" src=\"img_galaxypedia.php?topic=".$topic_data["id"]."&pos=2\"></a>",$topic_content);
	$topic_content = str_replace("#image3#","<a href=\"img_galaxypedia.php?topic=".$topic_data["id"]."&pos=3&fullsize\"><img style=\"border:1px solid white\" src=\"img_galaxypedia.php?topic=".$topic_data["id"]."&pos=3\"></a>",$topic_content);
	$topic_content = str_replace("#image4#","<a href=\"img_galaxypedia.php?topic=".$topic_data["id"]."&pos=4&fullsize\"><img style=\"border:1px solid white\" src=\"img_galaxypedia.php?topic=".$topic_data["id"]."&pos=4\"></a>",$topic_content);

	$TPL->set_var("topic_content_block.content",str_replace("\n","<br/><br/>",stripslashes($topic_content)));
	if ($topic_data["img1"] != "")
		$TPL->set_var("topic_content_block.img1","<img align=\"left\" src=\"img_galaxypedia.php?topic=".$topic_data["id"]."\" style=\"border:1px solid white;margin: 0 20 20 10\">");
	else
		$TPL->set_var("topic_content_block.img1","");
	
	$TPL->set_var("content", $TPL->process("", "topic_content_block", 2));
	
	$rs = $DB->Execute("SELECT * FROM tb_gp_comment WHERE topic_id=".$topic_data["id"]);
	$comments = array();
	while(!$rs->EOF)
	{
		
		$hostname = explode(".",$rs->fields["hostname"]);
		if (count($hostname) != 4) $rs->fields["hostname"] = "---"; else
		$rs->fields["hostname"] = $hostname[0].".".$hostname[1].".".$hostname[2].".*";
		$rs->fields["date"] =date("h:i:s m/d/y",$rs->fields["date"]);
		
		if (isset($_SESSION["admin"])) {
			$rs->fields["date"] .= "&nbsp;<a href=\"index.php?topic=".$current_parent."&delete_comment=".$rs->fields["id"]."\" style=\"color:#cccccc\" onclick=\"return confirm('Are you sure?');\">".LANG_DELETE_COMMENT."</a>";
		}
		
		$comments[] = $rs->fields;
		$rs->MoveNext();
		
	}
	$TPL->set_var("current_parent",$current_parent);
	$TPL->set_loop("comments",$comments);
	$TPL->set_var("block_comments", $TPL->process("", "comments_block", 2));
}


if (isset($_SESSION["admin"])) {
	if (isset($topic_data["id"])) {
		$TPL->set_var("edittopic_block.current_parent",$current_parent);
		$TPL->set_var("edittopic_block.name",substr($topic_data["name"],0,strpos($topic_data["name"],"<")));
		$TPL->set_var("edittopic_block.content",str_replace("<br/>","\r\n",stripslashes($topic_data["content"])));
		$TPL->set_var("edittopic_block.short",str_replace("<br/>","\r\n",stripslashes($topic_data["short"])));
		$TPL->set_var("edittopic_block.id",stripslashes($topic_data["id"]));
		$TPL->set_var("edittopic_block.keywords",stripslashes($topic_data["keywords"]));
		$TPL->set_var("edittopic_block.hide",($topic_data["hide"]==1?"checked":""));
		$TPL->set_var("block_edittopic", $TPL->process("", "edittopic_block", 2));
	} else 	$TPL->set_var("block_edittopic", "");
	
	
	$TPL->set_var("writetopic_block.current_parent", $current_parent);
	$TPL->set_var("block_writetopic",$TPL->process("", "writetopic_block", 2));
	

} else {
	$TPL->set_var("block_edittopic", "");
	$TPL->set_var("block_writetopic", "");
}
print $TPL->process("","page",2);


?>
