<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CANADA REVISITED FLAG: 3332222222222333333222222222233333322222222223333332222222222333333222233222233333322223322223333332223443222333333232344323233333323333333323333332233333322333333222333322233333322223322223333332222442222333333222255222233333322222222223333332222222222333
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

require_once("include/init.php");
require_once("include/init_ingame.php");

if (isset($_POST["logo_data_update"])) {
	
	
	$logo_data = trim($_POST["logo_data_update"]);
	if (strlen($logo_data)==256) {

		$GAME["empire"]->data["logo"] = $logo_data;
		$GAME["empire"]->save();

	}
		
	$GAME["system"]->redirect("logo_editor.php");
}

if (isset($_POST["logodata_0_0"]))
{
	$GAME["empire"]->data["logo"] = "";
	

	for ($y=0;$y<16;$y++)
	for ($x=0;$x<16;$x++)
	{
		
		$color = $_POST["logodata_".$x."_".$y];
		$pos = 0;
		
		for ($i=0;$i<count($TPL_LOGO_COLORS);$i++)
		{
				if ($TPL_LOGO_COLORS[$i][0] == $color) {
						
							$pos = $i;
							break;
					}
		}
		
		
		$GAME["empire"]->data["logo"] .= $pos;
		$GAME["empire"]->save();
	}
	
	$GAME["system"]->redirect("logo_editor.php",array("NOTICE"=>LANG_LOGO_SAVED));
}

		
$GAME["template"]->setPage("logo_editor.html");

$logo_data = $GAME["empire"]->data["logo"];

if (strlen($logo_data) != 256) $logo_data = str_repeat("0",256);

if (isset($_GET["fill"]))
{

	$base_color = 0;
	for ($i=0;$i<count($TPL_LOGO_COLORS);$i++)
	{
		if ($_GET["fill"] == $TPL_LOGO_COLORS[$i][0])
		{
			$base_color = $i;
			break;
		}
	}
	
	for ($i=0;$i<256;$i++) $logo_data[$i] = $base_color;
	$GAME["empire"]->data["logo"] = $logo_data;
	$GAME["empire"]->save();
	$GAME["system"]->redirect("logo_editor.php");
}


$logo_data_html = "<table bgcolor=\"cyan\" cellspacing=\"0\" cellpadding=\"1\" border=\"0\"><tr><td>";
$logo_data_html .= "<table bgcolor=\"#3a3a3a\" cellspacing=\"1\" cellpadding=\"0\" border=\"0\">";

for ($y=0;$y<16;$y++)
{
	$logo_data_html .= "<tr>";
	for ($x=0;$x<16;$x++)
	{
		
		$offset = intval($logo_data[($y * 16 )+ $x]);
		if ((intval($offset) < 0) || (intval($offset) > 9)) $value = 0; else
			$value = $TPL_LOGO_COLORS[$offset][0];
		
		$logo_data_html .= "<td style=\"cursor: crosshair\" id=\"cell_".$x."_".$y."\" 
		onclick=\"UpdateCellColor('cell_".$x."_".$y."',document.logo_form.logodata_".$x."_".$y.");\"
		width=32 height=32 bgcolor=\"".$value."\"><input type=\"hidden\" name=\"logodata_".$x."_".$y."\" value=\"".$value."\"></td>";
	}
	$logo_data_html .= "<tr>\r\n";
}

$logo_data_html .= "</table>";
$logo_data_html .= "</td></tr></table>";


$color_palette_html = "<table>";
for ($i=0;$i<count($TPL_LOGO_COLORS);$i++)
{
	$color_palette_html .= "<tr><td bgcolor=\"cyan\">
<table cellspacing=\"0\" cellpadding=\"0\" border=\"0\" onclick=\"ChangeCurrentcolor('".$TPL_LOGO_COLORS[$i][0]."');\"
width=32 height=32 bgcolor=\"".$TPL_LOGO_COLORS[$i][0]."\">
<tr><td><img src=\"images/placeholder.gif\" width=32 height=32 style=\"cursor: crosshair\"></td></tr>
</table>
</td></tr>\r\n";

}

$color_palette_html .= "</table>";
$GAME["template"]->setVar("current_color","white");
$GAME["template"]->setVar("color_palette_html",$color_palette_html);



$GAME["template"]->setVar("logo_data_html",$logo_data_html);
$GAME["template"]->setVar("logo_data",$logo_data);
$GAME["template"]->setVar("logo_empire_id",$_SESSION["empire_id"]);

print $GAME["template"]->render();

?>