<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2006.06.11 : ybo : Cleaning up the last visits display
// 2006.06.18 : ybo : Removing messages and putting it into sendmsg.php
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//
require_once("include/init.php");
require_once("include/init_ingame.php");

$GAME["template"]->setPage("logs.html");

$now = mktime(0,0,0,date("m"),date("d"),date("Y"));
$sevendays = 60*60*24*7;
$logs = array();

////////////////////////////////////////////////////////////////
// Display events
////////////////////////////////////////////////////////////////

$rs = $DB->Execute("SELECT * FROM tb_event WHERE event_to=".$GAME["empire"]->data["id"]." ORDER BY id DESC LIMIT 0,40");

$events = array();

while(!$rs->EOF)
{	
	$events[] = $rs->fields;
	$rs->MoveNext();
}

$content = "";
	
$c = array();

$cached_hosts = array();

if (isset($_GET["LASTVISITS"])) {

	$rs = $DB->Execute("SELECT * FROM tb_log_login ORDER BY date DESC LIMIT 40");
	$count = 000;
	while(!$rs->EOF)
	{
		$rs2 = $DB->Execute("SELECT emperor,name FROM tb_empire WHERE id=".$rs->fields["empire"]);
		$dup = false;
		$dup_name = "";
		
		if (isset($cached_hosts[$rs->fields["hostname"]]))
		{
			if ($cached_hosts[$rs->fields["hostname"]] != ($rs2->fields["emperor"]."@".$rs2->fields["name"]))
			{
				$dup = true;
				$dup_name = $cached_hosts[$rs->fields["hostname"]];
			}
		} else {
			$cached_hosts[$rs->fields["hostname"]] = $rs2->fields["emperor"]."@".$rs2->fields["name"];
		}
		
		
		$hostname = $rs->fields["hostname"];
		$hostname = explode(".",$hostname);
		$hostname = $hostname[0].".".$hostname[1].".".$hostname[2].".*";

	
		if ($dup)
			$c[$count++] = array("lastvisit","<table style=\"margin:0px;font-size:10pt;font-family:verdana;color:orange\" cellspacing=0 cellpadding=2 border=0 width=720 align=center><tr><td bgcolor=#333333  width=\"100%\">*DUP $dup_name* ".$rs2->fields[0]."@".$rs2->fields[1]."</td><td bgcolor=#666666  width=\"200\" nowrap align=right><b>$hostname</b></td><td bgcolor=#333333 style=color:#99aa99 nowrap>".date("H:i:s m/d/y",$rs->fields["date"])."</td></tr></table>");
		else
			$c[$count++] = array("lastvisit","<table style=\"margin:0px;font-size:10pt;font-family:verdana\" cellspacing=0 cellpadding=2 border=0 width=720 align=center><tr><td bgcolor=#333333  width=\"100%\">".$rs2->fields[0]."@".$rs2->fields[1]."</td><td bgcolor=#666666  width=\"200\" nowrap align=right><b>$hostname</b></td><td bgcolor=#333333 style=color:#99aa99 nowrap>".date("H:i:s m/d/y",$rs->fields["date"])."</td></tr></table>");
		
		$rs->MoveNext();
	}		


	while (list($key,$value) = each($c))
	{
	
	$content .= "<b>".$value[1]."</b>\r\n";
	}	


} 
else {

	for ($i=0;$i<count($events);$i++)
	{
		$evt = new EventRenderer($DB,$TPL,$GAME["template"]);
		$content .= $GAME["template"]->getNotice($evt->renderEvent($events[$i],$GAME["empire"]->data)).""; 
	}	

	
}
	



$GAME["template"]->setVar("content",$content);

print $GAME["template"]->render();

?>
