<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//
require_once("include/init.php");
require_once("include/init_ingame.php");

//////////////////////////////////////////////////////////////////////////////
// Handle requests
//////////////////////////////////////////////////////////////////////////////
if (isset($_GET["buy"]))
{
	$buy = $_GET["buy"];
	if (($buy < 0) || 
	($buy > floor($GAME["empire"]->data["credits"]/CONF_LOTTERY_TICKETPRICE)) || 
	(($GAME["empire"]->data["lottery_tickets"]+$buy) > CONF_LOTTERY_MAXTICKETS))
	{

		$GAME["system"]->redirect("lottery.php",array("WARNING"=>LANG_INVALID_TICKETS_AMOUNT));	
	
	} 

	$GAME["empire"]->data["lottery_tickets"] += $buy;
	$GAME["empire"]->data["credits"] -= ($buy * CONF_LOTTERY_TICKETPRICE);
	$GAME["empire"]->save();
			
	$credits = floor((($buy * CONF_LOTTERY_TICKETPRICE)/100)*CONF_LOTTERY_TICKETRATIO);
	
	$GAME["template"]->coord["lottery_cash"] += $credits;	
		
	$DB->Execute("UPDATE tb_coordinator SET lottery_cash=".($GAME["template"]->coord["lottery_cash"]));
	
	$notice = LANG_TICKETS_BOUGHT;
	$notice = str_replace("{qty}",$buy,$notice);
	$notice = str_replace("{credits}",$GAME["template"]->formatCredits($buy * CONF_LOTTERY_TICKETPRICE),$notice);
		
	$GAME["system"]->redirect("lottery.php",array("NOTICE"=>$notice));
	
}


//////////////////////////////////////////////////////////////////////////////
// Display page
//////////////////////////////////////////////////////////////////////////////

$GAME["template"]->setPage("lottery.html");

$GAME["template"]->setVar("lottery_jackpot",$GAME["template"]->formatCredits($GAME["template"]->coord["lottery_cash"]));
$GAME["template"]->setVar("lottery_ticketprice",$GAME["template"]->formatCredits(CONF_LOTTERY_TICKETPRICE));

// fetch tickets count
$rs = $DB->Execute("SELECT * FROM tb_empire WHERE active=1");
$tickets = 0;

while (!$rs->EOF)
{
	$tickets += $rs->fields["lottery_tickets"];
	$rs->MoveNext();
}

$maxtickets =(floor($GAME["empire"]->data["credits"]/CONF_LOTTERY_TICKETPRICE));
$currenttickets = (CONF_LOTTERY_MAXTICKETS-$GAME["empire"]->data["lottery_tickets"]);

if ($maxtickets > $currenttickets) 	$maxtickets = $currenttickets;

$GAME["template"]->setVar("label_tickets",LANG_HOW_MANY_TICKETS." [MAX=".$GAME["template"]->formatNumber($maxtickets)."]");
$GAME["template"]->setVar("lottery_tickets",$GAME["template"]->formatNumber($tickets));

print $GAME["template"]->render();

?>