<?php
//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2006.09.01 : ybo : Major code changes, OOP
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

require_once("include/init.php");
require_once("include/init_ingame.php");

//////////////////////////////////////////////////////////////////////////////
// Handle requests
//////////////////////////////////////////////////////////////////////////////
$units = array("soldiers","fighters","stations","generals","covertagents","lightcruisers","heavycruisers","carriers");

/* Build command ship */
if (isset($_GET["buildcommandship"]))
{
	$units_prices = $GAME["gameplay_costs"]->getUnitsPrices($GAME["empire"]->army->data,$GAME["empire"]->data,$GAME["empire"]->data["turns_played"],$GAME["empire"]->data["inflation"]);
	if ($GAME["empire"]->data["credits"] >= $units_prices["buy_commandship"])
	{
		if ($GAME["empire"]->army->data["commandship"] < 100) {
			$msg = "";
			if ($GAME["empire"]->army->data["commandship"] == 0) $msg = LANG_COMMANDSHIP_BUILD;
			$GAME["empire"]->army->data["commandship"] += 5;
			if ($GAME["empire"]->army->data["commandship"] > 100) $GAME["empire"]->army->data["commandship"] = 100;
			$GAME["empire"]->data["credits"] -= $units_prices["buy_commandship"];
			$notice_data = LANG_COMMANDSHIP_UPGRADED;
			$notice_data = str_replace("{credits}",$GAME["template"]->formatCredits($units_prices["buy_commandship"]),$notice_data);
			$notice_data = str_replace("{commandship}",$GAME["empire"]->army->data["commandship"],$notice_data);
			$GAME["empire"]->save();
			
			$GAME["system"]->redirect("manage.php",array("NOTICE"=>$msg.$notice_data));
		}
	}
}
	
/* Rush command ship */
if (isset($_GET["rushcommandship"]))
{
		
	$units_prices = $GAME["gameplay_costs"]->getUnitsPrices($GAME["empire"]->army->data,$GAME["empire"]->data,$GAME["empire"]->data["turns_played"],$GAME["empire"]->data["inflation"]);
	$total = ($units_prices["buy_commandship"] * 100);
	
	if ($GAME["empire"]->data["credits"] >= $total)
	{
		if ($GAME["empire"]->army->data["commandship"] < 100) {
			$msg = "";
			$GAME["empire"]->army->data["commandship"] = 100;
			$GAME["empire"]->data["credits"] -= $total;
			$notice_data = LANG_COMMANDSHIP_UPGRADED;
			$notice_data = str_replace("{credits}",$GAME["template"]->formatCredits($units_prices["buy_commandship"]),$notice_data);
			$notice_data = str_replace("{commandship}",$GAME["empire"]->army->data["commandship"],$notice_data);
			$GAME["empire"]->save();
			
			$GAME["system"]->redirect("manage.php",array("NOTICE"=>$msg.$notice_data));
		}
	}
}


$units_prices = $GAME["gameplay_costs"]->getUnitsPrices($GAME["empire"]->army->data,$GAME["empire"]->data,$GAME["empire"]->data["turns_played"],$GAME["empire"]->data["inflation"]);
$buy_max_soldiers = $GAME["gameplay_costs"]->getMaxQty($GAME["empire"]->data["credits"],$units_prices["buy_soldiers"],CONF_COST_INCREMENT);


$buy_max_fighters = $GAME["gameplay_costs"]->getMaxQty($GAME["empire"]->data["credits"],$units_prices["buy_fighters"],CONF_COST_INCREMENT);
$buy_max_stations = $GAME["gameplay_costs"]->getMaxQty($GAME["empire"]->data["credits"],$units_prices["buy_stations"],CONF_COST_INCREMENT);
$buy_max_generals = $GAME["gameplay_costs"]->getMaxQty($GAME["empire"]->data["credits"],$units_prices["buy_generals"],CONF_COST_INCREMENT);
if ($buy_max_generals > ($GAME["empire"]->planets->data["gov_planets"] * CONF_GENERALS_PER_GOVPLANET)) $buy_max_generals = $GAME["empire"]->planets->data["gov_planets"] * CONF_GENERALS_PER_GOVPLANET;
$buy_max_covertagents = $GAME["gameplay_costs"]->getMaxQty($GAME["empire"]->data["credits"],$units_prices["buy_covertagents"],CONF_COST_INCREMENT);
$buy_max_heavycruisers = $GAME["gameplay_costs"]->getMaxQty($GAME["empire"]->data["credits"],$units_prices["buy_heavycruisers"],CONF_COST_INCREMENT);
$buy_max_carriers = $GAME["gameplay_costs"]->getMaxQty($GAME["empire"]->data["credits"],$units_prices["buy_carriers"],CONF_COST_INCREMENT);

/* buy something */
if (isset($_GET["buy"]))
{
	$name = $_GET["buy"];	
	$qty = $_GET["quantity"];
			
	if (!strpos($name,"_planets")) {
		// this is not planets
		
		if (in_array($name,$units)) {
				
			$buy_max = ${"buy_max_".$name};
			
			if (($qty > ($buy_max)) || ($qty <= 0))
			{
				$warning = LANG_INVALID_UNITS_QTY;
				$warning = str_replace("{name}",$name,$warning);
				$warning = str_replace("{qty}",$GAME["template"]->formatNumber($qty),$warning);
				$warning = str_replace("{max}",$GAME["template"]->formatNumber($buy_max),$warning);
				
				$GAME["template"]->showNotice($warning,true);
			} else {
				
				$units_prices = $GAME["gameplay_costs"]->getUnitsPrices($GAME["empire"]->army->data,$GAME["empire"]->data,$GAME["empire"]->data["turns_played"],$GAME["empire"]->data["inflation"]);

				$GAME["empire"]->army->data[$name] += $qty;
				$GAME["empire"]->data["credits"] -= $GAME["gameplay_costs"]->calcTotalCost($units_prices["buy_".$name],$qty,CONF_COST_INCREMENT);

				$GAME["empire"]->save();
				$GAME["system"]->redirect("manage.php",array("NOTICE"=>$GAME["template"]->formatNumber($qty)." ".$name." ".LANG_UNITS." ".LANG_BOUGHT));
				
			}
		}
		
	} else {
		// this is planets
		
		$name = str_replace("_planets","",$name);
		if (in_array($name,$CONF_PLANETS)) {
			// valid planet found
			$planets_prices = $GAME["gameplay_costs"]->getPlanetsPrices($GAME["empire"]->planets->data,$GAME["empire"]->data["turns_played"],$GAME["empire"]->data["inflation"]);
			$max  = $GAME["gameplay_costs"]->getMaxQty($GAME["empire"]->data["credits"],$planets_prices["planet_".$name],CONF_COST_INCREMENT);
			if ($max > CONF_MAX_PLANET_BUY) $max = CONF_MAX_PLANET_BUY;

			if (($qty > ($GAME["empire"]->data["credits"]/$planets_prices["planet_".$name])) || 
			($qty > $max) || 
			($qty <= 0) || 
			($qty > $GAME["template"]->coord[$name."_planets"]))
			{
			
				$warning = LANG_INVALID_PLANETS_QTY;
				$warning = str_replace("{name}",$name,$warning);
				$warning = str_replace("{qty}",$GAME["template"]->formatNumber($qty),$warning);
				$warning = str_replace("{max}",$GAME["template"]->formatNumber($max),$warning);
				if ($GAME["template"]->coord[$name."_planets"] < $max)		
					$warning = LANG_NOT_ENOUGH_PLANETS.$GAME["template"]->formatNumber($GAME["template"]->coord[$name."_planets"]);
			
				$GAME["template"]->showNotice($warning,true);
			
			} else {
	
				if ($name != "gov") {
					$p = $qty / ($GAME["empire"]->planets->data[$name."_planets"] + $qty);
					$p *= $GAME["empire"]->production->data[$name."_short"];
				}
							 		
				$GAME["empire"]->planets->data[$name."_planets"] += $qty;
				
				if ($GAME["empire"]->planets->data[$name."_planets"] > $GAME["empire"]->planets->data["max_".$name])
					$GAME["empire"]->planets->data["max_".$name] = $GAME["empire"]->planets->data[$name."_planets"];

				if ($name != "gov") {
					$GAME["empire"]->production->data[$name."_short"] -= ceil($p);
			
					if ($GAME["empire"]->production->data[$name."_short"] <= 0) $GAME["empire"]->production->data[$name."_short"] = 1;
				}
				
				$DB->Execute("UPDATE tb_coordinator SET ".$name."_planets=".($GAME["template"]->coord[$name."_planets"]-$qty));

				$GAME["empire"]->data["credits"] -= ($planets_prices["planet_".$name] * $qty);
				$GAME["empire"]->save();		
				
				$GAME["system"]->redirect("manage.php",array("NOTICE"=>$GAME["template"]->formatNumber($qty)." $name ".LANG_PLANETS_BOUGHT));


			}		
		}
	}
		
}


/* sell something */
if (isset($_GET["sell"]))
{
	$name = $_GET["sell"];	
	$qty = $_GET["quantity"];
		if (!strpos($name,"_planets")) {
		// this is not planets
		
		if (in_array($name,$units)) {
				
			$max = $GAME["empire"]->army->data[$name];
					
			if (($qty > ($max)) || ($qty <= 0))
			{
				$warning = LANG_INVALID_UNITS_QTY;
				$warning = str_replace("{name}",$name,$warning);
				$warning = str_replace("{qty}",$GAME["template"]->formatNumber($qty),$warning);
				$warning = str_replace("{max}",$GAME["template"]->formatNumber($max),$warning);
				
				$GAME["template"]->showNotice($warning,true);
			} else {
				
				
				$units_prices = $GAME["gameplay_costs"]->getUnitsPrices($GAME["empire"]->army->data,$GAME["empire"]->data,$GAME["empire"]->data["turns_played"],$GAME["empire"]->data["inflation"]);

				$GAME["empire"]->army->data[$name] -= $qty;
				$GAME["empire"]->data["credits"] += ($units_prices["sell_".$name] * $qty);

				$GAME["empire"]->save();
				$GAME["system"]->redirect("manage.php",array("NOTICE"=>$GAME["template"]->formatNumber($qty)." ".$name." ".LANG_UNITS." ".LANG_SOLD));
				
			}
		}
	} else {
		// this is planets
		
		$name = str_replace("_planets","",$name);
		if (in_array($name,$CONF_PLANETS)) {
			// valid planet found
			
			$max = $GAME["empire"]->planets->data[$name."_planets"];
			if (($qty > ($max)) || ($qty <= 0))
			{
			
				$warning = LANG_INVALID_PLANETS_QTY;
				$warning = str_replace("{name}",$name,$warning);
				$warning = str_replace("{qty}",$GAME["template"]->formatNumber($qty),$warning);
				$warning = str_replace("{max}",$GAME["template"]->formatNumber($max),$warning);
				$GAME["template"]->showNotice($warning,true);
				
			} else {
				$GAME["empire"]->planets->data[$name."_planets"] -= $qty;


				$planets = $GAME["template"]->coord[$name."_planets"] + $qty;

				$DB->Execute("UPDATE tb_coordinator SET ".$name."_planets=$planets");
				$GAME["empire"]->save();
				
				$GAME["system"]->redirect("manage.php",array("NOTICE"=>$GAME["template"]->formatNumber($qty)." ".$name." ".LANG_PLANETS." ".LANG_RELEASED));
			}		
		}
	}
		
}



//////////////////////////////////////////////////////////////////////////////
// show page
//////////////////////////////////////////////////////////////////////////////

$GAME["template"]->setPage("manage.html");


// display costs
$planets_prices = $GAME["gameplay_costs"]->getPlanetsPrices($GAME["empire"]->planets->data,$GAME["empire"]->data["turns_played"],$GAME["empire"]->data["inflation"]);

for ($i=0;$i<count($CONF_PLANETS);$i++)
	$GAME["template"]->setVar("cost_planet_".$CONF_PLANETS[$i],
		$GAME["template"]->formatCredits($planets_prices["planet_".$CONF_PLANETS[$i]]));

$units_prices = $GAME["gameplay_costs"]->getUnitsPrices($GAME["empire"]->army->data,$GAME["empire"]->data,$GAME["empire"]->data["turns_played"],$GAME["empire"]->data["inflation"]);

$GAME["template"]->setVar("buy_soldiers",$GAME["template"]->formatCredits($units_prices["buy_soldiers"]));
$GAME["template"]->setVar("sell_soldiers",$GAME["template"]->formatCredits($units_prices["sell_soldiers"]));

$GAME["template"]->setVar("buy_fighters",$GAME["template"]->formatCredits($units_prices["buy_fighters"]));
$GAME["template"]->setVar("sell_fighters",$GAME["template"]->formatCredits($units_prices["sell_fighters"]));

$GAME["template"]->setVar("buy_stations",$GAME["template"]->formatCredits($units_prices["buy_stations"]));
$GAME["template"]->setVar("sell_stations",$GAME["template"]->formatCredits($units_prices["sell_stations"]));

$GAME["template"]->setVar("buy_generals",$GAME["template"]->formatCredits($units_prices["buy_generals"]));
$GAME["template"]->setVar("sell_generals",$GAME["template"]->formatCredits($units_prices["sell_generals"]));

$GAME["template"]->setVar("buy_commandship",$GAME["template"]->formatCredits($units_prices["buy_commandship"]));

$GAME["template"]->setVar("buy_covertagents",$GAME["template"]->formatCredits($units_prices["buy_covertagents"]));
$GAME["template"]->setVar("sell_covertagents",$GAME["template"]->formatCredits($units_prices["sell_covertagents"]));

$GAME["template"]->setVar("sell_lightcruisers",$GAME["template"]->formatCredits($units_prices["sell_lightcruisers"]));

$GAME["template"]->setVar("buy_heavycruisers",$GAME["template"]->formatCredits($units_prices["buy_heavycruisers"]));
$GAME["template"]->setVar("sell_heavycruisers",$GAME["template"]->formatCredits($units_prices["sell_heavycruisers"]));

$GAME["template"]->setVar("buy_carriers",$GAME["template"]->formatCredits($units_prices["buy_carriers"]));
$GAME["template"]->setVar("sell_carriers",$GAME["template"]->formatCredits($units_prices["sell_carriers"]));


$buy_max_soldiers = $GAME["gameplay_costs"]->getMaxQty($GAME["empire"]->data["credits"],$units_prices["buy_soldiers"],CONF_COST_INCREMENT);
$buy_max_fighters = $GAME["gameplay_costs"]->getMaxQty($GAME["empire"]->data["credits"],$units_prices["buy_fighters"],CONF_COST_INCREMENT);
$buy_max_stations = $GAME["gameplay_costs"]->getMaxQty($GAME["empire"]->data["credits"],$units_prices["buy_stations"],CONF_COST_INCREMENT);
$buy_max_generals = $GAME["gameplay_costs"]->getMaxQty($GAME["empire"]->data["credits"],$units_prices["buy_generals"],CONF_COST_INCREMENT);
if ($buy_max_generals > ($GAME["empire"]->planets->data["gov_planets"] * CONF_GENERALS_PER_GOVPLANET)) $buy_max_generals = $GAME["empire"]->planets->data["gov_planets"] * CONF_GENERALS_PER_GOVPLANET;
$buy_max_covertagents = $GAME["gameplay_costs"]->getMaxQty($GAME["empire"]->data["credits"],$units_prices["buy_covertagents"],CONF_COST_INCREMENT);
$buy_max_heavycruisers = $GAME["gameplay_costs"]->getMaxQty($GAME["empire"]->data["credits"],$units_prices["buy_heavycruisers"],CONF_COST_INCREMENT);
$buy_max_carriers = $GAME["gameplay_costs"]->getMaxQty($GAME["empire"]->data["credits"],$units_prices["buy_carriers"],CONF_COST_INCREMENT);

$GAME["template"]->setVar("buy_max_soldiers",$buy_max_soldiers);
$GAME["template"]->setVar("buy_max_fighters",$buy_max_fighters);
$GAME["template"]->setVar("buy_max_stations",$buy_max_stations);
$GAME["template"]->setVar("buy_max_generals",$buy_max_generals);
$GAME["template"]->setVar("buy_max_covertagents",$buy_max_covertagents);
$GAME["template"]->setVar("buy_max_heavycruisers",$buy_max_heavycruisers);
$GAME["template"]->setVar("buy_max_carriers",$buy_max_carriers);


$GAME["template"]->setVar("soldiers_buy_label",LANG_BUY." soldiers: ".$GAME["template"]->formatCredits($units_prices["buy_soldiers"],false)." ".LANG_EACH." [".LANG_MAX.": ".$GAME["template"]->formatNumber(floor($buy_max_soldiers))."]");
$GAME["template"]->setVar("fighters_buy_label",LANG_BUY." fighters: ".$GAME["template"]->formatCredits($units_prices["buy_fighters"],false)." ".LANG_EACH." [".LANG_MAX.": ".$GAME["template"]->formatNumber(floor($buy_max_fighters))."]");
$GAME["template"]->setVar("stations_buy_label",LANG_BUY." stations: ".$GAME["template"]->formatCredits($units_prices["buy_stations"],false)." ".LANG_EACH." [".LANG_MAX.": ".$GAME["template"]->formatNumber(floor($buy_max_stations))."]");
$GAME["template"]->setVar("generals_buy_label",LANG_BUY." generals: ".$GAME["template"]->formatCredits($units_prices["buy_generals"],false)." ".LANG_EACH." [".LANG_MAX.": ".$GAME["template"]->formatNumber(floor($buy_max_generals))."]");
$GAME["template"]->setVar("covertagents_buy_label",LANG_BUY." covert agents: ".$GAME["template"]->formatCredits($units_prices["buy_covertagents"],false)."  ".LANG_EACH." [".LANG_MAX.": ".$GAME["template"]->formatNumber(floor($buy_max_covertagents))."]");
$GAME["template"]->setVar("heavycruisers_buy_label",LANG_BUY." heavy cruisers: ".$GAME["template"]->formatCredits($units_prices["buy_heavycruisers"],false)." ".LANG_EACH." [".LANG_MAX.": ".$GAME["template"]->formatNumber(floor($buy_max_heavycruisers))."]");
$GAME["template"]->setVar("carriers_buy_label",LANG_BUY." carriers: ".$GAME["template"]->formatCredits($units_prices["buy_carriers"],false)." ".LANG_EACH." [".LANG_MAX.": ".$GAME["template"]->formatNumber(floor($buy_max_carriers))."]");

$GAME["template"]->setVar("soldiers_sell_label",LANG_SELL." soldiers: ".$GAME["template"]->formatCredits($units_prices["sell_fighters"],false)." ".LANG_EACH." [".LANG_MAX.": ".$GAME["template"]->formatNumber($GAME["empire"]->army->data["soldiers"])."]");
$GAME["template"]->setVar("fighters_sell_label",LANG_SELL." fighters: ".$GAME["template"]->formatCredits($units_prices["sell_fighters"],false)." ".LANG_EACH." [".LANG_MAX.": ".$GAME["template"]->formatNumber($GAME["empire"]->army->data["fighters"])."]");
$GAME["template"]->setVar("stations_sell_label",LANG_SELL." stations: ".$GAME["template"]->formatCredits($units_prices["sell_stations"],false)." ".LANG_EACH." [".LANG_MAX.": ".$GAME["template"]->formatNumber($GAME["empire"]->army->data["stations"])."]");
$GAME["template"]->setVar("generals_sell_label",LANG_SELL." generals: ".$GAME["template"]->formatCredits($units_prices["sell_generals"],false)." ".LANG_EACH." [".LANG_MAX.": ".$GAME["template"]->formatNumber($GAME["empire"]->army->data["generals"])."]");
$GAME["template"]->setVar("covertagents_sell_label",LANG_SELL." covert agents: ".$GAME["template"]->formatCredits($units_prices["sell_covertagents"],false)." ".LANG_EACH." [".LANG_MAX.": ".$GAME["template"]->formatNumber($GAME["empire"]->army->data["covertagents"])."]");
$GAME["template"]->setVar("lightcruisers_sell_label",LANG_SELL." light cruisers: ".$GAME["template"]->formatCredits($units_prices["sell_lightcruisers"],false)." ".LANG_EACH." [".LANG_MAX.": ".$GAME["template"]->formatNumber($GAME["empire"]->army->data["lightcruisers"])."]");
$GAME["template"]->setVar("heavycruisers_sell_label",LANG_SELL." heavy cruisers: ".$GAME["template"]->formatCredits($units_prices["sell_heavycruisers"],false)." ".LANG_EACH." [".LANG_MAX.": ".$GAME["template"]->formatNumber($GAME["empire"]->army->data["heavycruisers"])."]");
$GAME["template"]->setVar("carriers_sell_label",LANG_SELL." carriers: ".$GAME["template"]->formatCredits($units_prices["sell_carriers"],false)." ".LANG_EACH." [".LANG_MAX.": ".$GAME["template"]->formatNumber($GAME["empire"]->army->data["carriers"])."]");


for ($i=0;$i<count($CONF_PLANETS);$i++)
{
	$buy_max_planets = $GAME["gameplay_costs"]->getMaxQty($GAME["empire"]->data["credits"],$planets_prices["planet_".$CONF_PLANETS[$i]],CONF_COST_INCREMENT);
	if ($buy_max_planets > CONF_MAX_PLANET_BUY) $buy_max_planets = CONF_MAX_PLANET_BUY;
	$GAME["template"]->setVar("buy_max_planet_".$CONF_PLANETS[$i],$buy_max_planets);
	$GAME["template"]->setVar($CONF_PLANETS[$i]."_planets_buy_label",LANG_BUY." ".$CONF_PLANETS[$i]." ".LANG_PLANETS.": ".$GAME["template"]->formatCredits($planets_prices["planet_".$CONF_PLANETS[$i]],false)." ".LANG_EACH." [".LANG_MAX.": ".$GAME["template"]->formatNumber($buy_max_planets)."]");
	$GAME["template"]->setVar($CONF_PLANETS[$i]."_planets_sell_label",LANG_RELEASE." ".$CONF_PLANETS[$i]." ".LANG_PLANETS." [".LANG_MAX.": ".$GAME["template"]->formatNumber($GAME["empire"]->planets->data[$CONF_PLANETS[$i]."_planets"])."]");
}



print $GAME["template"]->render();

?>