<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:	http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//
require_once("include/init.php");
require_once("include/init_ingame.php");


$re_subject = "";
$content = "";

//////////////////////////////////////////////////////////////////////////////////////////
// Handle requests
//////////////////////////////////////////////////////////////////////////////////////////
if (isset($_POST["subject"]))
{
	$subject = $GAME["system"]->filterText($_POST["subject"],255);
	$recipient = $_POST["recipient"];
	$content = $GAME["system"]->filterText($_POST["content"],4096);

	if ($recipient == -2) {
		if (!$GAME["empire"]->coalition->isMember()) {
			
			$GAME["system"]->redirect("messages.php",array("WARNING"=>LANG_YOU_NEED_TO_BE_IN_A_COALITION));
			
		}
	}
	
	if ($subject == "") { 
			$GAME["system"]->redirect("messages.php",array("WARNING"=>LANG_EMPTY_MESSAGE_SUBJECT));
	}

	if ($content == "") { 
			$GAME["system"]->redirect("messages.php",array("WARNING"=>LANG_EMPTY_MESSAGE_CONTENT));		
	}
		
	if ($recipient == -1) $subject = "*".strtoupper(LANG_PUBLIC)."* ".$subject;
	if ($recipient == -2) $subject = "*".strtoupper(LANG_COALITION)."* ".$subject;
		
	if ($recipient != -3)  {			
		$query = "SELECT * FROM tb_empire WHERE active = 1"; //  AND NOT id = ".$GAME["empire"]->data <- BUGGY
		$rs = $DB->Execute($query);
		while(!$rs->EOF)
		{
			if (($rs->fields["id"] == $recipient) || ($recipient == -1))
			{
				$content = str_replace("\n","<br/>",$content);

				$evt = new EventCreator($DB);
				$evt->type = CONF_EVENT_MESSAGE;
				$evt->from = $_SESSION["empire_id"];
				$evt->to = $rs->fields["id"];
				$evt->params = array("subject"=>addslashes($subject),"content"=>addslashes($content));
				$evt->send();
								
			}

			if ($recipient == -2)
			{
					$rs2 = $DB->Execute("SELECT coalition FROM tb_member WHERE empire=".$rs->fields["id"]);
					if ((!$rs2->EOF) && ($rs2->fields["coalition"] == $GAME["empire"]->coalition->data["id"]))
					{
							$evt = new EventCreator($DB);
							$evt->type = CONF_EVENT_MESSAGE;
							$evt->from = $_SESSION["empire_id"];
							$evt->to = $rs->fields["id"];
							$evt->params = array("subject"=>addslashes($subject),"content"=>addslashes($content));
							$evt->send();
					}
					
			}


			$rs->MoveNext();
		}

		$GAME["system"]->redirect("messages.php",array("NOTICE"=>LANG_MESSAGE_SUCCESSFULLY_SENT));		
		
	}
	$content = "";
		
}

$use_recipient = -1;
	
if (isset($_GET["id"])) {

$rs = $DB->Execute("SELECT * FROM tb_event WHERE id=".addslashes($_GET["id"]));
if ($rs->EOF) die("Fatal error, invalid id");
$params = unserialize($rs->fields["params"]);
$use_recipient = $rs->fields["event_from"];

$re_subject = "RE: ".stripslashes($params["subject"]);
$content = stripslashes($params["content"]);
$content = str_replace("<br/>","\r\n",$content);
$content_array = explode("\r\n",$content);
$content = "";
for ($i=0;$i<count($content_array);$i++)
	$content .= "// ".$content_array[$i];	
}

//////////////////////////////////////////////////////////////////////////////////////////
// Display page
//////////////////////////////////////////////////////////////////////////////////////////

$GAME["template"]->setPage("messages.html");
$GAME["template"]->setVar("msg_re_subject",$re_subject);
$GAME["template"]->setVar("msg_content",$content);


/* Populating empires/recipients */
$recipients = array();

$query = "SELECT * FROM tb_empire WHERE active = 1 ORDER BY emperor ASC";
$rs = $DB->Execute($query);
while (!$rs->EOF)
{
	$recipient = array();
	$recipient["id"] = $rs->fields["id"];
	$recipient["selected"] = "";
	
	 if ($rs->fields["id"] == $use_recipient) $recipient["selected"] = "selected";
	
	$recipient["name"] = $GAME["template"]->displayEmpire($rs->fields["emperor"],$rs->fields["name"],$GAME["empire"]->data["networth"]);

	$rs2 = $DB->Execute("SELECT tb_coalition.name FROM tb_member,tb_coalition WHERE tb_member.empire=".$rs->fields["id"]." AND tb_member.coalition = tb_coalition.id");
	if (!$rs2->EOF) $recipient["name"] .= " [".$rs2->fields["name"]."]";

	$recipients[] = $recipient;
	$rs->MoveNext();
}

$GAME["template"]->setLoop("recipients",$recipients);



$rs = $DB->Execute("SELECT * FROM tb_event WHERE event_type=".CONF_EVENT_MESSAGE.
" AND event_to=".$_SESSION["empire_id"]." ORDER BY date DESC LIMIT 0,40");
$content = "";
while(!$rs->EOF)
{
	$content .= $GAME["template"]->showMessage($rs->fields)."<br/>";
	$rs->MoveNext();
}

$GAME["template"]->setVar("messages",$content);



print $GAME["template"]->render();

?>