<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

require_once("include/init.php");

if ($GAME["session"]->isActive()) $GAME["empire"]->load($_SESSION["empire_id"]);

$GAME["template"]->setPage("newspaper.html");

$left_content = "";
$center_content = "";
$right_content = "";

srand(time(NULL));

$rs = $DB->Execute("SELECT * FROM tb_news ORDER BY id DESC LIMIT 32");
while(!$rs->EOF)
{
	
	$content = "";
	if ($rs->fields["image"]=="") {
	
		$GAME["template"]->TPL->set_file("newspaper_article","newspaper/article.html");
		$GAME["template"]->TPL->set_var("title",stripslashes($rs->fields["title"]));
		$GAME["template"]->TPL->set_var("text",stripslashes($rs->fields["text"]));
		$content = $GAME["template"]->TPL->process("","newspaper_article",2);
		
	} else {
		
		$GAME["template"]->TPL->set_file("newspaper_article","newspaper/article_with_image.html");
		$GAME["template"]->TPL->set_var("title",stripslashes($rs->fields["title"]));
		$GAME["template"]->TPL->set_var("text",stripslashes($rs->fields["text"]));
		$GAME["template"]->TPL->set_var("image",stripslashes($rs->fields["image"]));
		$content = $GAME["template"]->TPL->process("","newspaper_article",2);
	}
	
	$size_left = strlen($left_content);
	$size_center = strlen($center_content);
	$size_right = strlen($right_content);

	if ($size_left > $size_center) {
		
		if ($size_center > $size_right) {
		
			if ($size_right != 0) $right_content .= "<hr size=\"1\" color=\"#999999\">";
			$right_content .= $content;
		
		} else {
		
			if ($size_right != 0) $center_content .= "<hr size=\"1\" color=\"#999999\">";
			$center_content .= $content;
		
		}
		
	} else {
		if ($size_left > $size_right) {
		
			if ($size_right != 0) $right_content .= "<hr size=\"1\" color=\"#999999\">";
			$right_content .= $content;
		
		} else {
		
			if ($size_right != 0) $left_content .= "<hr size=\"1\" color=\"#999999\">";
			$left_content .= $content;
		
		}
	}
	
	$rs->MoveNext();
}

$GAME["template"]->setVar("left_content",$left_content);
$GAME["template"]->setVar("center_content",$center_content);
$GAME["template"]->setVar("right_content",$right_content);


print $GAME["template"]->render();

?>
