<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//
require_once ("include/init.php");
require_once ("include/init_ingame.php");
require_once ("include/newturn/pirateraid.php");
require_once ("include/newturn/researchgrowth.php");
require_once ("include/newturn/foodgrowth.php");
require_once ("include/newturn/moneygrowth.php");
require_once ("include/newturn/military_production.php");
require_once ("include/newturn/populationgrowth.php");
require_once ("include/newturn/randomevent.php");
require_once ("include/newturn/civilstatus.php");
require_once ("include/newturn/lottery.php");
require_once ("include/newturn/blackmarket.php");
 
/* Updating turns count */

if ($GAME["empire"]->data["turns_left"] == 0) {
	
	$GAME["system"]->redirect("manage.php",array("WARNING"=>LANG_NO_MORE_TURNS_FOR_NOW));
}

$GAME["empire"]->data["turns_left"]--;

if ($GAME["empire"]->data["protection_turns_left"] == 1)
{
	print $GAME["template"]->showNotice(LANG_YOU_ARE_OUT_OF_PROTECTION);
}

if ($GAME["empire"]->data["protection_turns_left"] > 0) 
	$GAME["empire"]->data["protection_turns_left"]--;

$GAME["empire"]->data["turns_played"]++;


/* Updating covert points */

$GAME["empire"]->army->data["covert_points"] += CONF_COVERTPOINTS_PER_TURN;
if ($GAME["empire"]->army->data["covert_points"] > CONF_MAX_COVERTPOINTS) 
	$GAME["empire"]->army->data["covert_points"] = CONF_MAX_COVERTPOINTS;

/* Reset specific values */	
$GAME["empire"]->data["planets_bought"] = 0;
$GAME["empire"]->data["food_traded"] = 0;
$GAME["empire"]->data["already_attacked"] = 0;
$GAME["empire"]->data["last_turn_date"] = time(NULL);


$evt = new EventCreator($DB);
$evt->type = CONF_EVENT_NEWTURN;
$evt->from = -1;
$evt->seen = 1;
$evt->to = $_SESSION["empire_id"];
$evt->params = array("turns_played"=>$GAME["empire"]->data["turns_played"]);
$evt->send();


/* Army effectiveness */
if ($GAME["empire"]->army->data["effectiveness"] != 100)
{
	$GAME["empire"]->army->data["effectiveness"] += CONF_EFFECTIVENESS_GROWTH_PER_TURN;
}

NewTurn_HandlePirateRaid();
NewTurn_HandleResearchGrowth();
NewTurn_HandleFoodGrowth();
NewTurn_HandleMoneyGrowth();
NewTurn_HandleMilitaryProduction();
NewTurn_HandlePopulationGrowth();
NewTurn_PickRandomEvent();
NewTurn_HandleCivilStatus();
NewTurn_HandleLotteryPayout();
NewTurn_handleBlackMarket();


/* Updating empire inflation */
$GAME["empire"]->data["inflation"] += CONF_COST_INFLATION;


// UPDATING production
$production_food_short = $GAME["empire"]->production->data["food_short"];
$production_food_long = $GAME["empire"]->production->data["food_long"];
$production_ore_short = $GAME["empire"]->production->data["ore_short"];
$production_ore_long = $GAME["empire"]->production->data["ore_long"];
$production_tourism_short = $GAME["empire"]->production->data["tourism_short"];
$production_tourism_long = $GAME["empire"]->production->data["tourism_long"];
$production_supply_short = $GAME["empire"]->production->data["supply_short"];
$production_supply_long = $GAME["empire"]->production->data["supply_long"];
$production_edu_short = $GAME["empire"]->production->data["edu_short"];
$production_edu_long = $GAME["empire"]->production->data["edu_long"];
$production_research_short = $GAME["empire"]->production->data["research_short"];
$production_research_long = $GAME["empire"]->production->data["research_long"];
$production_urban_short = $GAME["empire"]->production->data["urban_short"];
$production_urban_long = $GAME["empire"]->production->data["urban_long"];
$production_petro_short = $GAME["empire"]->production->data["petro_short"];
$production_petro_long = $GAME["empire"]->production->data["petro_long"];
$production_antipollu_short = $GAME["empire"]->production->data["antipollu_short"];
$production_antipollu_long = $GAME["empire"]->production->data["antipollu_long"];

$production_food = ($production_food_short - $production_food_long)/10;
$production_ore = ($production_ore_short - $production_ore_long)/10;
$production_tourism = ($production_tourism_short - $production_tourism_long)/10;
$production_supply = ($production_supply_short - $production_supply_long)/10;
$production_edu = ($production_edu_short - $production_edu_long)/10;
$production_research = ($production_research_short - $production_research_long)/10;
$production_urban = ($production_urban_short - $production_urban_long)/10;
$production_petro = ($production_petro_short - $production_petro_long)/10;
$production_antipollu = ($production_antipollu_short - $production_antipollu_long)/10;

$GAME["empire"]->production->data["food_short"] -= $production_food;
$GAME["empire"]->production->data["ore_short"] -= $production_ore;
$GAME["empire"]->production->data["tourism_short"] -= $production_tourism;
$GAME["empire"]->production->data["supply_short"] -= $production_supply;
$GAME["empire"]->production->data["edu_short"] -= $production_edu;
$GAME["empire"]->production->data["research_short"] -= $production_research;
$GAME["empire"]->production->data["urban_short"] -= $production_urban;
$GAME["empire"]->production->data["petro_short"] -= $production_petro;
$GAME["empire"]->production->data["antipollu_short"] -= $production_antipollu;


$GAME["empire"]->updateStats();
$GAME["empire"]->save();


$evt = new EventCreator($DB);
$evt->type = CONF_EVENT_TURNCOMPLETED;
$evt->from = -1;
$evt->seen = 1;
$evt->to = $_SESSION["empire_id"];
$evt->params = array("turns_played"=>$GAME["empire"]->data["turns_played"]);
$evt->send();

$GAME["system"]->handleVictoryConditions();

$GAME["system"]->redirect("lastturn.php");

?>
