<?php
//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2006.09.01 : ybo : Major code changes, OOP
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

require_once("include/init.php");
require_once("include/init_ingame.php");




//////////////////////////////////////////////////////////////////////////////
// handling post/get
//////////////////////////////////////////////////////////////////////////////

if (isset($_GET["DESTROY"]))
{
	$GAME["empire"]->collapse();
	$GAME["empire"]->save();
	$GAME["system"]->redirect("manage.php");
	
}

if (isset($_POST["taxrate"]))
{
	$GAME["empire"]->data["taxrate"] = $_POST["taxrate"];

	$GAME["empire"]->supply->data["rate_soldier"] = round($_POST["rate_soldier"]);
	$GAME["empire"]->supply->data["rate_fighter"] = round($_POST["rate_fighter"]);
	$GAME["empire"]->supply->data["rate_station"] = round($_POST["rate_station"]);
	$GAME["empire"]->supply->data["rate_heavycruiser"] = round($_POST["rate_heavycruiser"]);
	$GAME["empire"]->supply->data["rate_carrier"] = round($_POST["rate_carrier"]);
	$GAME["empire"]->supply->data["rate_covert"] = round($_POST["rate_covert"]);
	$GAME["empire"]->supply->data["rate_general"] = round($_POST["rate_general"]);
	$GAME["empire"]->supply->data["rate_credits"] = round($_POST["rate_credits"]);
	

	if ($GAME["empire"]->supply->data["rate_soldier"] < 0) $GAME["empire"]->supply->data["rate_soldier"] = 0;
	if ($GAME["empire"]->supply->data["rate_fighter"] < 0) $GAME["empire"]->supply->data["rate_fighter"] = 0;
	if ($GAME["empire"]->supply->data["rate_station"] < 0) $GAME["empire"]->supply->data["rate_station"] = 0;
	if ($GAME["empire"]->supply->data["rate_heavycruiser"] < 0) $GAME["empire"]->supply->data["rate_heavycruiser"] = 0;
	if ($GAME["empire"]->supply->data["rate_carrier"] < 0) $GAME["empire"]->supply->data["rate_carrier"] = 0;
	if ($GAME["empire"]->supply->data["rate_covert"] < 0) $GAME["empire"]->supply->data["rate_covert"] = 0;
	if ($GAME["empire"]->supply->data["rate_general"] < 0) $GAME["empire"]->supply->data["rate_general"] = 0;
	if ($GAME["empire"]->supply->data["rate_credits"] < 0) $GAME["empire"]->supply->data["rate_credits"] = 0;

	// if total exceed 100% something is going wrong :)
	if (($GAME["empire"]->supply->data["rate_soldier"] + 
	$GAME["empire"]->supply->data["rate_fighter"] + 
	$GAME["empire"]->supply->data["rate_station"] +
	$GAME["empire"]->supply->data["rate_heavycruiser"] + 
	$GAME["empire"]->supply->data["rate_carrier"] + 
	$GAME["empire"]->supply->data["rate_general"] + 
	$GAME["empire"]->supply->data["rate_credits"] + 
	$GAME["empire"]->supply->data["rate_covert"]) != 100)
	{
		$GAME["system"]->redirect("preferences.php",array("WARNING"=>LANG_INVALID_SUPPLY_NUMBERS));
	}
	
//	if (isset($_POST["draftrate"])) $GAME["empire"]->data["draftrate"] = $_POST["draftrate"];
	if (isset($_POST["biography"])) $GAME["empire"]->data["biography"] = $_POST["biography"];	
	if (isset($_POST["password1"])) {
		
		if ($_POST["password1"] != "") {
			$GAME["empire"]->data["password"] = $_POST["password1"];
			
			if (($_POST["password1"] != "") && ($_POST["password1"] != $_POST["password2"]))
				$GAME["system"]->redirect("preferences.php",array("WARNING"=>LANG_PASSWORDS_DONT_MATCH));
	
		} 
	}	
	
	if (($GAME["empire"]->data["taxrate"] < 0) || ($GAME["empire"]->data["taxrate"] > 100)) 
		$GAME["system"]->redirect("preferences.php",array("WARNING"=>LANG_INVALID_TAXRATE_ENTERED));
	

	$GAME["empire"]->data["taxrate"] += 0;
//	$GAME["empire"]->data["draftrate"] += 0;

	if (isset($_POST["jpeg_quality"])) {
		if ($_POST["jpeg_quality"]==90) 
			$GAME["empire"]->data["jpeg_quality"] = 90;
		else
			$GAME["empire"]->data["jpeg_quality"] = 50;
	}
		
	if (isset($_FILES["emperor_avatar"]))
	{
			 if ($_FILES["emperor_avatar"]["error"] == 0)
			 {
			 		
			 		if (($_FILES["emperor_avatar"]["type"] != "image/pjpeg") && ($_FILES["emperor_avatar"]["type"] != "image/jpeg")) 
			 			$GAME["system"]->redirect("preferences.php",array("WARNING"=>LANG_JPEG_IMAGES_ONLY));
			 	
			 		$im = imagecreatefromjpeg($_FILES["emperor_avatar"]["tmp_name"]);
			 		$im2 = imagecreatetruecolor(140,168);
			 		imagecopyresampled($im2,$im,0,0,0,0,140,168,imagesx($im),imagesy($im));
			 		
			 		imagejpeg($im2,"images/avatars/".$_SESSION["empire_id"].".jpg",100);
			 		imagedestroy($im);
			 }
	}

	if (isset($_POST["emperor_avatar_http"])) {
		
		$http = $_POST["emperor_avatar_http"];
		
		$http = str_replace("..",".",$http);
		if ((substr($http,0,7)=="http://") && (substr($http,strlen($http)-4) == ".jpg")) {
			
			$im = imagecreatefromjpeg($http);
			$im2 = imagecreatetruecolor(140,168);
			imagecopyresampled($im2,$im,0,0,0,0,140,168,imagesx($im),imagesy($im));
			 		
			imagejpeg($im2,"images/avatars/".$_SESSION["empire_id"].".jpg",100);
			imagedestroy($im);
			
		}
		
	}

	$GAME["empire"]->save();
	
	$GAME["system"]->redirect("preferences.php",array("NOTICE"=>LANG_PREFS_SAVED));
}


//////////////////////////////////////////////////////////////////////////////
// show page
//////////////////////////////////////////////////////////////////////////////

$GAME["template"]->setPage("preferences.html");

//$GAME["template"]->setVar("draftrate",$GAME["empire"]->data["draftrate"]);
$GAME["template"]->setVar("taxrate",$GAME["empire"]->data["taxrate"]);
$GAME["template"]->setVar("biography",stripslashes($GAME["empire"]->data["biography"]));

$supply = $DB->Execute("SELECT * FROM tb_supply WHERE empire=".$GAME["empire"]->data["id"]);
$supply = $supply->fields;

if (file_exists("images/avatars/".$GAME["empire"]->data["id"].".jpg"))
	$GAME["template"]->setVar("img_avatar",$GAME["empire"]->data["id"].".jpg?=".time(NULL));
else
	$GAME["template"]->setVar("img_avatar","anonymous.jpg");
		

$GAME["template"]->setVar("rate_soldier",$supply["rate_soldier"]);
$GAME["template"]->setVar("rate_fighter",$supply["rate_fighter"]);
$GAME["template"]->setVar("rate_covert",$supply["rate_covert"]);
$GAME["template"]->setVar("rate_general",$supply["rate_general"]);
$GAME["template"]->setVar("rate_station",$supply["rate_station"]);
$GAME["template"]->setVar("rate_heavycruiser",$supply["rate_heavycruiser"]);
$GAME["template"]->setVar("rate_carrier",$supply["rate_carrier"]);
$GAME["template"]->setVar("rate_credits",$supply["rate_credits"]);

if ($GAME["empire"]->data["jpeg_quality"]==90) {
	$GAME["template"]->setVar("dialup_selected","");
	$GAME["template"]->setVar("broadband_selected","selected");
} else {
	$GAME["template"]->setVar("dialup_selected","selected");
	$GAME["template"]->setVar("broadband_selected","");
}

$planets = $GAME["empire"]->planets->data;
	

$production  = $planets["supply_planets"];
$production =  round(($production/100)*$GAME["empire"]->production->data["supply_short"]);
$production += rand(0,$production/16);
$production /= 100;

$psoldiers = $GAME["system"]->alterNumber(floor($supply["rate_soldier"] * $production * CONF_MILITARY_PRODUCTION_SOLDIER),5);
$pfighters = $GAME["system"]->alterNumber(floor($supply["rate_fighter"] * $production * CONF_MILITARY_PRODUCTION_FIGHTER),5);
$pstations = $GAME["system"]->alterNumber(floor($supply["rate_station"] * $production * CONF_MILITARY_PRODUCTION_STATION),5);
$pcredits = $GAME["system"]->alterNumber(floor($supply["rate_credits"] * $production * CONF_MILITARY_PRODUCTION_CREDITS),5);

$plightcruisers = $planets["research_planets"] *  CONF_RESEARCH_LIGHTCRUISER;
$plightcruisers += rand(0,$plightcruisers/16);
$plightcruisers = $GAME["system"]->alterNumber($plightcruisers,5);

$pheavycruisers = $GAME["system"]->alterNumber(floor($supply["rate_heavycruiser"] * $production * CONF_MILITARY_PRODUCTION_HEAVYCRUISER),5);
$pcarriers = $GAME["system"]->alterNumber(floor($supply["rate_carrier"] * $production * CONF_MILITARY_PRODUCTION_CARRIER),5);
$pcovertagents = $GAME["system"]->alterNumber(floor($supply["rate_covert"] * $production * CONF_MILITARY_PRODUCTION_COVERT),5);
$pgenerals = $GAME["system"]->alterNumber(floor($supply["rate_general"] * $production * CONF_MILITARY_PRODUCTION_GENERAL),5);

$GAME["template"]->setVar("prod_soldier",$GAME["template"]->formatNumber($psoldiers));
$GAME["template"]->setVar("prod_fighter",$GAME["template"]->formatNumber($pfighters));
$GAME["template"]->setVar("prod_station",$GAME["template"]->formatNumber($pstations));
$GAME["template"]->setVar("prod_heavycruiser",$GAME["template"]->formatNumber($pheavycruisers));
$GAME["template"]->setVar("prod_covert",$GAME["template"]->formatNumber($pcovertagents));
$GAME["template"]->setVar("prod_general",$GAME["template"]->formatNumber($pgenerals));
$GAME["template"]->setVar("prod_carrier",$GAME["template"]->formatNumber($pcarriers));
$GAME["template"]->setVar("prod_credits",$GAME["template"]->formatCredits($pcredits));
	

print $GAME["template"]->render();



?>