<?php
//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2006.09.01 : ybo : Major code changes, OOP
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//
require_once("include/init.php");

if ($GAME["template"]->coord["game_status"]==1) {
	$GAME["system"]->redirect("hall_of_fame.php");
}


// complete signup
if (isset($_GET["finish"]))
{
	if (!isset($_SESSION["register"])) 
		die("Fatal Error: Lost precious session data, retry validation or contact administrator");

	if (CONF_GAMETYPE_PREMIUM_ONLY)
	{
		$rs = $DB->Execute("SELECT * FROM premium_members WHERE email='".addslashes($_SESSION["register"]["email"])."'");
		if ($rs->EOF) die("< ahref=\"".CONF_PREMIUM_SIGNUP_URL."\">".LANG_THIS_GAME_IS_FOR_PREMIUM_MEMBERS_ONLY."</a>");
	}
	
	$rs = $DB->Execute("SELECT COUNT(*) FROM tb_empire WHERE active < 2");
	$playerscount = $rs->fields[0];

	if ($playerscount >= CONF_MAXPLAYERS)
	{
		$GAME["system"]->redirect("register.php",array("WARNING"=>LANG_PLAYER_LIMIT_REACHED));
		
	}

	$rs = $DB->Execute("SELECT * FROM tb_empire WHERE email='".$_SESSION["register"]["email"]."'");
	if (!$rs->EOF)	{
		$GAME["system"]->redirect("register.php",array("WARNING"=>LANG_ERROR_EMAIL_ALREADY_REGISTERED));
		
	}

	$rs = $DB->Execute("SELECT * FROM tb_empire WHERE email='".$_SESSION["register"]["emperor"]."'");
	if (!$rs->EOF)	{
		$GAME["system"]->redirect("register.php",array("WARNING"=>LANG_ERROR_EMPEROR_NAME_ALREADY_REGISTERED));
		
	}

	$rs = $DB->Execute("SELECT * FROM tb_empire WHERE name='".$_SESSION["register"]["empire"]."'");
	if (!$rs->EOF)	{
		$GAME["system"]->redirect("register.php",array("WARNING"=>LANG_ERROR_EMPEROR_NAME_ALREADY_REGISTERED));
		
	}

	$activation_hash = md5(time(NULL).$_SESSION["register"]["email"]);

	if (CONF_ACTIVATION_REQUIRED) {
		$GAME["system"]->sendActivationEmail($_SESSION["register"]["email"],$activation_hash);
	}

	$admin = 0;
	if ($playerscount == 0) $admin = 1;
	
	
	srand(time(NULL));
	

	do {
		$x = -950+rand(0,1900);
		$y = -950+rand(0,1900);
		$rs = $DB->Execute("SELECT * FROM tb_empire WHERE (x>=".($x-50)." AND x<=".($x+50).") AND (y>=".($y-50)." AND y<=".($y+50).")");
	
	} while(!$rs->EOF);
	
	$default_logo = array();
	$default_logo[] = "8888888998888888858888899888885888228888888822888828858888588288888858888885888888858883388858888888883443888888998883444438889999888344443888998888883443888888888588833888588888885888888588888828858888588288882288888888228885888889988888588888888998888888";
	$default_logo[] = "5333400330043335353488833888435333548883388845333445400330045443488454033045488408804543345408800880045335400880333333355333333333333335533333330880045335400880088045433454088048845403304548843445400330045443335488833888453335348883388843535333400330043335";
	$default_logo[] = "9888500440058889898533344333589888953334433359888559500440059558533595044059533503305954459503300330059449500330444444499444444444444449944444440330059449500330033059544595033053359504405953358559500440059558889533344333598889853334433358989888500440058889";
	$default_logo[] = "2982672332762892929826722762892989298267762892982892982662892982628929822892982676289298892982672762892992982672327628922982672332762892298267232762892992982672762892988929826762892982289298262892982662892982892982677628929892982672276289292982672332762892";
	$default_logo[] = "1399994444999931313999944999931393138884488831379931355445531377998313244231387799853134431358774985231441325874444444411444444444444441144444444985231441325894998531344313589999831324423138999931355445531399931388844888313931399994499993131399994444999931";
	$default_logo[] = "2333333333333332324444444444442334255555555552433452777777772543345726666662754334576288882675433457682992867543345768922986754334576892298675433457682992867543345762888826754334572666666275433452777777772543342555555555524332444444444444232333333333333332";

	$default_logo = $default_logo[rand(0,count($default_logo)-1)];
	
	if (!isset($_SESSION["register"]["gender"])) $_SESSION["register"]["gender"] = "M";

	$query = "INSERT INTO tb_empire (
	email,
	emperor,
	name,
	gender,
	logo,
	password,
	biography,
	active,
	admin,
	activation_hash,
	date,
	last_turn_date,
	turns_left,
	protection_turns_left,
	credits,
	last_credits,
	population,
	food,
	x,y) 
	VALUES(
	'".addslashes($_SESSION["register"]["email"])."',
	'".addslashes($_SESSION["register"]["emperor"])."',
	'".addslashes($_SESSION["register"]["empire"])."',
	'".addslashes($_SESSION["register"]["gender"])."',
	'$default_logo',
	'".md5($_SESSION["register"]["password"])."',
	'".addslashes($_SESSION["register"]["biography"])."',
	".(CONF_ACTIVATION_REQUIRED?"0":"1").",$admin,
	'".$activation_hash."',
	".time(NULL).",
	".time(NULL).",
	".CONF_TURNS_PER_DAY.",
	".CONF_PROTECTION_TURNS.",
	".CONF_START_CREDITS.",
	".CONF_START_CREDITS.",
	".CONF_START_POPULATION.",
	".CONF_START_FOOD.",$x,$y
	);";
	
	$DB->Execute($query);
	
	
	$query = "SELECT id FROM tb_empire WHERE email = '".addslashes($_SESSION["register"]["email"])."'";
	$rs = $DB->Execute($query);
	
	$id = $rs->fields["id"];

	$query = "INSERT INTO tb_production (empire) values($id)";
	$DB->Execute($query);

	$query = "INSERT INTO tb_supply (empire, rate_soldier) values($id,100);";
	$DB->Execute($query);

	$query = "INSERT INTO tb_planets (
	empire,
	food_planets,
	ore_planets,
	tourism_planets,
	supply_planets,
	gov_planets,
	edu_planets,
	research_planets,
	urban_planets,
	petro_planets,
	antipollu_planets) 
	VALUES(
	$id,
	".CONF_START_FOOD_PLANETS.",
	".CONF_START_ORE_PLANETS.",
	".CONF_START_TOURISM_PLANETS.",
	".CONF_START_SUPPLY_PLANETS.",
	".CONF_START_GOV_PLANETS.",
	".CONF_START_EDU_PLANETS.",
	".CONF_START_RESEARCH_PLANETS.",
	".CONF_START_URBAN_PLANETS.",
	".CONF_START_PETRO_PLANETS.",
	".CONF_START_ANTIPOLLU_PLANETS."
	);";

	$DB->Execute($query);

	$query = "INSERT INTO tb_army (empire,soldiers,fighters,generals,stations) 
	VALUES($id,".CONF_START_SOLDIERS.",".CONF_START_FIGHTERS.",".CONF_START_GENERALS.",".CONF_START_STATIONS.");";
	$DB->Execute($query);
	

	$evt = new EventCreator($DB);
	$evt->type = CONF_EVENT_NEWEMPIRE;
	$evt->from = $id;
	$evt->params = array("empire_emperor"=>$_SESSION["register"]["emperor"],"empire_name"=>$_SESSION["register"]["empire"],"gender"=>$_SESSION["register"]["gender"]);
	$evt->broadcast();
	
	$news = new NewsCreator($DB);
	$news_data = $NEWS_DATA["new_empire"];
	$news_data = $news_data[rand(0,count($news_data)-1)];
	
	$news->title = $news_data["title"];
	$news->text = $news_data["text"];
	$news->text = str_replace("{empire}",$_SESSION["register"]["empire"],$news->text);
	$news->text = str_replace("{emperor}",$_SESSION["register"]["emperor"],$news->text);
	$news->text = str_replace("{gender}",$_SESSION["register"]["gender"]=="M"?LANG_EMPEROR:LANG_EMPRESS,$news->text);
	$news->image = $news_data["image"];
	$news->send();
	

	if (CONF_ACTIVATION_REQUIRED) 
		$GAME["template"]->setPage("register_finished_activation_required.html");
	else
		$GAME["template"]->setPage("register_finished.html");
		
	die($GAME["template"]->render());
}

// normal signup page

$GAME["template"]->setPage("register_template.html");

$email = "";
$emperor = "";
$empire = "";
$password1 = "";
$password2 = "";
$biography = "";
$gender = "M";

if (isset($_POST["email"])) $email = $GAME["system"]->filterText($_POST["email"],125);
if (isset($_POST["emperor"])) $emperor = $GAME["system"]->filterText($_POST["emperor"],35);
if (isset($_POST["empire"])) $empire = $GAME["system"]->filterText($_POST["empire"],35);
if (isset($_POST["password1"])) $password1 = $GAME["system"]->filterText($_POST["password1"],15);
if (isset($_POST["password2"])) $password2 = $GAME["system"]->filterText($_POST["password2"],15);
if (isset($_POST["biography"])) $biography = $GAME["system"]->filterText($_POST["biography"],512);
if (isset($_POST["gender"])) $gender = $GAME["system"]->filterText($_POST["gender"],1);

if ($email == "") {
	
	$GAME["system"]->redirect("register.php",array("WARNING"=>LANG_INVALID_EMAIL_ADDRESS));
	
}

if ($empire == "") {
	
	$GAME["system"]->redirect("register.php",array("WARNING"=>LANG_INVALID_EMPIRE_NAME));
	
}


if ($emperor == "") {
	
	$GAME["system"]->redirect("register.php",array("WARNING"=>LANG_INVALID_EMPIRE_NAME));
	
}

if (($password1 == "") || ($password1 != $password2)) {
	
	$GAME["system"]->redirect("register.php",array("WARNING"=>LANG_INVALID_USERNAME_PASSWORD_COMBINATION));
	
}

$GAME["template"]->setVar("email",stripslashes($email));
$GAME["template"]->setVar("emperor",stripslashes($emperor));
$GAME["template"]->setVar("empire",stripslashes($empire));
$GAME["template"]->setVar("gender",($gender=="M"?LANG_EMPEROR:LANG_EMPRESS));
$GAME["template"]->setVar("biography",stripslashes($biography));

$_SESSION["register"] = array();
$_SESSION["register"]["email"] = $email;
$_SESSION["register"]["empire"] = $empire;
$_SESSION["register"]["emperor"] = $emperor;
$_SESSION["register"]["password"] = $password1;
$_SESSION["register"]["biography"] = $biography;
$_SESSION["register"]["gender"] = $gender;

print $GAME["template"]->render();

?>
