<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
//
//---------------------------------------------------------------------------//
require_once("include/init.php");
require_once("include/init_ingame.php");
// 2007.02.04 : ybo : Reviewed the code for public release

//////////////////////////////////////////////////////////////////////////////
// Handle requests
//////////////////////////////////////////////////////////////////////////////
if (isset($_GET["current"])) {
	
	if ($_GET["current"] == -1)
	{
		
		$GAME["empire"]->data["research_points"] = 0;
		$GAME["empire"]->data["research_tech_id"] = -1;
		$GAME["empire"]->save();
	
		$GAME["system"]->redirect("research.php",array("NOTICE"=>LANG_CURRENT_RESEARCH_CHANGED));
	}

	$tech_data = $GAME["empire"]->research->getTechFromId($_GET["current"]);

	if ($GAME["empire"]->data["research_level"] < $tech_data["level"])
	{
			
		$GAME["empire"]->data["research_points"] = 0;
		$GAME["empire"]->data["research_tech_id"] = -1;
		$GAME["empire"]->save();
	
		$GAME["system"]->redirect("research.php",array("NOTICE"=>LANG_CURRENT_RESEARCH_CHANGED));
	
	}

	if ($tech_data == null) $GAME["system"]->redirect("research.php",array("WARNING"=>LANG_INVALID_RESEARCH_ID));
	
	if (in_array($_GET["current"],$GAME["empire"]->research->tech_done))
		$GAME["system"]->redirect("research.php",array("WARNING"=>LANG_RESEARCH_ALREADY_DONE));


	// test for prerequises
	$rs = $DB->Execute("SELECT * FROM tb_research_tech WHERE id=".addslashes($_GET["current"]));

	$target = explode("_",$rs->fields["target"]);
	if ($target[1] == "level") {
		$current_level = $GAME["empire"]->army->data[$rs->fields["target"]];
		if (($rs->fields["value"] - $current_level) != 1) {
			$GAME["system"]->redirect("research.php",array("WARNING"=>LANG_YOU_NEED_TO_COMPLETE_PREVIOUS_UNIT_LEVEL_BEFORE));
		}
	}

	$GAME["empire"]->data["research_points"] = 0;
	$GAME["empire"]->data["research_tech_id"] = $_GET["current"];
	$GAME["empire"]->save();
	
	$GAME["system"]->redirect("research.php",array("NOTICE"=>LANG_CURRENT_RESEARCH_CHANGED));
		
}

//////////////////////////////////////////////////////////////////////////////
// Display page
//////////////////////////////////////////////////////////////////////////////
$GAME["template"]->setPage("research.html");

/* Display current research */
if ($GAME["empire"]->data["research_tech_id"] == -1) {
	$GAME["template"]->setVar("current_research_name",LANG_FUNDAMENTAL_RESEARCH);
	$GAME["template"]->setVar("current_research_description",LANG_FUNDAMENTAL_RESEARCH_DESCRIPTION);
	$maxpoints = ($GAME["empire"]->data["research_level"]+1);
	$maxpoints = $maxpoints * (($maxpoints * $maxpoints) * CONF_RESEARCH_BASECOST);

	$GAME["template"]->setVar("current_research_progress",$GAME["template"]->formatNumber($GAME["empire"]->data["research_points"])." / ".$GAME["template"]->formatNumber($maxpoints));

	$growth = $GAME["empire"]->research->getGrowthPoints($GAME["empire"]->planets->data["research_planets"],$GAME["empire"]->production->data["research_short"]);
	

	if ($growth == 0) {
		$GAME["template"]->setVar("current_research_turns_left","---");
	} else {
		$GAME["template"]->setVar("current_research_turns_left",$GAME["template"]->formatNumber(ceil(($maxpoints-$GAME["empire"]->data["research_points"]) / $growth)));
	}		

	$GAME["template"]->setVar("current_research_image","images/research/fundamental.gif");
} else {
	$tech_data = $GAME["empire"]->research->getTechFromId($GAME["empire"]->data["research_tech_id"]);
	$GAME["template"]->setVar("current_research_name",stripslashes($tech_data["name"]));
	$GAME["template"]->setVar("current_research_description",stripslashes($tech_data["description"]));
	$GAME["template"]->setVar("current_research_image",stripslashes($tech_data["image"]));

	$growth = $GAME["empire"]->research->getGrowthPoints($GAME["empire"]->planets->data["research_planets"],$GAME["empire"]->production->data["research_short"]);
	
	$GAME["template"]->setVar("current_research_turns_left",
		$GAME["template"]->formatNumber(ceil(($tech_data["cost"]-$GAME["empire"]->data["research_points"]) / ($growth>0?$growth:1))));

	$GAME["template"]->setVar("current_research_progress",$GAME["template"]->formatNumber($GAME["empire"]->data["research_points"])." / ".$GAME["template"]->formatNumber($tech_data["cost"]));
	
}

$research_items = "<tr>";

for ($i=0;$i<8;$i++)
{
	
	$tech_data = $GAME["empire"]->research->getLevel($i+1);
	
	$background="images/background/tech_avail.jpg";
	$locked = false;
	if ($GAME["empire"]->data["research_level"] < ($i+1))
	{
		$background="images/background/tech_locked.jpg";
		$locked = true;
	}
	
	$research_items .= "<td width=\"75\" valign=\"top\" background=\"$background\">";
	for ($j=0;$j<5;$j++)
	{
		
		if (((count($tech_data)-1) < $j) || ($locked))
		{
			if ((count($tech_data)-1) < $j) {
				$GAME["template"]->TPL->set_var("research_item_block.image","images/placeholder.gif");
				$GAME["template"]->TPL->set_var("research_item_block.border_size",0);
			}
			else	{
				$GAME["template"]->TPL->set_var("research_item_block.image","images/no_research.jpg");
				$GAME["template"]->TPL->set_var("research_item_block.border_size",1);
			}

			$GAME["template"]->TPL->set_var("research_item_block.research_id","-1");
			$GAME["template"]->TPL->set_var("research_item_block.label","&nbsp;");
		}	
		else
		{
			$GAME["template"]->TPL->set_var("research_item_block.image",$tech_data[$j]["image"]);

			if (in_array($tech_data[$j]["id"],$GAME["empire"]->research->tech_done))
			{
				$GAME["template"]->TPL->set_var("research_item_block.image",str_replace(".","_done.",$tech_data[$j]["image"]));
				$GAME["template"]->TPL->set_var("research_item_block.research_id","-1");
				$GAME["template"]->TPL->set_var("research_item_block.label",LANG_DONE);
			} else {				
				$GAME["template"]->TPL->set_var("research_item_block.research_id",$tech_data[$j]["id"]);
				$GAME["template"]->TPL->set_var("research_item_block.label","<img src=\"images/placeholder.gif\" width=\"48\" height=\"48\" border=\"0\"><br/>");
			}

			$GAME["template"]->TPL->set_var("research_item_block.border_size",1);
	
		}
		$research_items .= $GAME["template"]->TPL->process("","research_item_block",2);
		if ($j!=4)
			$research_items .= "<img src=\"images/placeholder.gif\" height=\"10px\" border=\"0\">";
	}
	
	
	$research_items .= "</td>";
}
$research_items .= "<td background=\"images/background/tech_avail.jpg\" rowpsan=\"4\"><a href=\"research.php?current=-1\"><img style=\"border:1px solid yellow\" src=\"images/research/fundamental2.gif\" width=\"60\" height=\"290\"></a></td>";
$research_items .= "</tr>";
$GAME["template"]->setVar("research_items",$research_items);

print $GAME["template"]->render();

?>