<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//
require_once("include/init.php");


$id = $_GET["id"];

$rs = $DB->Execute("SELECT * FROM tb_empire WHERE id=".addslashes($id));
if ($rs->EOF) die(LANG_INVALID_EMPIRE_ID);

$GAME["template"]->setPage("show_empire.html");

$GAME["template"]->setVar("info_empire",stripslashes($rs->fields["name"]));
$GAME["template"]->setVar("info_emperor",stripslashes($rs->fields["emperor"]));
$GAME["template"]->setVar("info_empire_id",$rs->fields["id"]);
$GAME["template"]->setVar("gender",$rs->fields["gender"]=="M"?LANG_EMPEROR:LANG_EMPRESS);
if ($rs->fields["last_turn_date"] != 0) {
	
$time = time(NULL)-$rs->fields["last_turn_date"];


$lastturn_days = floor($time / (60*60*24));
$time -= ($lastturn_days * (60*60*24));

$lastturn_hours = floor($time / (60*60));
$time -= ($lastturn_hours * (60*60));

$lastturn_minutes = floor($time / 60);
$time -= ($lastturn_minutes*(60));

$lastturn_sec = $time;

$lastturn = "$lastturn_days days, $lastturn_hours hours, $lastturn_minutes min., $lastturn_sec sec";
} else $lastturn = "NEVER PLAYED";
$GAME["template"]->setVar("info_lastturn",$lastturn);
if ($rs->fields["biography"]=="") $rs->fields["biography"] = "No biography";
$GAME["template"]->setVar("info_biography",stripslashes(str_replace("\n","<br>",$rs->fields["biography"])));
$GAME["template"]->setVar("info_id",$rs->fields["id"]);

$GAME["template"]->setVar("info_date",date("h:i:s m/d/Y",$rs->fields["date"]));
$GAME["template"]->setVar("info_networth",$GAME["template"]->formatNumber($rs->fields["networth"]));
$GAME["template"]->setVar("info_population",$GAME["template"]->formatNumber($rs->fields["population"]));
$GAME["template"]->setVar("info_empires_eliminated",$GAME["template"]->formatNumber($rs->fields["empires_eliminated"]));

$rs2 = $DB->Execute("SELECT * FROM tb_planets WHERE empire=".$rs->fields["id"]);
$planets_count = 0;
$planets_count += $rs2->fields["food_planets"];
$planets_count += $rs2->fields["ore_planets"];
$planets_count += $rs2->fields["tourism_planets"];
$planets_count += $rs2->fields["supply_planets"];
$planets_count += $rs2->fields["gov_planets"];
$planets_count += $rs2->fields["edu_planets"];
$planets_count += $rs2->fields["research_planets"];
$planets_count += $rs2->fields["urban_planets"];
$planets_count += $rs2->fields["petro_planets"];
$planets_count += $rs2->fields["antipollu_planets"];

$GAME["template"]->setVar("info_planets",$GAME["template"]->formatNumber($planets_count));
$GAME["template"]->setVar("info_turns",$GAME["template"]->formatNumber($rs->fields["turns_played"]));
$coalition = "None";



$co = $DB->Execute("SELECT tb_coalition.id,tb_coalition.logo FROM tb_coalition,tb_member WHERE tb_member.empire=".$rs->fields["id"]." AND tb_coalition.id = tb_member.coalition");
if (!$co->EOF) {
	$coalition = "<a href=\"show_coalition.php?id=".$co->fields["id"]."\"><img src=\"img_logo.php?data=".$co->fields["logo"]."\" style=\"border-color:yellow\" bordercolor=\"yellow\" border=\"1\"></a>";
}

$GAME["template"]->setVar("info_coalition",$coalition);


$rs2 = $DB->Execute("SELECT * FROM tb_empire ORDER BY networth DESC");
$playerscount = 0;
$rank = 0;
while(!$rs2->EOF)
{
	if ($rs2->fields["id"] == $rs->fields["id"]) $rank = $playerscount+1;
	$playerscount++;
	$rs2->MoveNext();
}


if (file_exists("images/avatars/".$rs->fields["id"].".jpg"))
	$GAME["template"]->setVar("img_avatar",$rs->fields["id"].".jpg?=".time(NULL));
else
	$GAME["template"]->setVar("img_avatar","anonymous.jpg");
		

$GAME["template"]->setVar("info_ranking",$rank);
$GAME["template"]->setVar("info_playerscount",$playerscount);
$GAME["template"]->setvar("info_research",$rs->fields["research_level"]);

print $GAME["template"]->render();


?>
