<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//
require_once("include/init.php");
require_once("include/init_ingame.php");


/* Loading LOANS information */
$loan_amount = 0;
$total_loans = 0;

$query = "SELECT * FROM tb_loan WHERE empire=".$_SESSION["empire_id"];
$rs = $DB->Execute($query);

while (!$rs->EOF)
{
	$loan_amount += $rs->fields["current_credits"];
	$total_loans++;
	$rs->MoveNext();
	
	
}

$query = "SELECT COUNT(*) FROM tb_empire WHERE active=1";
$rs = $DB->Execute($query);
$ccount = floor($rs->fields[0]*5);

$loan_rate = CONF_SOLARBANK_LOAN_BASE_RATE  + ($total_loans*10);

$loan_maxcredits = (CONF_SOLARBANK_LOAN_BASE_AMOUNT + floor(($GAME["template"]->coord["taxcash"] - $loan_amount)/$ccount));
$loan_maxcredits = floor($loan_maxcredits);

/* Loading BONDS information */
$bond_amount = 0;
$total_bonds = 0;

$query = "SELECT * FROM tb_bond WHERE empire=".$GAME["empire"]->data["id"];
$rs = $DB->Execute($query);

while (!$rs->EOF)
{
	$bond_amount += $rs->fields["current_credits"];
	$total_bonds++;
	$rs->MoveNext();
	
	
}

$query = "SELECT COUNT(*) FROM tb_empire WHERE active=1";
$rs = $DB->Execute($query);
$ccount = floor($rs->fields[0]*5);

$bond_rate = CONF_SOLARBANK_BOND_BASE_RATE  - ($total_bonds*0.1);
if ($bond_rate <= 0) $bond_rate = 1;

/////////////////////////////////////////////////////
// Handle requests
/////////////////////////////////////////////////////


if (isset($_GET["takeloan"]))
{
	$credits = round($_POST["credits"]);
	$turns = 0;
	if (isset($_POST["turns"])) $turns = round($_POST["turns"]);
	
	if (($credits < 1) || ($credits > $loan_maxcredits))
	{
		$GAME["system"]->redirect("solarbank.php",array("WARNING"=>LANG_INVALID_CREDITS_AMOUNT));
	
	} else 
	if (($turns < 1) || ($turns > CONF_SOLARBANK_LOAN_MAXTURNS))
	{
		$GAME["system"]->redirect("solarbank.php",array("WARNING"=>LANG_INVALID_NUMBER_OF_TURNS));
	} else 
	if ($total_loans >= CONF_SOLARBANK_LOAN_MAXLOANS)
	{
		$GAME["system"]->redirect("solarbank.php",array("WARNING"=>LANG_TOO_MANY_ACTIVE_LOANS));
	} else {
		// take the loan
		$GAME["empire"]->data["credits"] += $credits;
		$GAME["empire"]->save();
		
		$query = "INSERT INTO tb_loan (empire,initial_credits,current_credits,total_turns,turns_left,rate,date) VALUES(".$_SESSION["empire_id"].",$credits,$credits,$turns,$turns,$loan_rate,".time(NULL).");";
		$DB->Execute($query);
		
		$notice = LANG_CREDITS_LOANED_AT_A_RATE;
		$notice = str_replace("{percent}",$loan_rate,$notice);
		$notice = str_replace("{credits}",$GAME["template"]->formatCredits($credits),$notice);

		$GAME["system"]->redirect("solarbank.php",array("NOTICE"=>$notice));		
		
	}

}



if (isset($_GET["takebond"]))
{
	$credits = round($_POST["credits"]);
	$turns = CONF_SOLARBANK_BOND_MAXTURNS;
	
	if (($credits < 1) || ($credits > $GAME["empire"]->data["credits"]))
	{
		$GAME["system"]->redirect("solarbank.php",array("WARNING"=>LANG_INVALID_CREDITS_AMOUNT));
	
	} else 
	if ($total_bonds >= CONF_SOLARBANK_BOND_MAXBONDS)
	{
		$GAME["system"]->redirect("solarbank.php",array("WARNING"=>LANG_TOO_MANY_ACTIVE_BONDS));
	} else {
		// take the bond
		$GAME["empire"]->data["credits"] -= $credits;
		$GAME["empire"]->save();
		
		$query = "INSERT INTO tb_bond (empire,initial_credits,current_credits,total_turns,turns_left,rate,date) VALUES(".$_SESSION["empire_id"].",$credits,$credits,$turns,$turns,$bond_rate,".time(NULL).");";
		$DB->Execute($query);
		
		$notice = LANG_CREDITS_INVESTED_AT_A_RATE;
		$notice = str_replace("{percent}",$loan_rate,$notice);
		$notice = str_replace("{credits}",$GAME["template"]->formatCredits($credits),$notice);
		$notice = str_replace("{turns}",CONF_SOLARBANK_BOND_MAXTURNS,$notice);

		$GAME["system"]->redirect("solarbank.php",array("NOTICE"=>$notice));		
		
	}

}



/////////////////////////////////////////////////////
// Display page
/////////////////////////////////////////////////////



$GAME["template"]->setPage("solarbank.html");

// LOANS
$GAME["template"]->setVar("solarbank_loan_rate",$loan_rate);
$GAME["template"]->setVar("solarbank_loan_loans",(CONF_SOLARBANK_LOAN_MAXLOANS-$total_loans));
$GAME["template"]->setVar("solarbank_loan_credits",$GAME["template"]->formatCredits($loan_maxcredits));
$GAME["template"]->setVar("solarbank_loan_amount",$GAME["template"]->formatCredits($loan_amount));
$GAME["template"]->setVar("solarbank_loan_maxturns",CONF_SOLARBANK_LOAN_MAXTURNS);


$loans = array();
$query = "SELECT * FROM tb_loan WHERE empire=".$_SESSION["empire_id"];
$rs = $DB->Execute($query);

while (!$rs->EOF)
{
	$rs->fields["current_credits"] = $GAME["template"]->formatCredits($rs->fields["current_credits"]);
	$rs->fields["initial_credits"] = $GAME["template"]->formatCredits($rs->fields["initial_credits"]);
	$loans[] = $rs->fields;
	$rs->MoveNext();
	
}

$GAME["template"]->setLoop("loans",$loans);

// GALACTIC BONDS
$GAME["template"]->setVar("solarbank_bond_rate",$bond_rate);
$GAME["template"]->setVar("solarbank_bond_bonds",(CONF_SOLARBANK_BOND_MAXBONDS-$total_bonds));
$GAME["template"]->setVar("solarbank_bond_credits",$GAME["template"]->formatCredits($GAME["empire"]->data["credits"]));
$GAME["template"]->setVar("solarbank_bond_amount",$GAME["template"]->formatCredits($bond_amount));
$GAME["template"]->setVar("solarbank_bond_turns",CONF_SOLARBANK_BOND_MAXTURNS);

$bonds = array();
$query = "SELECT * FROM tb_bond WHERE empire=".$_SESSION["empire_id"];
$rs = $DB->Execute($query);
while (!$rs->EOF)
{
	$rs->fields["current_credits"] = $GAME["template"]->formatCredits($rs->fields["current_credits"]);
	$rs->fields["initial_credits"] = $GAME["template"]->formatCredits($rs->fields["initial_credits"]);
	$bonds[] = $rs->fields;
	$rs->MoveNext();
	
}

$GAME["template"]->setLoop("bonds",$bonds);

print $GAME["template"]->render();

?>
