<?php

//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
// 2007.02.22 : ybo : Adding GSIV feature (draggable map a-la-google)
// 2007.03.01 : ybo : Removed GSIV and replaced it with my own implementation (javascript)
//
//---------------------------------------------------------------------------//

require_once("include/init.php");
require_once("include/init_ingame.php");


////////////////////////////////////////////////////////////////////////////////////
// Display page
////////////////////////////////////////////////////////////////////////////////////
$GAME["template"]->setPage("starmap.html");

$empires_data = array();

$rs = $DB->Execute("SELECT SUM(networth) FROM tb_empire WHERE active=1 AND admin=0");
$total_networth = $rs->fields[0];

$rs = $DB->Execute("SELECT * FROM tb_empire WHERE active=1 AND admin=0");
while(!$rs->EOF) {

	$data = array();
	$data["empire"] = $rs->fields["name"];
	$data["emperor"] = $rs->fields["emperor"];
	$data["x"] = $rs->fields["x"];
	$data["y"] = $rs->fields["y"];
	$data["radius"] = floor(($rs->fields["networth"] / $total_networth)*200);
	$data["networth"] = $GAME["template"]->formatNumber($rs->fields["networth"]);
	$data["population"] = $GAME["template"]->formatNumber($rs->fields["population"]);
	$data["img"] = "images/empires/".$rs->fields["id"].".jpg";
	$data["separator"] = ",";
	$empires_data[] = $data;
	$rs->MoveNext();
}

if (count($empires_data) != 0) {
	$empires_data[count($empires_data)-1]["separator"] = "";
}


$GAME["template"]->setLoop("empires_data",$empires_data);

// lines
$lines_data = array();

$rs = $DB->Execute("SELECT * FROM tb_armyconvoy");
while(!$rs->EOF) {

	$data = array();
	
	$data["separator"] = ",";
	
	$rs2 = $DB->Execute("SELECT x,y FROM tb_empire WHERE id=".$rs->fields["empire_from"]);
	$rs3 = $DB->Execute("SELECT x,y FROM tb_empire WHERE id=".$rs->fields["empire_to"]);
		
	
	
	$percent = ($rs->fields["time_total"]-$rs->fields["time_left"]) / $rs->fields["time_total"];
	$percent *= 100;
	
	if ($rs->fields["convoy_type"] < 2) {
		$data["start_x"] = $rs2->fields["x"];
		$data["start_y"] = $rs2->fields["y"];
		$data["end_x"] = $data["start_x"] + floor((($rs3->fields["x"]-$rs2->fields["x"])/100)*$percent);
		$data["end_y"] = $data["start_y"] + floor((($rs3->fields["y"]-$rs2->fields["y"])/100)*$percent);
	} else {
		$data["start_x"] = $rs3->fields["x"];
		$data["start_y"] = $rs3->fields["y"];
		$data["end_x"] = $data["start_x"] + floor((($rs2->fields["x"]-$rs3->fields["x"])/100)*$percent);
		$data["end_y"] = $data["start_y"] + floor((($rs2->fields["y"]-$rs3->fields["y"])/100)*$percent);
	}


	if ($rs->fields["empire_from"] == $rs->fields["empire_to"]) 
		$data["color"] = "blue";
		else {

		if ($rs->fields["convoy_type"] == CONF_CONVOY_INVASION) $data["color"] = "#ff3333";
		if ($rs->fields["convoy_type"] == CONF_CONVOY_DEFENSE) $data["color"] = "#33ff33";
		if ($rs->fields["convoy_type"] == CONF_CONVOY_INVASION_RETREAT) $data["color"] = "#443333";
		if ($rs->fields["convoy_type"] == CONF_CONVOY_DEFENSE_RETREAT) $data["color"] = "#334433";
		
	}
	
	$lines_data[] = $data;
	$rs->MoveNext();
}

// add trades
$rs = $DB->Execute("SELECT * FROM tb_tradeconvoy WHERE empire_from=".$GAME["empire"]->data["id"]." OR empire_to=".$GAME["empire"]->data["id"]);
while(!$rs->EOF)
{

		$rs2 = $DB->Execute("SELECT x,y FROM tb_empire WHERE id=".$rs->fields["empire_from"]);
		$rs3 = $DB->Execute("SELECT x,y FROM tb_empire WHERE id=".$rs->fields["empire_to"]);
		
		
	$percent = ($rs->fields["time_total"]-$rs->fields["time_left"]) / $rs->fields["time_total"];
	$percent *= 100;
	
		$data = array();
		
		$data["start_x"] = $rs2->fields["x"]+5;
		$data["start_y"] = $rs2->fields["y"]+5;
		$data["end_x"] = $data["start_x"] + floor((($rs3->fields["x"]-$rs2->fields["x"])/100)*$percent);
		$data["end_y"] = $data["start_y"] + floor((($rs3->fields["y"]-$rs2->fields["y"])/100)*$percent);
		
		$data["color"] = "orange";
		$data["separator"] = ",";
		$lines_data[] = $data;
	
		$rs->MoveNext();
}

// add diplomacy
 for ($i=0;$i<count($GAME["empire"]->diplomacy->data);$i++) {
 	
 	  $empire_dest = $GAME["empire"]->diplomacy->data[$i]["empire_from"];
 	  if ($empire_dest == $GAME["empire"]->data["id"]) $empire_dest = $GAME["empire"]->diplomacy->data[$i]["empire_to"];

		$rs  = $DB->Execute("SELECT x,y FROM tb_empire WHERE id=".$empire_dest);
		$data = array();
		$data["start_x"] = $rs->fields["x"]-5;
		$data["start_y"] = $rs->fields["y"]-5;
		$data["end_x"] = $GAME["empire"]->data["x"]-5;
		$data["end_y"] = $GAME["empire"]->data["y"]-5;
		$data["color"] = "#3333FF";
		$data["separator"] = ",";
		$lines_data[] = $data;
 	
 }



if (count($lines_data) != 0) {
	$lines_data[count($lines_data)-1]["separator"] = "";
}

$GAME["template"]->setLoop("lines_data",$lines_data);

print $GAME["template"]->render();
?>