<?php


//---------------------------------------------------------------------------//
// author: Yanick Bourbeau <ybourbeau@mrgtech.ca> 
// date:   2006.01.01
// web:    http://www.mrgtech.ca
// info:   Solar Imperium
//---------------------------------------------------------------------------//
// copyleft license
//
// this software is provided 'as-is', without any express or implied
// warranty. in no event will the authors be held liable for any damages
// arising from the use of this software.
//
// permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions: 
//
// 1. the origin of this software must not be misrepresented;
//	  you must not claim that you wrote the original software. 
//	  if you use this software in a product, an acknowledgment 
//	  in the product documentation would be appreciated but is not required.
//
// 2. altered source versions must be plainly marked as such, 
//	  and must not be misrepresented as being the original software.
//
// 3. mail about the fact of using this class in production 
//	  would be very appreciated.
//
// 4. this notice may not be removed or altered from any source distribution.
//
//---------------------------------------------------------------------------//
// CHANGELOG:
//
// 2006.06.01 : ybo : Changed name: Imperium Galactica is (c), moved to Solar Imperium
// 2007.02.04 : ybo : Reviewed the code for public release
//
//---------------------------------------------------------------------------//

require_once ("include/init.php");
require_once ("include/init_ingame.php");

////////////////////////////////////////////////////////////////
// Handle request
////////////////////////////////////////////////////////////////
if (isset ($_POST["empire"])) {


	$rs = $DB->Execute("SELECT COUNT(*) FROM tb_tradeconvoy WHERE empire_from=".$GAME["empire"]->data["id"]);
	if ($rs->fields[0] == CONF_TRADE_MAXCONVOYS) {
		$GAME["system"]->redirect("trade.php",array("WARNING"=>LANG_TOO_MUCH_TRADE_CONVOYS_ACTIVE));
	}
	$trade_money = addslashes($_POST["trade_money"]) + 0;

	$trade_food = addslashes($_POST["trade_food"]) + 0;
	$trade_generals = addslashes($_POST["trade_generals"]) + 0;
	$trade_coverts = addslashes($_POST["trade_coverts"]) + 0;
	$trade_soldiers = addslashes($_POST["trade_soldiers"]) + 0;
	$trade_fighters = addslashes($_POST["trade_fighters"]) + 0;
	$trade_lightcruisers = addslashes($_POST["trade_lightcruisers"]) + 0;
	$trade_heavycruisers = addslashes($_POST["trade_heavycruisers"]) + 0;
	$carriers = 0;

	if (($trade_money > $GAME["empire"]->data["credits"]) || ($trade_money < 0))
		$GAME["empire"]->redirect("trade.php", array (
			"WARNING" => LANG_INVALID_CREDITS_AMOUNT
		));

	$needed_carriers = ceil($trade_money * $units_info["carriers_" .$GAME["empire"]->army->data["carriers_level"]]["cargo_hold"] * CONF_CARRIER_MONEY);
	if ($needed_carriers > $GAME["empire"]->army->data["carriers"]) {
		$GAME["empire"]->redirect("trade.php", array (
			"WARNING" => LANG_INVALID_CREDITS_AMOUNT
		));
	} else
		$carriers += $needed_carriers;

	if (($trade_food > $GAME["empire"]->data["food"]) || ($trade_food < 0))
		$GAME["empire"]->redirect("trade.php", array (
			"WARNING" => LANG_INVALID_FOOD_AMOUNT
		));
	$needed_carriers = ceil($trade_food * $units_info["carriers_" .$GAME["empire"]->army->data["carriers_level"]]["cargo_hold"]* CONF_CARRIER_FOOD);
	if ($needed_carriers > $GAME["empire"]->army->data["carriers"]) {
		$GAME["empire"]->redirect("trade.php", array (
			"WARNING" => LANG_INVALID_FOOD_AMOUNT
		));
	} else
		$carriers += $needed_carriers;

	if (($trade_generals > $GAME["empire"]->army->data["generals"]) || ($trade_generals < 0))
		$GAME["system"]->redirect("trade.php", array (
			"WARNING" => LANG_INVALID_GENERALS_QUANTITY
		));
	$needed_carriers = ceil($trade_generals * $units_info["carriers_" .$GAME["empire"]->army->data["carriers_level"]]["cargo_hold"]* CONF_CARRIER_GENERAL);
	if ($needed_carriers > $GAME["empire"]->army->data["carriers"]) {
		$GAME["system"]->redirect("trade.php", array (
			"WARNING" => LANG_INVALID_GENERALS_QUANTITY
		));
	} else
		$carriers += $needed_carriers;

	if (($trade_coverts > $GAME["empire"]->army->data["covertagents"]) || ($trade_coverts < 0))
		$GAME["system"]->redirect("trade.php", array (
			"WARNING" => LANG_INVALID_COVERTAGENTS_QUANTITY
		));
	$needed_carriers = ceil($trade_coverts * $units_info["carriers_" .$GAME["empire"]->army->data["carriers_level"]]["cargo_hold"]* CONF_CARRIER_COVERT);
	if ($needed_carriers > $GAME["empire"]->army->data["carriers"]) {
		$GAME["system"]->redirect("trade.php", array (
			"WARNING" => LANG_INVALID_COVERTAGENTS_QUANTITY
		));
	} else
		$carriers += $needed_carriers;

	if (($trade_soldiers > $GAME["empire"]->army->data["soldiers"]) || ($trade_soldiers < 0))
		$GAME["system"]->redirect("trade.php", array (
			"WARNING" => LANG_INVALID_SOLDIERS_QUANTITY
		));
	$needed_carriers = ceil($trade_soldiers * $units_info["carriers_" .$GAME["empire"]->army->data["carriers_level"]]["cargo_hold"]* CONF_CARRIER_SOLDIER);
	if ($needed_carriers > $GAME["empire"]->army->data["carriers"]) {
		die(CONF_ShowWarning("Invalid soldier amount"));
	} else
		$carriers += $needed_carriers;

	if (($trade_fighters > $GAME["empire"]->army->data["fighters"]) || ($trade_fighters < 0))
		$GAME["system"]->redirect("trade.php", array (
			"WARNING" => LANG_INVALID_FIGHTERS_QUANTITY
		));
	$needed_carriers = ceil($trade_fighters * $units_info["carriers_" .$GAME["empire"]->army->data["carriers_level"]]["cargo_hold"]* CONF_CARRIER_FIGHTER);
	if ($needed_carriers > $GAME["empire"]->army->data["carriers"]) {
		$GAME["system"]->redirect("trade.php", array (
			"WARNING" => LANG_INVALID_FIGHTERS_QUANTITY
		));
	} else
		$carriers += $needed_carriers;

	if (($trade_lightcruisers > $GAME["empire"]->army->data["lightcruisers"]) || ($trade_lightcruisers < 0))
		$GAME["system"]->redirect("trade.php", array (
			"WARNING" => LANG_INVALID_LIGHTCRUISERS_QUANTITY
		));
	$needed_carriers = ceil($trade_lightcruisers * $units_info["carriers_" .$GAME["empire"]->army->data["carriers_level"]]["cargo_hold"]* CONF_CARRIER_LIGHTCRUISER);
	if ($needed_carriers > $GAME["empire"]->army->data["carriers"]) {
		$GAME["system"]->redirect("trade.php", array (
			"WARNING" => LANG_INVALID_LIGHTCRUISERS_QUANTITY
		));
	} else
		$carriers += $needed_carriers;

	if (($trade_heavycruisers > $GAME["empire"]->army->data["heavycruisers"]) || ($trade_heavycruisers < 0))
		$GAME["system"]->redirect("trade.php", array (
			"WARNING" => LANG_INVALID_HEAVYCRUISERS_QUANTITY
		));
	$needed_carriers = ceil($trade_heavycruisers * $units_info["carriers_" .$GAME["empire"]->army->data["carriers_level"]]["cargo_hold"]* CONF_CARRIER_HEAVYCRUISER);
	if ($needed_carriers > $GAME["empire"]->army->data["carriers"]) {
		$GAME["system"]->redirect("trade.php", array (
			"WARNING" => LANG_INVALID_HEAVYCRUISERS_QUANTITY
		));
	} else
		$carriers += $needed_carriers;

	$carriers = ceil($carriers);

	if ($carriers == 0)
		$GAME["system"]->redirect("trade.php", array (
			"WARNING" => LANG_YOU_CANT_TRADE_THIS_QUANTITY . " (" . LANG_MAX . ":" . $GAME["template"]->formatNumber(CONF_TRADE_MAXCARRIERS
		) . ")"));

	$empire = $_POST["empire"];
	$rs = $DB->Execute("SELECT * FROM tb_empire WHERE admin=0 AND id=" . addslashes($empire));
	if ($rs->EOF)
		$GAME["system"]->redirect("trade.php", array (
			"WARNING" => LANG_INVALID_EMPIRE_ID
		));

	if ($GAME["empire"]->diplomacy->treatyFrom($empire) == null)
		$GAME["system"]->redirect("trade.php", array (
			"WARNING" => LANG_CANT_TRADE_WITH_ENEMY_EMPIRE
		));

	// check if the target is still under protection
	if ($rs->fields["protection_turns_left"] != 0) {
		$GAME["system"]->redirect("trade.php", array (
			"WARNING" => LANG_CANT_TRADE_WITH_PROTECTED_EMPIRE
		));

	}

	$content = "";

	$trade_cost = 0;
	$trade_cost += ($trade_money * CONF_TRADETAX_MONEY);
	$trade_cost += ($trade_food * CONF_TRADETAX_FOOD);
	$trade_cost += ($trade_generals * CONF_TRADETAX_GENERAL);
	$trade_cost += ($trade_coverts * CONF_TRADETAX_COVERT);
	$trade_cost += ($trade_soldiers * CONF_TRADETAX_SOLDIER);
	$trade_cost += ($trade_fighters * CONF_TRADETAX_FIGHTER);
	$trade_cost += ($trade_lightcruisers * CONF_TRADETAX_LIGHTCRUISER);
	$trade_cost += ($trade_heavycruisers * CONF_TRADETAX_HEAVYCRUISER);
	$trade_cost = round(($trade_cost / 100) * CONF_TRADE_TAXRATE);

	if ($trade_cost == 0)
		$GAME["system"]->redirect("trade.php", array (
			"WARNING" => LANG_EMPTY_TRADE_DEAL
		));

	if (($trade_cost + $trade_money) > $GAME["empire"]->data["credits"])
		$GAME["system"]->redirect("trade.php", array (
			"WARNING" => LANG_NO_ENOUGH_CREDITS
		));

	if ($trade_money != 0)
		$content .= LANG_CREDITS . ": " . $GAME["template"]->formatCredits($trade_money) . "\r\n";
	if ($trade_food != 0)
		$content .= LANG_FOOD . ": " . $GAME["template"]->formatFood($trade_food) . "\r\n";
	if ($trade_generals != 0)
		$content .= LANG_GENERALS . ": " . $GAME["template"]->formatNumber($trade_generals) . "\r\n";
	if ($trade_coverts != 0)
		$content .= LANG_COVERTAGENTS . ": " . $GAME["template"]->formatNumber($trade_coverts) . "\r\n";
	if ($trade_soldiers != 0)
		$content .= LANG_SOLDIERS . ": " . $GAME["template"]->formatNumber($trade_soldiers) . "\r\n";
	if ($trade_fighters != 0)
		$content .= LANG_FIGHTERS . ": " . $GAME["template"]->formatNumber($trade_fighters) . "\r\n";
	if ($trade_lightcruisers != 0)
		$content .= LANG_LIGHTCRUISERS . ": " . $GAME["template"]->formatNumber($trade_lightcruisers) . "\r\n";
	if ($trade_heavycruisers != 0)
		$content .= LANG_HEAVYCRUISERS . ": " . $GAME["template"]->formatNumber($trade_heavycruisers) . "\r\n";

	$GAME["empire"]->data["credits"] -= ($trade_cost + $trade_money);
	$GAME["empire"]->data["food"] -= $trade_food;
	$GAME["empire"]->army->data["generals"] -= $trade_generals;
	$GAME["empire"]->army->data["covertagents"] -= $trade_coverts;

	$GAME["empire"]->army->data["soldiers"] -= $trade_soldiers;
	$GAME["empire"]->army->data["fighters"] -= $trade_fighters;
	$GAME["empire"]->army->data["lightcruisers"] -= $trade_lightcruisers;
	$GAME["empire"]->army->data["heavycruisers"] -= $trade_heavycruisers;

	$GAME["empire"]->save();

	$x = abs($GAME["empire"]->data["x"] - $rs->fields["x"]);
	$y = abs($GAME["empire"]->data["y"] - $rs->fields["y"]);

	$time_required = floor(sqrt(($x * $x) + ($y * $y)));
	$time_required = floor($time_required / $units_info["carriers_" . $GAME["empire"]->army->data["carriers_level"]]["speed"]);
	$time_required *= 10;
	$time_required -= ($time_required % 60);

	// SENDING THE CONVOY
	$query = "INSERT INTO tb_tradeconvoy (empire_from,empire_to,trade_money,trade_food,trade_generals,trade_covertagents,trade_soldiers,trade_fighters,trade_lightcruisers,trade_heavycruisers,carriers,time_left,time_total)
		VALUES(" . $GAME["empire"]->data["id"] . ",$empire,$trade_money,$trade_food,$trade_generals,$trade_coverts,$trade_soldiers,$trade_fighters,$trade_lightcruisers,$trade_heavycruisers,$carriers," . $time_required . ",".$time_required.");";
	$DB->Execute($query);

	$GAME["system"]->redirect("trade.php", array (
		"NOTICE" => LANG_TRADE_CONVOY_SENT
	));

}

////////////////////////////////////////////////////////////////////////////////////
// Display page
////////////////////////////////////////////////////////////////////////////////////
$GAME["template"]->setPage("trade.html");

$GAME["template"]->setVar("trade_taxrate", CONF_TRADE_TAXRATE);
$GAME["template"]->setVar("trade_carriers", $GAME["template"]->formatNumber($GAME["empire"]->army->data["carriers"]));

/* Populate empires */
$empires = array ();

for ($i = 0; $i < count($GAME["empire"]->diplomacy->data); $i++) {
	$empire = array ();
	$empire_id = $GAME["empire"]->diplomacy->data[$i]["empire_from"];
	if ($empire_id == $GAME["empire"]->data["id"])
		$empire_id = $GAME["empire"]->diplomacy->data[$i]["empire_to"];

	$empire["id"] = $empire_id;
	$rs = $DB->Execute("SELECT emperor,x,y,name,gender FROM tb_empire WHERE id=" . addslashes($empire_id));

	$x = abs($GAME["empire"]->data["x"] - $rs->fields["x"]);
	$y = abs($GAME["empire"]->data["y"] - $rs->fields["y"]);

	$time_required = floor(sqrt(($x * $x) + ($y * $y)));
	$time_required = floor($time_required / $units_info["carriers_" . $GAME["empire"]->army->data["carriers_level"]]["speed"]);
	$time_required *= 10;
	$time_required -= ($time_required % 60);
	$time_required_str =  round($time_required/3600,3)." ".LANG_HOURS;
	$empire["name"] = $GAME["template"]->displayEmpire($rs->fields["emperor"], $rs->fields["name"], $GAME["empire"]->data["networth"]) . " (Time required: $time_required_str)";

	$empires[] = $empire;

}
$GAME["template"]->setLoop("empires", $empires);

$credits = $GAME["empire"]->data["credits"];
$max_credits = $credits;
$needed_carriers = ceil($max_credits * CONF_CARRIER_MONEY);
if ($needed_carriers > $GAME["empire"]->army->data["carriers"]) {
	$percent = ($GAME["empire"]->army->data["carriers"] / $needed_carriers) * 100;
	$max_credits = floor(($max_credits / 100) * $percent);
}
if ($max_credits < $credits)
	$credits = $max_credits;

$GAME["template"]->setVar("trade_money_max", $GAME["template"]->formatNumber($credits));
$GAME["template"]->setVar("trade_money_max_noformat", $credits);

$food = $GAME["empire"]->data["food"];
$max_food = $food;
$needed_carriers = ceil($max_food * CONF_CARRIER_FOOD);
if ($needed_carriers > $GAME["empire"]->army->data["carriers"]) {
	$percent = ($GAME["empire"]->army->data["carriers"] / $needed_carriers) * 100;
	$max_food = floor(($max_food / 100) * $percent);
}
if ($max_food < $food)
	$food = $max_food;

$GAME["template"]->setVar("trade_food_max", $GAME["template"]->formatNumber($food));
$GAME["template"]->setVar("trade_food_max_noformat", $food);

$generals = $GAME["empire"]->army->data["generals"];
$max_generals = $generals;
$needed_carriers = ceil($max_generals * CONF_CARRIER_GENERAL);
if ($needed_carriers > $GAME["empire"]->army->data["carriers"]) {
	$percent = ($GAME["empire"]->army->data["carriers"] / $needed_carriers) * 100;
	$max_generals = floor(($max_generals / 100) * $percent);
}
if ($max_generals < $generals)
	$generals = $max_generals;

$GAME["template"]->setVar("trade_generals_max", $GAME["template"]->formatNumber($generals));
$GAME["template"]->setVar("trade_generals_max_noformat", $generals);

$coverts = $GAME["empire"]->army->data["covertagents"];
$max_coverts = $coverts;
$needed_carriers = ceil($max_coverts * CONF_CARRIER_COVERT);
if ($needed_carriers > $GAME["empire"]->army->data["carriers"]) {
	$percent = ($GAME["empire"]->army->data["carriers"] / $needed_carriers) * 100;
	$max_coverts = floor(($max_coverts / 100) * $percent);
}
if ($max_coverts < $coverts)
	$coverts = $max_coverts;

$GAME["template"]->setVar("trade_coverts_max", $GAME["template"]->formatNumber($coverts));
$GAME["template"]->setVar("trade_coverts_max_noformat", $coverts);

$soldiers = $GAME["empire"]->army->data["soldiers"];
$max_soldiers = $soldiers;
$needed_carriers = ceil($max_soldiers * CONF_CARRIER_SOLDIER);
if ($needed_carriers > $GAME["empire"]->army->data["carriers"]) {
	$percent = ($GAME["empire"]->army->data["carriers"] / $needed_carriers) * 100;
	$max_soldiers = floor(($max_food / 100) * $percent);
}
if ($max_soldiers < $soldiers)
	$soldiers = $max_soldiers;

$GAME["template"]->setVar("trade_soldiers_max", $GAME["template"]->formatNumber($soldiers));
$GAME["template"]->setVar("trade_soldiers_max_noformat", $soldiers);

$fighters = $GAME["empire"]->army->data["fighters"];
$max_fighters = $fighters;
$needed_carriers = ceil($max_fighters * CONF_CARRIER_FIGHTER);
if ($needed_carriers > $GAME["empire"]->army->data["carriers"]) {
	$percent = ($GAME["empire"]->army->data["carriers"] / $needed_carriers) * 100;
	$max_fighters = floor(($max_fighters / 100) * $percent);
}
if ($max_fighters < $fighters)
	$fighters = $max_fighters;

$GAME["template"]->setVar("trade_fighters_max", $GAME["template"]->formatNumber($fighters));
$GAME["template"]->setVar("trade_fighters_max_noformat", $fighters);

$lightcruisers = $GAME["empire"]->army->data["lightcruisers"];
$max_lightcruisers = $lightcruisers;
$needed_carriers = ceil($max_lightcruisers * CONF_CARRIER_LIGHTCRUISER);
if ($needed_carriers > $GAME["empire"]->army->data["carriers"]) {
	$percent = ($GAME["empire"]->army->data["carriers"] / $needed_carriers) * 100;
	$max_lightcruisers = floor(($max_lightcruisers / 100) * $percent);
}
if ($max_lightcruisers < $lightcruisers)
	$lightcruisers = $max_lightcruisers;

$GAME["template"]->setVar("trade_lightcruisers_max", $GAME["template"]->formatNumber($lightcruisers));
$GAME["template"]->setVar("trade_lightcruisers_max_noformat", $lightcruisers);

$heavycruisers = $GAME["empire"]->army->data["heavycruisers"];
$max_heavycruisers = $heavycruisers;
$needed_carriers = ceil($max_heavycruisers * CONF_CARRIER_HEAVYCRUISER);
if ($needed_carriers > $GAME["empire"]->army->data["carriers"]) {
	$percent = ($GAME["empire"]->army->data["carriers"] / $needed_carriers) * 100;
	$max_heavycruisers = floor(($max_heavycruisers / 100) * $percent);
}
if ($max_heavycruisers < $heavycruisers)
	$heavycruisers = $max_heavycruisers;

$GAME["template"]->setVar("trade_heavycruisers_max", $GAME["template"]->formatNumber($heavycruisers));
$GAME["template"]->setVar("trade_heavycruisers_max_noformat", $heavycruisers);


$active_trades = "";
$rs = $DB->Execute("SELECT * FROM tb_tradeconvoy WHERE empire_from=" . $GAME["empire"]->data["id"] . " OR empire_to=" . $GAME["empire"]->data["id"]);
$count = 0;

while (!$rs->EOF) {
	$rs3 = $DB->Execute("SELECT * FROM tb_empire WHERE id=" . $rs->fields["empire_from"]);
	$rs2 = $DB->Execute("SELECT * FROM tb_empire WHERE id=" . $rs->fields["empire_to"]);
	$orig = $GAME["template"]->displayEmpire($rs3->fields["emperor"], $rs3->fields["name"],$GAME["empire"]->data["networth"]);
	$dest = $GAME["template"]->displayEmpire($rs2->fields["emperor"], $rs2->fields["name"],$GAME["empire"]->data["networth"]);
	$count++;

	$GAME["template"]->TPL->set_file("tradeconvoy", "tradeconvoy.html");

	$GAME["template"]->TPL->set_var("count", $count);
	$GAME["template"]->TPL->set_var("sender", $orig);
	$GAME["template"]->TPL->set_var("destination", $dest);
	$GAME["template"]->TPL->set_var("trade_money", $GAME["template"]->formatCredits($rs->fields["trade_money"]));
	$GAME["template"]->TPL->set_var("trade_food", $GAME["template"]->formatFood($rs->fields["trade_food"]));
	$GAME["template"]->TPL->set_var("trade_generals", $GAME["template"]->formatNumber($rs->fields["trade_generals"]));
	$GAME["template"]->TPL->set_var("trade_covertagents", $GAME["template"]->formatNumber($rs->fields["trade_covertagents"]));
	$GAME["template"]->TPL->set_var("trade_soldiers", $GAME["template"]->formatNumber($rs->fields["trade_soldiers"]));
	$GAME["template"]->TPL->set_var("trade_fighters", $GAME["template"]->formatNumber($rs->fields["trade_fighters"]));
	$GAME["template"]->TPL->set_var("trade_lightcruisers", $GAME["template"]->formatNumber($rs->fields["trade_lightcruisers"]));
	$GAME["template"]->TPL->set_var("trade_heavycruisers", $GAME["template"]->formatNumber($rs->fields["trade_heavycruisers"]));
	$GAME["template"]->TPL->set_var("carriers_used", $GAME["template"]->formatNumber($rs->fields["carriers"]));
	$GAME["template"]->TPL->set_var("time_left", round($rs->fields["time_left"]/3600,3));

	$active_trades .= $GAME["template"]->TPL->process("", "tradeconvoy", 2);
	$rs->MoveNext();
}
if ($active_trades == "")
	$active_trades = LANG_NO_TRADE_PENDING;

$GAME["template"]->setVar("active_trades", $active_trades);

print $GAME["template"]->render();
?> 
